#!/bin/bash

##########################################################

function readconf() {
    while read line; do
        # skip comments
        [[ ${line:0:1} == "#" ]] && continue 
        # skip empty lines
        [[ -z "$line" ]] && continue
        line=`echo $line | awk -F "#" '{print $1}'`
        # echo line=$line
        key=${line//=*}
        value=${line//*=}
        key=$(echo "$key" | sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//')
        value=$(echo "$value" | sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//')
        # echo key=$key 
        # echo value=$value
        export $key="$value"
    done < "$CONFIG"
}

#########################################################

# read in the configuration file

CONFIG=/etc/RS.conf

readconf

echo RESERVATION_SYSTEM_SERVICE_URL: $RESERVATION_SYSTEM_SERVICE_URL
echo RESERVATION_SYSTEM_DIRECTORY:   $RESERVATION_SYSTEM_DIRECTORY 

perl $RESERVATION_SYSTEM_DIRECTORY/RSServiceSOAPServer.pm
