#!/usr/bin/perl

use IPC::ShareLite;
use HTTP::Request;
use HTTP::Response;
use Pod::WSDL;
use SOAP::Transport::HTTP;
use Proc::Simple;
use IO::Socket;
use POSIX qw(setsid);
use DateTime::Format::MySQL;
use Date::Parse;
use Date::Manip qw(ParseDate UnixDate);
use SOAP::Data::ComplexType;
use SOAP::DateTime;
use Time::HiRes qw(gettimeofday);
use Env;
use POSIX qw(setsid);
use DateTime::Format::MySQL;
use SOAP::Transport::HTTP;
use Date::Parse;
use MIME::Base64 qw( encode_base64 decode_base64 );
use Time::HiRes qw(gettimeofday); 
use File::Slurp;
use Data::Dumper;
use File::Basename;
use Archive::Zip;
use Time::Zone;
use CGI;
use File::Copy;
use Fcntl qw/ :flock /;
use XML::Simple;

# use SOAP::Lite + trace;
use SOAP::Lite;

readConfiguration("/etc/TARWIS.conf");

print "Test Program for Compliance with WSDL-Files\n";

my $ip   = getHostFromURL($ENV{"CONTROLLER_SERVICE_URL"});
my $port = getPortFromURL($ENV{"CONTROLLER_SERVICE_URL"});

print "ControllerService is at host: " . $ip   ."\n"; 
print "ControllerService is at port: " . $port ."\n";
 

print "Connecting to SessionManagementService...\n";
my $wsdlDriver = SOAP::Lite->service( "file:". $ENV{"TARWIS_DIRECTORY"} . "/WSDL/SessionManagementService.wsdl" );

my $experiment_id       = "1";
my $CONTROLLER_URL      = $ENV{'CONTROLLER_SERVICE_URL'};
my $urn_prefix          = $ENV{'URN_PREFIX'};
            
my $experiment_id_soap  = generateSecretReservationKeySOAP($experiment_id, $urn_prefix);
my $CONTROLLER_URL_SOAP = generateSimpleSOAPElement("controller", "string", $CONTROLLER_URL);

my $instance_url        = $wsdlDriver->getInstance($experiment_id_soap, $CONTROLLER_URL_SOAP);

sub readConfiguration {
     # read the configuration
     my $conf = $_[0];
     
     if(!-e $conf || !-r $conf) {
        print "Configuration file: $conf does not exist!\n";
        return 0;
     }     
     open(CONFIG, $conf)  or return 0;   
     while (<CONFIG>) {
         chomp;                                       # no newline
         s/#.*//;                                     # no comments
         s/^\s+//;                                    # no leading white
         s/\s+$//;                                    # no trailing white
         next unless length;                          # anything left?
         my ($var, $value) = split(/\s*=\s*/, $_, 2);
         $ENV{"$var"} = $value;
     } 
     return 1;
}

sub getHostFromURL {
    my $uri = URI->new($_[0]);
    return $uri->host;
}

sub getPortFromURL {
    my $uri = URI->new($_[0]);
    return $uri->port;
}

sub generateSecretReservationKeySOAP
{
	my $secretReservationKey        = $_[0];
	my $urnPrefix                   = $_[1];
	my $soapObj =         SOAP::Data->name("secretReservationKey" => \SOAP::Data->value( 
	                      SOAP::Data->new(name => "secretReservationKey", value => $secretReservationKey, type => "string"),
	                      SOAP::Data->new(name => "urnPrefix",            value => $urnPrefix,            type => "string")));
	return $soapObj;
}


sub generateSimpleSOAPElement {
    my $name  = $_[0];
    my $type  = $_[1];
    my $value = $_[2];
    
    my $data = SOAP::Data->name($name)->type($type)->value($value);
    return $data;
}
