require 'soap/rpc/driver'
require 'soap/wsdlDriver'
require 'utils.rb'
require 'base64'
require 'dummy_nodes_factory.rb'
require 'soap/rpc/standaloneServer'  
require 'soap/wsdlDriver'
require 'soap/rpc/driver'
require 'utils.rb'
require 'rexml/document'
require 'dummy_node.rb'
require 'xsd/qname'
require 'soap/marshal'
require 'xsd/mapping'
require 'ControllerServiceDriver.rb'

class DummyNode
  def initialize(urn)
     @urn = urn
         
     puts "This is sensor node: " + urn + " starting up..."    
     deliverOutput(@urn.to_s, "Hello this is sensor node: " + @urn.to_s); 
     
     @outputThread = Thread.new {      
       while true
          random = rand(10)
          sleep(random)
          deliverOutput(@urn.to_s, @urn.to_s + " sending output-repeat in " + random.to_s + "s");
       end
     }
      
  end
  
  def getControllerService
     controllerService = Controller.new();
     controllerService.options["protocol.http.protocol_version"] = "HTTP/1.0"
     controllerService.streamhandler.client.receive_timeout = 180
     return controllerService
  end
  
  def getControllerServiceWD
     controllerService = Controller.new();
     controllerService.options["protocol.http.protocol_version"] = "HTTP/1.0"
     controllerService.streamhandler.client.receive_timeout = 180
     controllerService.wiredump_dev = STDOUT
     return controllerService
  end
  
  def getOutputThread()
     return @outputThread;
  end
  
  def runCommand(cmd)
    deliverOutput(@urn, "#############################################"); 
    deliverOutput(@urn, "running command: \"" + cmd + "\"..."); 
    deliverOutput(@urn, "processing command..."); 
    deliverOutput(@urn, "command \"" + cmd + "\" processed!"); 
    deliverOutput(@urn, "#############################################"); 
        
  end
    
  def resetNode()
    puts @urn, "resetting..."; 
  end
  
  def deliverOutput(urn, textmessage)
    begin
      message = Message.new(urn,DateTime.now,Base64.encode64(textmessage))
      array = Array.new;
      array.push(message);
      tmessage = Receive.new(array)
      getControllerService().receive(tmessage)
    rescue Exception=>e
      puts "deliverOutput: receive failed!"
    end
  end
  
  
  def kill
    puts "killing outputthread: " + @urn
    Thread.kill(@outputThread)
  end
    
end 
