
if($ARGV[0] eq "") {
    print "usage: HardResetNode.pl <urn>";
    exit(1)
}


hardResetSensorNode($ARGV[0]);

use strict;
use POSIX qw(setsid);
use POSIX;
use LWP;
use LWP::UserAgent;
use File::Slurp; 
use HTTP::Request;
use HTTP::Response;
use Env;
use Pod::WSDL;
use Data::Dumper;
use Net::Ping;
use Coro;
use Storable;
use Data::Dumper;



sub hardResetSensorNode {
    my $urn = $_[0];
    print "resetSensorNode: resetSensorNode node $urn\n";
    my $id = int(stripeIDfromURN($urn));
    print "resetting node id: $id\n";
    my $meshnode_hostname = getMeshNodeOfSensorNode($id);
    my $URL = "http://$meshnode_hostname.unibe.ch/control/rebootMeshNode.php";
    print "URL: $URL\n";
    my $request = HTTP::Request->new(GET => $URL);
    my $ua = LWP::UserAgent->new;
    my $response = $ua->request($request);   
    if( $response->content =~ m/rebooting/ ) {
        my $WAIT_DURATION = 120;
    	my $time_end = time() + $WAIT_DURATION; 
    	print "waiting for: $WAIT_DURATION\n";
    	while(time() < $time_end ) {
    	   sleep(1);
    	}
    	print "exiting: " . getTimeInMySQLFormat() . "\n";
        exit(0);
    }
    else {
        exit(1);
    }
    exit(1);
}

sub getTimeInMySQLFormat() {
   my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime(time);
   my $time = sprintf("%4d-%02d-%02d %02d:%02d:%02d", $year+1900,$mon+1,$mday,$hour,$min,$sec);
   return $time;
}

sub stripeIDfromURN {
   my $urn   = $_[0];
   # stripe away the testbed name
   $urn =~ s/.*://;
   return int($urn);
}

sub getMeshNodeOfSensorNode {
    my $sensorNode_id = $_[0];
    my $mesh_id = $sensorNode_id-1;
    if($mesh_id<10) {
       $mesh_id = "0".$mesh_id;
    }
    return "wb$mesh_id";
}