#!/usr/bin/perl

use strict;
use POSIX qw(setsid);
use POSIX;
use LWP;
use HTTP::Request;
use HTTP::Response;
use DBI;
use DBD::mysql;
use DateTime::Format::MySQL;
use SOAP::Transport::HTTP;
use Proc::Simple;
use IO::Socket;
use IPC::ShareLite;
use Env;
use Pod::WSDL;

readConfiguration("/etc/TARWIS.conf");

push(@INC, $ENV{"TARWIS_DIRECTORY"});
push(@INC, $ENV{"TARWIS_DIRECTORY"} . "UBERN_TESTBED_IMPLEMENTATION");
push(@INC, $ENV{"TARWIS_DIRECTORY"} . "UBERN_TESTBED_IMPLEMENTATION/LOCAL");

require "SensorNodesOutputHandler.pm";
require "DatabaseInterface.pm";
   
print "Starting Local Testbed Implementation...\n\n\n";


startLocalTestbed();

sub startLocalTestbed {     
    my @sensornodes_msb    = ("urn:wisebed:node:ubern:msb1", 
                              "urn:wisebed:node:ubern:msb2",
                              "urn:wisebed:node:ubern:msb3",
                              "urn:wisebed:node:ubern:msb4",
                              "urn:wisebed:node:ubern:msb5", 
                              "urn:wisebed:node:ubern:msb6", 
                              "urn:wisebed:node:ubern:msb7");                         
                               
   
    foreach my $node_urn (@sensornodes_msb){ 
        my $myproc = Proc::Simple->new();
        $myproc->start(\&SensorNodesOutputHandler::sensorNodesOutputHandler, $node_urn, 1);  
    }
}


sub readConfiguration {
     my $conf = $_[0];
     open(CONFIG, $conf)  or die "Can't read file $conf :$!";   
     while (<CONFIG>) {
         chomp;
         s/#.*//;
         s/^\s+//;
         s/\s+$//;
         next unless length;
         my ($var, $value) = split(/\s*=\s*/, $_, 2);
         $ENV{"$var"} = $value;
     } 
     return 1;
}