package Utils;

use Env;
use Time::HiRes qw(gettimeofday);
use MIME::Base64 qw( encode_base64 decode_base64 );

sub encodeFile {
   my $filepath = $_[0];
   open INFILE, '<', $filepath;
   binmode INFILE;
   my $buf;
   my $encoded;
   while ( read( INFILE, $buf, 100000000 ) ) {
        $encoded.=encode_base64($buf);
   }
   close INFILE;
   return $encoded;
}

sub decodeAndWriteToFile {
   my $image = $_[0];
   my $filename = $_[1];
   $image = decode_base64($image);

   open (FILE, ">$filename") or die "Can't read $filename !";
   print FILE $image;
   close(FILE);
}





sub readConfiguration {
     my $conf = $_[0];
     if(!-e $conf || !-r $conf) {
        print "Configuration file: $conf does not exist!\n";
        return 0;
     }
     open(CONFIG, $conf)  or return 0;
     while (<CONFIG>) {
         chomp;                                       # no newline
         s/#.*//;                                     # no comments
         s/^\s+//;                                    # no leading white
         s/\s+$//;                                    # no trailing white
         next unless length;                          # anything left?
         my ($var, $value) = split(/\s*=\s*/, $_, 2);
         $ENV{"$var"} = $value;
     }
     return 1;
}

sub trimchomp
{
    my $string = $_[0];
    chomp($string);
    $string =~ s/^\s+//;
    $string =~ s/\s+$//;
    chomp($string);
    return $string;
}

sub readFile {
   my $filepath = $_[0];
   my $string;
   open FILE, "$filepath" or die "Could not open file: $!";
   while ($record = <FILE>) {
   	$string.= $record;
   }
   close FILE;
   return $string;
}

sub flushFile {
   my $filepath = $_[0];
   open(FILE, ">$filepath") or die "Can't read $file $!";
   close(FILE);
}

sub writeBufferToFile {
   my $filename = $_[0];
   my $string   = $_[1];
   open(OUT, ">$filename");
   print OUT $string;
   close(OUT);
}


sub portChecker {
    my $host = $_[0];
    my $port = $_[1];
    my $sock = new IO::Socket::INET(PeerAddr=>$host,PeerPort=>$port,Proto=>'tcp');
    if($sock)
    {
       close $sock;
       return 1;
    }
    return 0;
}

sub verifyPort {
    my $host = $_[0];
    my $port = $_[1];
    my $portServed = portChecker($_[0],$_[1]);
    return $portServed;
}


sub sendData_flush {
    my $DESTINATION_IP   = $_[0];
    my $DESTINATION_PORT = $_[1];
    my $nodeID           = $_[2];
    my $text             = $_[3];

    my $sock = new IO::Socket::INET(PeerAddr=>$DESTINATION_IP,PeerPort=>$DESTINATION_PORT,Proto=>'tcp');
    if($sock) {
        $toSend = trimchomp($nodeID."|".$text);
    	$sock->send($toSend);
        $sock->close();
        return 1;
    }
    else {
    	# print "could not send data, destination $DESTINATION_IP:$DESTINATION_PORT not reachable\n";
        return 0;
    }
}

sub sendDataChunks_flush {
    my $DESTINATION_IP   = $_[0];
    my $DESTINATION_PORT = $_[1];
    my $nodeID           = $_[2];
    my @chunks           = @{$_[3]};

    my $sock = new IO::Socket::INET(PeerAddr=>$DESTINATION_IP,PeerPort=>$DESTINATION_PORT,Proto=>'tcp');
    if($sock) {
        $toSend = "";
    	foreach my $text (@chunks) {
    	    $toSend .= trimchomp($nodeID."|".$text);
            $toSend .= "\n";
        }
        $sock->send($toSend);
        $sock->close();
        return 1;
    }
    else {
    	# print "could not send data, destination $DESTINATION_IP:$DESTINATION_PORT not reachable\n";
        return 0;
    }
}


sub getTimeInMySQLFormat() {
   my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=gmtime(time());
   my $time = sprintf("%4d-%02d-%02d %02d:%02d:%02d", $year+1900,$mon+1,$mday,$hour,$min,$sec);
   return $time;
}

sub getUsecs () {
   my ($epochseconds, $microseconds) = gettimeofday;
   return $microseconds;
}

sub getHostID {
        my @buffer = `ipconfig /all`;
        foreach $line (@buffer) {
        	if($line =~ m/ee0/){
       		      $line =~ s/.*ee0//g;
                      return int(trimchomp($line));
                }
        }
        return 0;
}

sub getHostIP {
        my @buffer = `ipconfig`;
        foreach $line (@buffer) {
        	if($line =~ m/IP\ Address/ || $line =~ m/IP\-Adresse/){
       		      $line =~ s/.*130/130/g;
                      return trimchomp($line);
                }
        }
        return 0;
}

sub finalizeToken {
	$char      = $_[0];
	$char      = &Utils::trimchomp($char);
	$timestamp = &Utils::getTimeInMySQLFormat();
        $usecs     = &Utils::getUsecs();
	$text      = "$char      CURRENT_TIME: $timestamp $usecs\n";
        return $text;
}



1;