require Win32::SerialPort;
use Time::HiRes qw(usleep);
use Env;
use IO::Socket::INET;
use Win32::MMF::Shareable;

require "Utils.pm";

# at port 4002, listen to the reset command for the serialClient
$listenPort = 4002;
my $hostIP = &Utils::getHostIP();
my $id_file = "C:\\msb\\procid.txt";


print "scriptController.pl running at port: $listenPort\n";

print "Starting to listen at $hostIP:$listenPort for the reset directive\n";
my $sock = new IO::Socket::INET(
	LocalHost => $hostIP,
	LocalPort => $listenPort,
	Type      => SOCK_STREAM,
	Listen    => 50,
	Reuse     => 1,
	Proto     => 'tcp'
	);

while ( my $client = $sock->accept() ) {
	my $data = "";
	while ( defined( my $buf = <$client> ) ) {
		$data .= $buf;
	}
        print "received data: $data\n";
        if($data =~ m/RESET/){
        	open FILE, "<", $id_file or die $!;
	        my @lines = <FILE>;
	        if(@lines>0){
                        my $proc = int(@lines[0]);
                        print "killing proc: $proc\n";
	                my $status = kill(3, $proc);
			system("shutdown -f -r -t 0");
                        exit(0);
                }
	        else {
	                print "ERROR: no pid in file $id_file!\n";
	        }
        }
}