
use strict;
use POSIX qw(setsid);
use POSIX;
use LWP;
use LWP::UserAgent;
use File::Slurp; 
use HTTP::Request;
use HTTP::Response;
use Env;
use Pod::WSDL;
use Data::Dumper;
use Net::Ping;
use Coro;
use Storable;
use Data::Dumper;
use IO::Socket::INET;

readConfiguration("/etc/TARWIS.conf");
push(@INC, $ENV{"TARWIS_DIRECTORY"} . "UBERN_TESTBED_IMPLEMENTATION");
require "UBERNUtils.pm";
our $CURRENT_DIRECTORY              = &UBERNUtils::correctPath($ENV{'TARWIS_DIRECTORY'} . "UBERN_TESTBED_IMPLEMENTATION");  
our $MSB_COMMAND_PORT               = 4000;    

if($ARGV[0] eq "") {
    print "usage: ResetMSBNode.pl <msbX>";
    exit(1)
}

resetMSBNode($ARGV[0]);

sub resetMSBNode {
    my $urn = $_[0];
    print "resetMSBNode: node $urn\n";
    my $id = &UBERNUtils::stripeIDfromURN($urn);
    my $eepc = &UBERNUtils::getSensorNodeOfEEPC($id);
    my $number = $id;
    $number =~ s/msb//;
    $number = int($number)-1;
    # determine the host
    my $hostname = "ee0" . $number  . ".unibe.ch";
    my $success = &UBERNUtils::sendData_flush($hostname, $MSB_COMMAND_PORT, "RESET_NODE"); 
    if($success) {
    	my $WAIT_DURATION = 10;
        my $time_end = time() + $WAIT_DURATION; 
        while(time() < $time_end ) {
           sleep(1);
        }

        exit(0);
    }
    else {
    	exit(1);
    }
}

sub readConfiguration {
     my $conf = $_[0];
     if(!-e $conf || !-r $conf) {
        print "Configuration file: $conf does not exist!\n";
        return 0;
     }
     open(CONFIG, $conf)  or return 0;   
     while (<CONFIG>) {
         chomp;                                       # no newline
         s/#.*//;                                     # no comments
         s/^\s+//;                                    # no leading white
         s/\s+$//;                                    # no trailing white
         next unless length;                          # anything left?
         my ($var, $value) = split(/\s*=\s*/, $_, 2);
         $ENV{"$var"} = $value;
     } 
     return 1;
}