
if($ARGV[0] eq "") {
    print "usage: ResetNode.pl <urn>";
    exit(1)
}


resetSensorNode($ARGV[0]);

use strict;
use POSIX qw(setsid);
use POSIX;
use LWP;
use LWP::UserAgent;
use File::Slurp; 
use HTTP::Request;
use HTTP::Response;
use Env;
use Pod::WSDL;
use Data::Dumper;
use Net::Ping;
use Coro;
use Storable;
use Data::Dumper;


sub resetSensorNode {
    my $urn = $_[0];
    print "resetSensorNode: resetSensorNode node $urn\n";
    my $id = int(stripeIDfromURN($urn));
    print "resetting node id: $id\n";
    my $meshnode_hostname = getMeshNodeOfSensorNode($id);
    my $URL = "http://$meshnode_hostname.unibe.ch/control/resetSensorNode.php";
    print "URL: $URL\n";
    my $request = HTTP::Request->new(GET => $URL);
    my $ua = LWP::UserAgent->new;
    $ua->timeout(10);
    my $response = $ua->request($request);   
    if( $response->content =~ m/succeeded/ ) {
        exit(0);
    }
    else {
        exit(1);
    }
    exit(1);
}

sub stripeIDfromURN {
   my $urn   = $_[0];
   # stripe away the testbed name
   $urn =~ s/.*://;
   return int($urn);
}

sub getMeshNodeOfSensorNode {
    my $sensorNode_id = $_[0];
    my $mesh_id = $sensorNode_id-1;
    if($mesh_id<10) {
       $mesh_id = "0".$mesh_id;
    }
    return "wb$mesh_id";
}