##########################################################

function readconf() {
    while read line; do
        [[ ${line:0:1} == "#" ]] && continue
        [[ -z "$line" ]] && continue
        line=`echo $line | awk -F "#" '{print $1}'`
        key=${line//=*}
        value=${line//*=}
        key=$(echo "$key" | sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//')
        value=$(echo "$value" | sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//')
        export $key="$value"
    done < "$CONFIG"
}

#########################################################

# read in the configuration file



CONFIG=/etc/TARWIS.conf

readconf

echo "controller service url:      " $CONTROLLER_SERVICE_URL
echo "session manager service url: " $SESSION_MANAGEMENT_SERVICE_URL

safe_pattern=$(printf "%s\n" "$CONTROLLER_SERVICE_URL" | sed 's/[][\.*^$/]/\\&/g')
echo "setting CONTROLLER_SERVICE_URL according to the /etc/TARWIS.conf settings"
sed -i 's/<soap\:address location=.*>/<soap\:address location=\"'$safe_pattern'\"\/>/g' $TARWIS_DIRECTORY/WSDL/ControllerService.wsdl
sed -i 's/DefaultEndpointUrl = \".*\"/DefaultEndpointUrl = \"'$safe_pattern'\"/g' $TARWIS_DIRECTORY/DUMMY_TESTBED_IMPLEMENTATION/ControllerServiceDriver.rb

safe_pattern=$(printf "%s\n" "$SESSION_MANAGEMENT_SERVICE_URL" | sed 's/[][\.*^$/]/\\&/g')
echo "setting SESSION_MANAGEMENT_SERVICE_URL according to the /etc/TARWIS.conf settings"
sed -i 's/<soap\:address location=.*>/<soap\:address location=\"'$safe_pattern'\"\/>/g' $TARWIS_DIRECTORY/WSDL/SessionManagementService.wsdl



