#!/bin/bash


##########################################################

function readconf() {
    while read line; do
        # skip comments
        [[ ${line:0:1} == "#" ]] && continue 
        # skip empty lines
        [[ -z "$line" ]] && continue
        line=`echo $line | awk -F "#" '{print $1}'`
        # echo line=$line
        key=${line//=*}
        value=${line//*=}
        key=$(echo "$key" | sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//')
        value=$(echo "$value" | sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//')
        # echo key=$key 
        # echo value=$value
        export $key="$value"
    done < "$CONFIG"
}

#########################################################


CONFIG=/etc/TARWIS.conf

readconf


FILE=$TARWIS_DIRECTORY/image_*.ihex
rm -rf $FILE

FILE=$TARWIS_DIRECTORY/*.out
FILE=`echo $FILE | sed "s/\/\//\//"`
rm -rf $FILE

FILE=$TARWIS_DIRECTORY/*.out_*
FILE=`echo $FILE | sed "s/\/\//\//"`
rm -rf $FILE

FILE=$TARWIS_DIRECTORY/*.err_*
FILE=`echo $FILE | sed "s/\/\//\//"`
rm -rf $FILE

FILE=$TARWIS_DIRECTORY/*.err
FILE=`echo $FILE | sed "s/\/\//\//"`
rm -rf $FILE

FILE=$TARWIS_DIRECTORY/*~
FILE=`echo $FILE | sed "s/\/\//\//"`
rm -rf $FILE

FILE=$TARWIS_DIRECTORY/*.wiseml
FILE=`echo $FILE | sed "s/\/\//\//"`
rm -rf $FILE

FILE=$TARWIS_DIRECTORY/notification_*.txt
FILE=`echo $FILE | sed "s/\/\//\//"`
rm -rf $FILE

FILE=$TARWIS_DIRECTORY/results_*.zip
FILE=`echo $FILE | sed "s/\/\//\//"`
rm -rf $FILE

FILE=$TARWIS_DIRECTORY/WSDL/WSNService.wsdl_expid=*
FILE=`echo $FILE | sed "s/\/\//\//"`
rm -rf $FILE

rm -rf $TARWIS_DIRECTORY/ExperimentLogs/
mkdir $TARWIS_DIRECTORY/ExperimentLogs/

rm -rf /var/www/portal/TARWIS/ExperimentObservation/*.dot
rm -rf /var/www/portal/TARWIS/ExperimentObservation/*.svg
