#!/bin/bash


##########################################################

function readconf() {
    while read line; do
        # skip comments
        [[ ${line:0:1} == "#" ]] && continue 
        # skip empty lines
        [[ -z "$line" ]] && continue
        line=`echo $line | awk -F "#" '{print $1}'`
        # echo line=$line
        key=${line//=*}
        value=${line//*=}
        key=$(echo "$key" | sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//')
        value=$(echo "$value" | sed -e 's/^[[:space:]]*//' -e 's/[[:space:]]*$//')
        # echo key=$key 
        # echo value=$value
        export $key="$value"
    done < "$CONFIG"
}

#########################################################


CONFIG=/etc/TARWIS.conf
readconf
CONFIG=/etc/RS.conf
readconf

cat > createUser << EOF

SET NAMES 'utf8'; 
SET CHARACTER SET utf8; 
CHARSET utf8; 

USE mysql;

DELETE FROM user where user='wisebeduser';
FLUSH PRIVILEGES;

INSERT INTO user (Host,User,Password,Select_priv,Insert_priv,
Update_priv,Delete_priv, Create_tmp_table_priv,Lock_tables_priv,Execute_priv) 
VALUES   ('localhost','wisebeduser',PASSWORD('wisebed'), 'Y','Y','Y','Y','Y','Y','Y'); 
FLUSH PRIVILEGES; 

CREATE DATABASE IF NOT EXISTS wsn_info CHARACTER SET = utf8; 
CREATE DATABASE IF NOT EXISTS rs_info  CHARACTER SET = utf8; 
USE wsn_info; 
GRANT ALL PRIVILEGES ON wsn_info.* TO '$MYSQL_DATABASE_USER'@'localhost' IDENTIFIED BY '$MYSQL_DATABASE_PASSWORD'; 
USE rs_info; 
GRANT ALL PRIVILEGES ON rs_info.* TO '$RS_MYSQL_DATABASE_USER'@'localhost' IDENTIFIED BY '$RS_MYSQL_DATABASE_PASSWORD'; 
QUIT

EOF


echo "This script sets up the user \"wisebeduser\" with the password \"wisebed\""
echo "with full privileges for the table \"wsn_info\" which is used for TARWIS"
echo "ENTER THE PASSWORD FOR YOUR ROOT MYSQL USER!"

mysql -u root -p < createUser

rm -f createUser



