<!--
*******************************************************************************
  including Header and Menues
*************************************************************************** -->
<?php
include '../include/header.php';
?>
<div id='pageHeader' class='pageHeader'>
<?php
include '../include/menue.php';
include 'expSetupMenue.php';
?>
</div> <!-- end div container 'pageHeader' -->
<!-- ********************************************************************** -->

<!--
*******************************************************************************
  div container for 'pageContent'
*************************************************************************** -->
<div id='pageContent' class='pageContent'>
<?php
  require_once('../include/configurations.php');
  require_once("../include/classes.inc.php");
  require_once("../include/functions.php");
  require_once('../include/RSService/RSService.php');

  //delete old graph file
  delfile("*.svg");
  delfile("*.dot");
  delfile("*.xml");
  delfile("*.png");
?>

<!--
*******************************************************************************
  div container for 'infoBox'
*************************************************************************** -->
<div id='expSetupCfgInfoBox' class='infoBox'>
  
  <!-- General information text about the experiment setup ---------------- -->
  <div id='expSetupCfgInfoText' class='infoText'>
    <p><strong>Experiment Configuration:</strong> You can choose the images for the selected sensor nodes. Please fill the form and write <strong>name</strong> and a short <strong>description</strong> of the experiment.
    <br/>
    <br/>
    By clicking on the <strong>public experiment</strong> checkbox, you allow other users to observe the experiment (but not send commands nor reset the nodes) and download the results.</p>
  </div>
  <!-- -------------------------------------------------------------------- -->
  
  <div id='expSetupCfgCrossLine' class='crossLine'>
    &nbsp;
  </div>
  <!-- -------------------------------------------------------------------- -->
  
</div> <!-- end div container 'infoBox' -->
<!-- ********************************************************************** -->


<!--
*******************************************************************************
  div container for 'contentBox'
*************************************************************************** -->
<div id='expSetupCfgContentBox' class='contentBox'>
<?php
  Db::getInstance()->selectDB("wsn_info");
  
  //echo "<pre>";
  //print_r($_POST);
  //echo "</pre>"; 
  
  if(!empty($_POST) && !empty($_POST['configExp']) && !empty($_POST['resKey']))
  {
    $myRes = getReservation($_POST['resKey']);
  }
  else if(!empty($_POST) && !empty($_POST['exp_id']))
  {
    $myRes = getReservation($_POST['exp_id']);
  }

  
  //get the selected node IDs from the $myRes structure
  $snIDs = array();
  if(!empty($myRes->reservationData->nodeURNs))
  {
    if(count($myRes->reservationData->nodeURNs) == 1)
    {
      array_push($snIDs, $myRes->reservationData->nodeURNs);
    }
    else
    {
      $snIDs = $myRes->reservationData->nodeURNs;
    }
  }
  
  $resNetworkName = "resNet_" . $myRes->reservationData->data->secretReservationKey;
  $resNetwork = new Network($resNetworkName);
  foreach($snIDs as $snID)
  {
    $resNetwork->addSensorNodeFromDB($snID);
  }
  
  //add the new experiment conf when button 'Finish' is pressed
  if(!empty($_POST) && $_POST['finConf'] == 'Finish Experiment Configuration')
  {
    Db::getInstance()->addNewExperimentConfiguration($_POST, $_SERVER);
  }
  
  if(!empty($_POST) && $_POST['loadSettings'] == 'load template')
  {
  	$templateEntry = Db::getInstance()->getTemplateWithID($_POST['template']);
    $_POST['exp_name']         = $templateEntry['template_name'];
    if($templateEntry['template_visibility'] == 1) {
    	$_POST['exp_visibility']   =  "public";
    }
    $_POST['iterations']       = $templateEntry['template_runs'];
    $_POST['exp_desc']         = $templateEntry['template_description'];
    
    
    $automatedTemplatedCommandsArray = Db::getInstance()->getTemplatedAutomatedCommands($_POST['template']);
    Db::getInstance()->deleteAutomatedTemplatedCommands($template_id);
    
    foreach($automatedTemplatedCommandsArray as $automatedCommand)
    {
        //echo "template_name: "        .  print_r($automatedCommand) . "<br/>";
        if(in_array($automatedCommand['node_urn'], $snIDs)) {
    	   Db::getInstance()->insertAutomatedCommandArgs($_POST['exp_id'], $automatedCommand['node_urn'], $automatedCommand['command'], $automatedCommand['seconds_after_flash']);
    	}
        if(strpos($automatedCommand['node_urn'], "all nodes")!==false) {
           Db::getInstance()->insertAutomatedCommandArgs($_POST['exp_id'], "broadcast|" . $snIDs[0] , $automatedCommand['command'], $automatedCommand['seconds_after_flash']);
        }
    }
    
    
    $templatedNodesImagesArray = Db::getInstance()->getTemplatedNodesImages($_POST['template']);   
    //echo "<pre>";
    //echo "template_name: "        .  $templateEntry['template_name'] . "<br/>";
    //echo "template_description: " .  $templateEntry['template_description'] . "<br/>";
    //echo "template_visibility: "  .  $templateEntry['template_visibility'] . "<br/>";
    //echo "template_runs: "        .  $templateEntry['template_runs'] . "<br/>";
    //echo "</pre>";
  }
  
  if(!empty($_POST) && $_POST['deleteSettings'] == 'delete template')
  {
    Db::getInstance()->deleteAutomatedTemplatedCommands($_POST['template']);
    Db::getInstance()->deleteTemplate($_POST['template']);
    Db::getInstance()->deleteAutomatedTemplatedNodeImages($_POST['template']);
  }
  
  if(!empty($_POST) && $_POST['addCommand'] == 'add' && is_numeric($_POST['seconds']))
  {
    if(strcmp($_POST['automated_command_input_node'], 'all nodes') == 0) {
        $_POST['automated_command_input_node'] = "broadcast|" . $snIDs[0]; 
    }
  	Db::getInstance()->insertAutomatedCommand($_POST, $_SERVER);
  }
  
  if(!empty($_POST) && in_array('delete', $_POST))
  {
  	$rawcommandID = array_search('delete', $_POST);
  	$splitted = explode('_', $rawcommandID);
  	$command_id = $splitted[1];
    Db::getInstance()->deleteAutomatedCommand($command_id);
  }
  
  $diffTimeSec = timeToSec($myRes->reservationData->to) - timeToSec($myRes->reservationData->from); 
  
  //create the formular to configure the experiment
  if(!empty($_POST) && $_POST['finConf'] != 'Finish Experiment Configuration' && $_POST['saveTemplate'] != 'save settings as template')
  {
      
    // UPLOAD IMAGE 
    
    echo "<br/>";
        
    if(!empty($_POST) && $_POST['uploadImage'] != "")
    {
      //echo "<pre>";
      //print_r($_POST);
      //echo "</pre>";  
        
      $dbInsertArray = array();
      $dbInsertArray['img_name']          = $_POST['name'];
      $dbInsertArray['img_version']       = $_POST['version'];
      $dbInsertArray['img_platform']      = $_POST['platform'];
      $dbInsertArray['img_description']   = $_POST['description'];
      $dbInsertArray['img_file_name']     = ($_FILES['imageFile']['name']);
      $imageTmpFile                       = ($_FILES['imageFile']['tmp_name']);
      $dbInsertArray['img_file_size']     = ($_FILES['imageFile']['size']);
      $dbInsertArray['img_file']          = mysql_real_escape_string(@fread(fopen($imageTmpFile, "r"), filesize($imageTmpFile)));
      $dbInsertArray['img_file_datetime'] = gmdate("Y-m-d H:i:s", time());
      $dbInsertArray['img_file_usecs']    = 0;
      $dbInsertArray['exp_user_unique_id']= $_SERVER['personUniqueID'];
      
      //echo "<pre>";
      //print_r($dbInsertArray);
      //echo "</pre>";  
      $line = exec("hexdump $imageTmpFile | head -n 1");
      $line = substr($line, 0, 12);
      if( $line  == "0000000 5a4d" | $line == "0000000 457f" ) {
        echo "<br/>";
        echo "<font color='#FF0000'>";
        if($line  == "0000000 5a4d"){
            echo "The uploaded image looks like a <strong>windows executable</strong> file<br/>";
        }
        else {
            echo "The uploaded image looks like a <strong>linux executable</strong> file<br/>";
        }
        echo "It is <strong>unlikely to run</strong> on most sensor nodes<br/>";
        echo "<strong>Update the image</strong> under the MyImages tab in case you uploaded the <strong>wrong image</strong><br/>";
        echo "</font>";
      }
      
      
      // calls DB functions according to the pressed button ['sub']
      if($_POST['uploadImage'] == "Upload New Image" && $dbInsertArray['img_name'] !="" && $dbInsertArray['img_file_size'] > 0)
      {
        $imageID = Db::getInstance($config)->addNewImage($dbInsertArray);
        echo "<p><strong>uploaded image: " . $dbInsertArray['img_name'] . " assigned unique id: " . $imageID . "</strong></p>";
      }
    }
    
    echo "<a href='javascript:;' onmousedown='toggleUpload();' style='color:black' ><strong>Upload New Sensor Image:</strong></a>";
    
    echo "<div id='upload' style='display:none'>";
    echo "<br/>";
    echo "<form enctype='multipart/form-data' name='imageUploadForm' action='' method='POST'>";
    echo "<table border='0'>";    
    echo "<tr><td width='150px'>Name:</td>";
    echo "<td width='300px'><input type='text' name='name'></input></td></tr>";
    echo "<tr><td width='150px'>Version:</td>";        
    echo "<td width='300px'><input type='text' name='version'></input></td></tr>";
    echo "<tr><td width='150px'>Platform:</td>";        
    echo "<td width='300px'><input type='text' name='platform'></input></td></tr>";
    echo "<tr><td width='150px' valign='top'>Description:</td>";        
    echo "<td width='300px'><textarea name='description' cols='30' rows='5'></textarea></td></tr>";
    echo "<tr><td width='150px'>File Name:</td>";        
    echo "<td width='300px'><input type='file' name='imageFile'></input></td></tr>";
    echo "<tr><td></td><td><input type='submit' name='uploadImage' value='Upload New Image'></input></td></table>";
    echo "<input name='resKey' type='hidden' value='" .  $myRes->reservationData->data->secretReservationKey . "'/>";
    echo "<input name='configExp' type='hidden' value='Configure Experiment'/>";
    echo "</form>"; 
    echo "</div>";
    
    echo "<br/>";
    echo "<br/>";   
      
    //formular for image selection and exp configuration --------------------
    echo "<form action='' name='expConfForm' method='POST'>";
    
    //which was the last seleteced image in the drop down menue
    if(!empty($_POST) && $imageID == "")
    {
      $tmp = split(",", $_POST['AllSN']);
      $imageID = $tmp[0];
    }
    
    
    $templates = Db::getInstance()->getTemplates($_SERVER['personUniqueID']);
    echo "<div id='expSetupCfgImageSelectForm' class='formularBox'>";
        
    if(count($templates)>0) {
	    
	    // -- div container 'formularBox' (for ImgSel)
	    echo "<strong>Load Experiment Template:</strong><br/><br/>";
	    echo "<table>";
	    echo "<colgroup>";
	    echo "<col width='120'>";
	    echo "<col width='100'>";
	    echo "<col width='100'>";
	    echo "</colgroup>";
	    echo "<tr>";
	    echo "<td><select name='template' size='1'>";
	    foreach($templates as $template)
		{
		     echo "<option value ='" . $template['template_uniqueID'] . "'>" . $template['template_uniqueID'] . "</option>";
		}
	    echo "</select></td>";
	    echo "<td><input type='submit' id='loadSettings' name='loadSettings' value='load template'></td>";
	    echo "<td><input type='submit' id='deleteSettings' name='deleteSettings' value='delete template'></td>";
	    echo "</table>";
	    echo "<br/>";
	    echo "<br/>";
    }
    
    echo "<strong>Selected Nodes:</strong><br/><br/>";
    echo "<table>";
    echo "<colgroup>";
    echo "<col width='120'>";
    echo "<col width='150'>";
    echo "</colgroup>";
    echo "<tr><td>";
    echo "<strong>ALL NODES: </strong></td><td><select name='AllSN' size='1' onChange='Javascript:expConfForm.submit()'>";

    $resultArray = array();
    $imageQueryString = "SELECT image_id, image_name, image_file_name, exp_user_unique_id FROM images WHERE image_visible='1' AND exp_user_unique_id='" . $_SERVER['personUniqueID'] . "' OR exp_user_unique_id='defaultExperimentUser'";
    $res = mysql_query($imageQueryString);
    while ($line = mysql_fetch_assoc($res))
    {
      array_push($resultArray, $line);
    }
  
    
    foreach($resultArray as $val)
    {
      if($imageID == $val['image_id'])
      {
        echo "<option selected value = '" . $val['image_id'] . "," . $val['image_name'] . "'>" . $val['image_name'] . "</option>";
      }
      else
      {
        echo "<option value = '" . $val['image_id'] . "," . $val['image_name'] . "'>" . $val['image_name'] . "</option>";
      }
    }
    echo "</select>";
    echo "</td>" . "</tr>";
    
    //create the dop-down menues for the selected nodes
    //initial menue (snIDs from the $_POST array from expSetupSelect.php)
    if(!empty($snIDs))
    {
      foreach($snIDs as $snID)
      {
        echo "<tr>" . "<td>";
        echo $snID .": </td><td><select name='snNodes[" . $snID . "]' size='1'>";
        if(count($templatedNodesImagesArray) > 0) {
            $tuple = getDefinedTupleForNode($snID, $templatedNodesImagesArray);
            if($tuple != NULL){
                echo "<option value = '" . $tuple['image_id'] . "," . $tuple['image_name'] . "'>" . $tuple['image_name'] . "</option>\n";       
            }
            foreach($resultArray as $val)
            {
                echo "<option value = '" . $val['image_id'] . "," . $val['image_name'] . "'>" . $val['image_name'] . "</option>";
            } 
        }
        else {
            foreach($resultArray as $val)
            {
              if($imageID == $val['image_id'])
              {
                echo "<option selected value = '" . $val['image_id'] . "," . $val['image_name'] . "'>" . $val['image_name'] . "</option>";
              }
              else
              {
                echo "<option value = '" . $val['image_id'] . "," . $val['image_name'] . "'>" . $val['image_name'] . "</option>";
              }
            }
        }
        echo "</select>";
    	  echo "</td>" . "</tr>";
      }
    }
    //after selecting ALL (snIDs from the $_POST array from itself)
    else if(!empty($_POST['snNodes']))
    {
      foreach($_POST['snNodes'] as $snID => $val2)
      {
    	  echo "<tr>" . "<td>";
        echo $snID . ": </td><td><select name='snNodes[" . $snID . "]' size='1'>";
        foreach($resultArray as $val)
        {
          if($imageID == $val['image_id'])
          {
            echo "<option selected value = '" . $val['image_id'] . "," . $val['image_name'] . "'>" . $val['image_name'] . "</option>";
          }
          else
          {
            echo "<option value = '" . $val['image_id'] . "," . $val['image_name'] . "'>" . $val['image_name'] . "</option>";
          }
        }
        echo "</select>";
        echo "</td>" . "</tr>";
      }
    }
    echo "</table>";   
    echo "</div>"; 
   
    
    // -- div container 'formularBox' (for ExpCfg)
    echo "<div id='expSetupCfgExpCfgForm' class='formularBox'>";
    echo "<strong>Experiment Configuration:</strong><br/><br/>";
    echo "<table>";
    echo "<tr>";
      echo "<td>" . "ID:" . "</td>";
      echo "<td>" . "<input name='exp_id' type='text' value='" . $myRes->reservationData->data->secretReservationKey . "' readonly size='35' style='background-color: grey'>" . "</td>";
    echo "</tr>";    
    echo "<tr>";
      echo "<td>" . "Name:" . "</td>";
      echo "<td>";
        echo "<input name='exp_name' type='text' value='" . $_POST['exp_name'] . "' size='35'>";
        if($_POST['exp_visibility'] == "public")
        {
          echo " public experiment <input type='checkbox' name='exp_visibility' value='public' checked>";
        }
        else
        {
          echo " public experiment <input type='checkbox' name='exp_visibility' value='public'>";
        }
        echo "</td>";
    echo "</tr>";  
    echo "<tr>";
      echo "<td>" . "Description:" . "</td>";
      echo "<td>" . "<textarea name='exp_desc' cols='50' rows='10'>" . $_POST['exp_desc'] . "</textarea>" . "</td>";
    echo "</tr>";
    echo "<tr>";
      echo "<td>" . "Start:" . "</td>";
      echo "<td>" . "<input name='exp_start_time' type='text' value='" . $myRes->reservationData->from . "' readonly style='background-color: grey'>" . "</td>";
    echo "</tr>";    
    echo "<tr>";
      echo "<td>" . "End:" . "</td>";
      echo "<td>" . "<input name='exp_end_time' type='text' value='" . $myRes->reservationData->to . "' readonly style='background-color: grey'>" . "</td>";
    echo "</tr>";    
    echo "<tr>";
      echo "<td>" . "Runs:" . "</td>";
      echo "<td>\n";
    echo " <select name='iterations'>";
    
    global $config;
    // because it is possible that flashing takes long, minimum run duration must be accordingly big 
    $lowerlimit = 2*(intval($config['FLASH_ATTEMPTS'])*intval($config['WAIT_PERIOD_BEFORE_FLASH_RETRY']));
    
    for($iter = 1; $iter <= 20; $iter += 1)
    {
      $secPerRun = round($diffTimeSec / $iter);
      if($secPerRun > $lowerlimit) {
	      echo "<option value='" . $iter . "' "; 
	      if($iter == $_POST['iterations'])
	      { 
	      	echo "selected='selected'";
	      }
	      echo "><b>" . $iter . "</b> (" . secToTime($secPerRun) . " per run) " . "</option>\n";
	  }
    }
    echo "</select>";
      echo "</td>";
    echo "</tr>";    
    echo "</table>";  
    
    echo "<br/>";
    
    $commandsArray = Db::getInstance()->getAutomatedCommands($myRes->reservationData->data->secretReservationKey);
    
    echo "<table>";
    echo "<tr>";
    echo "<td><strong>" . "Automated Command Input:" . "</strong></td>";
    echo "</tr>";   
    echo "</table>"; 
    echo "<br/>";
    echo "<table>";
      echo "<tr>";
      echo "<td>node</td><td>command</td><td>t-t0 [s]</td>";
      echo "</tr>";   
      echo "<tr>";
      echo "<td>";   
      echo " <select name='automated_command_input_node'>";
        
	    foreach($snIDs as $snID)
	    {
	       echo "<option value='" . $snID . "'>" . $snID . "</option>";
	    }
	    
	    echo "<option value='all nodes'>all nodes</option>";
        echo "</select>";
        echo "</td>";
        echo "<td><input name='command' type='text' size='15'></td><td><input name='seconds' title='enter numeric value' type='text' size='5'></td><td><input type='submit' id='addCommand' name='addCommand' value='add' onClick='Javascript:expConfForm.submit()'></td>";
        echo "</tr>";   
        
    
    
    foreach($commandsArray as $commandEntry)
    {
	    echo "</td>";
	    echo "<td>" . $commandEntry['node_urn'] . "</td><td>" . $commandEntry['command'] . "</td><td>" . $commandEntry['seconds_after_flash'] . "</td>";
	    echo "<td>";
	    echo "<input type='submit' id='deleteCommand' name='deleteCommand_" . $commandEntry['command_id'] . "' value='delete' onClick='Javascript:expConfForm.submit()'>"; 
	    echo "</td>";
	    echo "</tr>";       
  	}
  	echo "</table>"; 
    echo "<br/>";
    echo "<br/>";
        
    echo "<table>";         
      echo "<tr>";
      echo "<td>" . "<input type='submit' id='finConf' name='finConf' value='Finish Experiment Configuration'>" . "</td>";
      echo "</tr>";
    echo "</table>"; 
    echo "</div>";  //end div container 'formularBox' (for ExpCfg)
     
    // -- div container 'netGraphSmall' (for expSetupCfgNetGraph)
    echo "<div id='expSetupCfgNetGraph' class='netGraphSmall'" . "style='background-image:url(" . $config['MAP_PATH'] . "/" . $config['MAP_FILE_NAME']. ");background-repeat:no-repeat;padding-right:10pt;'>";
      $graphFormat = "svg";
      $graphFile = "./" . $resNetworkName . "Graph." . $graphFormat;
      $graphResNet = new NetworkGraph($resNetworkName, $resNetwork);
      $graphResNet->drawGraph();
    
      if (!file_exists($graphFile)) {
            echo "<strong>GraphViz ERROR! The file " .  $graphFile . " does not exist</strong>";
      } 
      $graphFilePrefix = "./" . $resNetworkName . "Graph";
      $command = "mogrify -format png -transparent white " . $graphFilePrefix . ".svg";
      
      exec($command);
      echo "<img src='" . $graphFilePrefix .".png" . "'>";
    	
    echo "</div>";  //end div container 'netGraphSmall' (for expSetupCfgNetGraph)
    
    // -- div container 'netTree' (for expSetupCfgNetTree)
    echo "<div id='expSetupCfgNetTree' class='netTree'>";
  	  $netTree = NetTreeExpSetup::getInstance();
  	  $netFileName = "./" . $resNetworkName . ".xml";
	    $netTree->generateNetworkTree($resNetwork, $netFileName);
	    ?>
	    <!-- end php section --> <!-- javascript for tree building and returning node selection -->
    <script type="text/javascript">
      tree = new dhtmlXTreeObject(document.getElementById('expSetupCfgNetTree'),"100%","",0);
      tree.setImagePath("../include/dhtmlxtree/codebase/imgs/");
      tree.enableCheckBoxes(false);
      tree.enableDragAndDrop(false);
	    tree.enableThreeStateCheckboxes(false);
  	  tree.enableHighlighting(true);
  	  tree.loadXML("<?php echo $netFileName ?>");
    </script> <!-- end javascript for tree building and returning node selection -->
<?php
    echo "</div>";  //end div container 'netTree' (for expSetupCfgNetTree)
    echo "</form>"; // end formular for image selection and exp configuration
    //-----------------------------------------------------------------------
  }
  else if(!empty($_POST) && $_POST['finConf'] == 'Finish Experiment Configuration' || $_POST['saveTemplate'] == 'save settings as template')  //print the result of the experiment configuration after pressing finish
  {
    echo "<br/>";
  	$myExperiment = Db::getInstance()->getExperimentConfiguration($_POST['exp_id']);
    if($myExperiment['exp_visibility'] == 1)
    {
      echo "<strong>Configuration for a <i> public </i> Experiment (id=" . $myExperiment['exp_id'] . ") finished!</strong><br/>";
    }
    else
    {
      echo "<strong>Configuration for a <i> private </i> Experiment (id=" . $myExperiment['exp_id'] . ") finished!</strong><br/>";
    }
    
    echo "<br/>";
    
    echo "<table style='border: 1px solid black'>";
    echo "<colgroup>";
    echo "<col width='180'>";
    echo "<col width='500'>";
    echo "</colgroup>";
    echo "<tr>";
    echo "<td><strong>User:</strong></td><td bgcolor='#F2F2F2'>".$_SERVER['Shib-WISEBEDPerson-surname'] . " " . $_SERVER['Shib-WISEBEDPerson-givenName'] . " (" . $myExperiment['exp_user_unique_id'] . ")</td>";
    echo "</tr>";    
    echo "<tr>";
    echo "<td><strong>Experiment ID:</strong></td>" . "<td bgcolor='#F2F2F2'>" . $myExperiment['exp_id'] . "</td>";
    echo "</tr>";    
    echo "<tr>";    
    echo "<td><strong>Name:       </strong></td>" . "<td bgcolor='#F2F2F2'>" . $myExperiment['exp_name'] . "</td>";
    echo "</tr>";    
    echo "<tr>";    
    echo "<td style='vertical-align:top'><strong>Description: </strong></td>";
    if(strlen( $myExperiment['exp_description'] )== 0)
    {
	    echo "<td bgcolor='#F2F2F2'><i>no description supplied</i></td>";
    }
    else
    {
  	  echo "<td bgcolor='#F2F2F2'>" .  $myExperiment['exp_description']  . "</td>";
    }
    echo "</tr>";        
    echo "<tr>";        
    echo "<td><strong>Start: </strong></td><td bgcolor='#F2F2F2'>" . $myExperiment['exp_start_time'] . "</td>";
    echo "</tr>";        
    echo "<tr>";        
    echo "<td><strong>End: </strong></td><td bgcolor='#F2F2F2'>" . $myExperiment['exp_end_time'] . "</td>";
    echo "</tr>";
    echo "<tr>";        
    echo "<td><strong>Runs: </strong></td><td bgcolor='#F2F2F2'>" . $myExperiment['exp_runs'] . "</td>";
    echo "</tr>";
    echo "</table>";
    echo "<br/>";
    echo "<br/>";
    echo "<table>";
    echo "<colgroup>";
    echo "<col width='250'>";
    echo "<col width='500'>";
    echo "</colgroup>";
    echo "<tr><td><strong>Selected Nodes:</strong></td><td><strong>Images:</strong></td></tr>";
    foreach($myExperiment['exp_nodes'] as $snNodes)
    {
      echo "<tr>";
      echo "<td>" . $snNodes['node_urn'] . "</td>" . "<td>" . $snNodes['image_name'] . " v" . $snNodes['image_version'] . "</td>";
      echo "</tr>";
    }
    echo "</table>";
    echo "<br/>";
    echo "<br/>";
    
    if($_POST['saveTemplate'] == 'save settings as template') {
        echo "<strong>Configuration saved under template name " . $_POST['templatename'] . "</strong><br/>";
        Db::getInstance()->saveTemplate($_POST['exp_id'], $_POST['templatename']);
    }
    else { 
        echo "<form action='' name='saveSettingsForm' method='POST'>";
        echo "<input type='hidden' id='exp_id' name='exp_id' value='" . $_POST['exp_id'] . "' />";
        echo "<table>";         
        echo "<tr>";
        echo "<td>" . "<input type='submit' id='saveTemplate' name='saveTemplate' value='save settings as template' onClick='Javascript:saveSettingsForm.submit()'>" . "</td>";
        echo "<td> specify template name </td>";
        echo "<td><input name='templatename' type='text' size='15' value='" .  $myExperiment['exp_id'] . "' ></td>";
        echo "</tr>";
        echo "</table>"; 
        
        echo "</form>";
    }
    
  }
?>
</div> <!-- end div container 'contentBox' -->
<!-- ********************************************************************** -->

  
</div> <!-- end div container 'pageContent' -->
<!-- ********************************************************************** -->


<!-- closing body and html -->
  </body>
</html>
<!-- ********************************************************************** -->
 
