<!--
*******************************************************************************
  including Header and Menues
*************************************************************************** -->
<?php
include '../include/header.php';
?>
<div id='pageHeader' class='pageHeader'>
<?php
include '../include/menue.php';
include './resMenue.php';
?>
</div> <!-- end div container 'pageHeader' -->
<!-- ********************************************************************** -->

<!--
*******************************************************************************
  div container for 'pageContent'
*************************************************************************** -->
<div id='pageContent' class='pageContent'>    
<?php
require_once('../include/configurations.php');
require_once("../include/classes.inc.php");
require_once("../include/functions.php");
require_once('../include/RSService/RSService.php');

Db::getInstance()->selectDB("wsn_info");
$userID = $_SERVER['personUniqueID'];

if(!empty($_POST))
{
  if(!empty($_POST['deleteRes']))
  {
    if(!empty($_POST['deleteResKey']))
    {
      deleteReservation($_POST['deleteResKey'], $userID);
      Db::getInstance()->deleteExperiment($_POST['deleteResKey']);
    }
  }
}

if (strlen(strstr($_POST['deleteAllOwnExpiredReservations'],"Delete all"))>0)
{
    //echo "deleteAllOwnExpiredReservations: <pre>";
    //print_r($_POST);
    //echo "</pre>";
    $max = count($_POST);
    for($i=0; $i<$max; $i++){
        $label = "ownReservations_" . $i;
        if(!empty($_POST[$label])) {
            try {
                deleteReservation($_POST[$label], $userID);
            }
            catch (SoapFault $fault2)
            {
                echo "deleteReservation " . $_POST[$label] . " failed<br/>";
            }
            Db::getInstance()->deleteExperiment($_POST[$label]);
        }
    }
}

    // if this is a testbed maintainer, filter out other users' experiments here
$isTestbedMaintainer = 0;
if(checkAccessRights($_SERVER['personUniqueID'], "maintainReservation") || checkAccessRights($_SERVER['personUniqueID'], "maintainTestbed")) {
   $isTestbedMaintainer = 1;
}

$fromTimestamp = strtotime("2000-01-01 00:00:00");
$from = strftime("%Y-%m-%d %H:%M:%S", $fromTimestamp);
$toTimestamp = strtotime("2020-12-31 23:59:59");
$to = strftime("%Y-%m-%d %H:%M:%S", $toTimestamp);

if($isTestbedMaintainer) {
    try {
        $myResArr = getMyReservationsAsTestbedMaintainer_onlyMine($from, $to, $userID);
    }
    catch (SoapFault $fault2)
    {
        $faultstring = "<b>Fault Message:</b> " . $fault2->faultstring  . "<br/> (<b>Error Code:</b> " . $fault2->faultcode . ")";
    }

}
else {
    try {
        $myResArr = getMyReservations($from, $to, $userID);
    }
    catch (SoapFault $fault2)
    {
        $faultstring = "<b>Fault Message:</b> " . $fault2->faultstring  . "<br/> (<b>Error Code:</b> " . $fault2->faultcode . ")";
    }
}
  
?>

<!--
*******************************************************************************
  div container for 'infoBox'
*************************************************************************** -->
<div id='resMyResInfoBox' class='infoBox'>
<div id='resMyResInfoText' class='infoText'>
<?php
if(checkAccessRights($_SERVER['personUniqueID'], "makingOwnReservation"))
{
    if(empty($faultstring))
    {
        echo "<p><strong>My Reservations:</strong> You can find your reservations and you can delete or configure them.</p>";
    }
    else
    {
        echo "<p><font color='#FF000'>" . $faultstring . "</font></p>";
        exit;
    }
}
else
{
    echo "<p><font color='#FF000'>" . "<strong>Error:</strong> You are not allowed to make reservations on the testbed!" . "</font></p>";
    exit;
}
?>
</div>
<div id='resCrossLine' class='crossLine'>
&nbsp;
</div>

</div> <!-- end div container 'infoBox' -->

<!--
*******************************************************************************
  div container for 'contentBox'
*************************************************************************** -->
<div id='resMyResContentBox' class='contentBox'>
<?php
//-----------------------------------------------------------------------------
//display resKeys

echo "<br/><br/><strong><font size='4'>My Reservations</font></strong><br/>";
    
//echo "myResArr: <pre>";
//print_r($myResArr);
//echo "</pre>";

//echo "reservationData: <pre>";
//count($myResArr->reservationData);
//echo "</pre>";

$ownExpiredReservationIds = array();

$myResCount = 0;
if(count($myResArr->reservationData)>0 || is_array($myResArr) ) { 
        
    //echo "inside count: <pre>";
    //print_r(count($myResArr->reservationData));
    //echo "</pre>";
    
    //echo "is array: <pre>";
    //print_r(is_array($myResArr));
    //echo "</pre>";
    
    if(count($myResArr->reservationData) == 1 && !is_array($myResArr))
    {
        $myResArr = array($myResArr->reservationData);
    }
    else if(count($myResArr->reservationData) == 0 && !is_array($myResArr))
    {
        $myResArr = $myResArr->reservationData;
    }
    else if(count($myResArr->reservationData) >= 1 && is_array($myResArr->reservationData)) {
        $myResArr = $myResArr->reservationData;
    }
    uasort($myResArr, "sortResCallback");   
    
    $finishedReservations = 0;
    $runningReservations = 0;
    $upcomingReservations = 0;
    
    foreach($myResArr as $myRes)
    {
        $myResCount++;
        $resKey = $myRes->data->secretReservationKey;
        $myExp = Db::getInstance()->getExperimentConfiguration($resKey);
        $fromTimestamp = strtotime($myRes->from);
        $toTimestamp = strtotime($myRes->to);
        $now = gmdate("Y-m-d H:i:s", time());
        $nowTimestamp = strtotime($now);

        if($fromTimestamp > $nowTimestamp && $toTimestamp > $nowTimestamp && $upcomingReservations == 0) {
            $upcomingReservations = 1;
            echo "<br/><br/><strong><font size='3'>Upcoming Reservations: </font></strong><br/><br/>";
        }
        if($fromTimestamp < $nowTimestamp && $toTimestamp < $nowTimestamp && $finishedReservations == 0) {
            $finishedReservations = 1;
            echo "<br/><br/><strong><font size='3'>Expired Reservations: </font></strong><br/><br/>";
        }
        if($fromTimestamp < $nowTimestamp && $toTimestamp > $nowTimestamp && $runningReservations == 0) {
            $runningReservations = 1;
            echo "<br/><br/><strong><font size='3'>Currently Scheduled Reservations: </font></strong><br/><br/>";
        }
        
        echo "<table style='border: 1px solid black'>";
        echo "<colgroup>";
        echo "<col width='200'/>";
        echo "<col width='500'/>";
        echo "</colgroup>";
        echo "<tr>";
        echo "<td><strong>User:</strong></td><td style='background-color:#F2F2F2'>" . $myRes->data->username . "</td>";
        echo "</tr>";
        echo "<tr>";
        echo "<td><strong>Experiment ID:</strong></td>" . "<td style='background-color:#F2F2F2'>" . $resKey . "</td>";
        echo "</tr>";
        echo "<tr>";
        echo "<td><strong>Name:       </strong></td>";
        
        if(empty($myExp))
        {
            echo "<td style='background-color:#F2F2F2'>" . "" . "</td>";
        }
        else
        {
            echo "<td style='background-color:#F2F2F2'>" . $myExp['exp_name'] . "</td>";
        }
        echo "</tr>";
        echo "<tr>";
        echo "<td style='vertical-align:top'><strong>Description: </strong></td>";
        if(empty($myExp))
        {
            echo "<td style='background-color:#F2F2F2'><i>no description supplied</i></td>";
        }
        else
        {
            echo "<td style='background-color:#F2F2F2'>" . $myExp['exp_description']. "</td>";
        }
        echo "<br/>";
        echo "</tr>";
        echo "<tr>";
        echo "<td><strong>Start: </strong></td><td style='background-color:#F2F2F2'>" . $myRes->from . "</td>";
        echo "</tr>";
        echo "<tr>";
        echo "<td><strong>End: </strong></td><td style='background-color:#F2F2F2'>" . $myRes->to . "</td>";
        echo "</tr>";
        echo "<tr>";
        
        if($fromTimestamp > $nowTimestamp)
        {
            echo "<td>" . "" . "</td>";
            echo "<td>";
            echo "<table border='0' width='100%' cellspacing='0' cellpadding='0'><tr>";
            if(empty($myExp))
            {
                echo "<td style='width:0' align='left'><form style='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='modifyResForm' action='../Reservation/resOverview.php' method='POST'><input type='submit' id='modifyRes' name='modifyRes' value='Modify Reservation'/><input name='resKey' type='hidden' value='" . $resKey . "'/></form></td>";
            }
            else
            {
                echo "<td style='width:0'>" . "</td>";
            }
            if(empty($myExp))
            {
                echo "<td style='width:33%' align='left'><form style='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='configExpForm' action='../ExperimentSetup/expSetupCfg.php' method='POST'><input type='submit' id='configExp' name='configExp' value='Configure Experiment'/><input name='resKey' type='hidden' value='" . $resKey . "'/></form></td>";
            }
            else
            {
                echo "<td style='width:33%' align='left'><form style='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='modifyExpForm' action='../ExperimentSetup/expSetupModExp.php' method='POST'><input type='submit' id='modifyExp' name='modifyExp' value='Modify Experiment'/><input name='resKey' type='hidden' value='" . $resKey . "'/></form></td>";
            }
            if(empty($myExp)) {
                echo "<td style='width:33%' align='right'><form style='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='delResForm' action='' method='POST'><input type='submit' id='deleteRes' name='deleteRes' value='Delete Reservation'><input name='deleteResKey' type='hidden' value='" . $resKey . "'/></form></td>";
            }
            else {
                echo "<td style='width:33%' align='right'><form style='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='delResForm' action='' method='POST'><input type='submit' id='deleteRes' name='deleteRes' value='Deletion disabled. Delete Experiment first!' disabled='disabled'><input name='deleteResKey' type='hidden' value='" . $resKey . "'/></form></td>";
            }
            echo "</tr></table>";
            echo "</td>";
        }
        else if($fromTimestamp < $nowTimestamp && $toTimestamp > $nowTimestamp && !empty($myExp))
        {
            echo "<td>" . "" . "</td>";
            echo "<td>";
            echo "<table border='0' width='100%' cellspacing='0' cellpadding='0'><tr>";
            echo "<td>" . "<i>experiment is running</i>" . "</td>";
            if(empty($myExp)) {
                echo "<td style='width:33%' align='right'><form style='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='delResForm' action='' method='POST'><input type='submit' id='deleteRes' name='deleteRes' value='Delete Reservation'><input name='deleteResKey' type='hidden' value='" . $resKey . "'/></form></td>";
            }
            else {
                echo "<td style='width:33%' align='right'><form style='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='delResForm' action='' method='POST'><input type='submit' id='deleteRes' name='deleteRes' value='Deletion disabled. Delete Experiment first!' disabled='disabled'><input name='deleteResKey' type='hidden' value='" . $resKey . "'/></form></td>";
            }
            echo "</tr></table>";
        }
        else if($fromTimestamp < $nowTimestamp && $toTimestamp > $nowTimestamp && empty($myExp))
        {
            echo "<td>" . "" . "</td>";
            echo "<td>";
            echo "<table border='0' width='100%' cellspacing='0' cellpadding='0'><tr>";
            echo "<td>" . "<i>no experiment configured</i>" . "</td>";
            if(empty($myExp)) {
                echo "<td style='width:33%' align='right'><form style='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='delResForm' action='' method='POST'><input type='submit' id='deleteRes' name='deleteRes' value='Delete Reservation'><input name='deleteResKey' type='hidden' value='" . $resKey . "'/></form></td>";
            }
            else {
                echo "<td style='width:33%' align='right'><form style='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='delResForm' action='' method='POST'><input type='submit' id='deleteRes' name='deleteRes' value='Deletion disabled. Delete Experiment first!' disabled='disabled'><input name='deleteResKey' type='hidden' value='" . $resKey . "'/></form></td>";
            }
            echo "</tr></table>";
        }
        else
        {
            echo "<td>" . "" . "</td>";
            echo "<td>";
            echo "<table border='0' width='100%' cellspacing='0' cellpadding='0'><tr>";
            echo "<td>" . "<i>experiment is finished</i>" . "</td>";
            array_push($ownExpiredReservationIds, $resKey);
                
            if(empty($myExp)) {
                echo "<td style='width:33%' align='right'><form style='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='delResForm' action='' method='POST'><input type='submit' id='deleteRes' name='deleteRes' value='Delete Reservation'><input name='deleteResKey' type='hidden' value='" . $resKey . "'/></form></td>";
            }
            else {
                echo "<td style='width:33%' align='right'><form style='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='delResForm' action='' method='POST'><input type='submit' id='deleteRes' name='deleteRes' value='Deletion disabled. Delete Experiment first!' disabled='disabled'><input name='deleteResKey' type='hidden' value='" . $resKey . "'/></form></td>";
            }
            echo "</tr></table>";
        }
        echo "</tr>";
        echo "</form>";
        echo "</table>";
    }
    
    if($finishedReservations > 0) { 
        echo "<br/>";
        echo "<table style='border: 1px solid black; margin-bottom:10px;'>\n";
        echo "<colgroup>\n";
        echo "<col width='350'/>\n";
        echo "<col width='350'/>\n";
        echo "</colgroup>\n";
        echo "<tr>";
        echo "<td><strong>Delete all your expired Reservations</strong></td>\n";
        echo "<td align='right'>";
        echo "<form style='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='ownResDeleteForm' action='resMyRes.php' method='POST'>";
        echo "<input type='submit' id='deleteAllOwnExpiredReservations' name='deleteAllOwnExpiredReservations' value='Delete all Reservations &amp; Results'/>";
        for($i=0; $i<count($ownExpiredReservationIds); $i++)
        {
            echo "<input name='ownReservations_" . $i . "' type='hidden' value='" . $ownExpiredReservationIds[$i]. "'/>";
        }
        echo "</form>";
        echo "</td>";
        echo "</tr>"; 
        echo "</table>";
    }
    
} // if count ( reservationData ) > 0 



if($myResCount == 0)
{
    echo "<br/>";
    echo "<br/><i>no <strong>reservations</strong> saved</i>";
    echo "<br/>";
}

echo "<br/>";


?>

</div> <!-- end div container 'contentBox' -->
<!-- ********************************************************************** -->


</div> <!-- end div container 'pageContent' -->
<!-- ********************************************************************** -->


<!-- closing body and html -->
  </body>
</html>
<!-- ********************************************************************** -->
