<!--
*******************************************************************************
  including Header and Menues
*************************************************************************** -->
<?php
    include '../include/header.php';
?>
<div id='pageHeader' class='pageHeader'>
<?php
    include '../include/menue.php';
    include './resMenue.php';
    require_once('../include/RSService/RSService.php');
    require_once('../include/functions.php');
?>
</div> <!-- end div container 'pageHeader' -->
<!-- ********************************************************************** -->

<!--
*******************************************************************************
  div container for 'pageContent'
*************************************************************************** -->
<div id='pageContent' class='pageContent'>    
<?php
    require_once('../include/configurations.php');
    require_once("../include/classes.inc.php");
    require_once("../include/functions.php");
    require_once('../include/RSService/RSService.php');
    
    Db::getInstance()->selectDB("wsn_info");
    $nodeStates = Db::getInstance()->areNodesAlive();
    //echo "<pre>";
    //print_r(Db::getInstance()->areNodesAlive());
    //echo "</pre>";
    
    $testbed_setup = "";

    try
    {
        $testbed_setup = getNetwork();
    }
    catch (SoapFault $fault)
    {
        $faultstring .= "<b>\'getNetwork\' call failed at SessionManager</b>"; 
        $faultstring .= "<br/>";
        $faultstring .= "<b>Fault Message:</b> " . $fault->faultstring  . "<br/> (<b>Error Code:</b> " . $fault->faultcode . ")";
        $faultstring .= "<br/>";
        $faultstring .= "<br/>";
    }
    
    $testbed_setup_xml = simplexml_load_string($testbed_setup);
    
    //if(is_object($testbed_setup)) {
        $testbed_setup_xml->registerXPathNamespace('default', 'http://wisebed.eu/ns/wiseml/1.0');
    //}
    //else {
    //    echo "<pre>";
    //    print_r($testbed_setup_xml);
    //    echo "</pre>";
    //}
    
    $nodesArr = $testbed_setup_xml->xpath('//default:setup/default:node');
    $default_setup = $testbed_setup_xml->xpath('//default:setup/default:defaults/default:node');
    $defaultNodeType = (string)$default_setup[0]->nodeType;
    
    $experimentsToEmails = array();
    $experimentsToUsers  = array();
        
    
    $nodeArrMap = array();
    foreach($nodesArr as $node)
    {
        $nodeUrn = xml_attribute($node, 'id');
        $nodeArrMap[] = $nodeUrn;
    }
    
    $nodeTypeMap = createNodeTypeMap($nodesArr, $defaultNodeType);
    $types = getAllTypes($nodeTypeMap);
    $nodes_sorted_by_nodetype = array();
    //sorting the nodes according to the type    
    foreach($types as $type)
    {
        $nodes_per_type = array();
        $ids = array();
        $identifiers_are_hex = true;
        foreach($nodeArrMap as $idx => $node_urn)
        {
            if($nodeTypeMap[$node_urn]==$type)
            {
                array_push($nodes_per_type, $node_urn);
                $divide = explode(":", $node_urn);  // splits the urn (UBERN:xx)
                $identifier = $divide[sizeof($divide)-1];
                if(strstr($identifier, "0x"))
                {
                  $identifiers_are_hex = $identifiers_are_hex && true;
                }
                else
                {
                  $identifiers_are_hex = $identifiers_are_hex && false;
                }
            }
        }
        if($identifiers_are_hex)
        {
          sort($nodes_per_type);
        }
        else
        {
          usort($nodes_per_type, "strnatcmp");
        }
        $nodes_sorted_by_nodetype = array_merge($nodes_sorted_by_nodetype, $nodes_per_type);        
    }
    
    
    
    if(!empty($_POST['modifyRes']))
    {
        $resToMod = getReservation($_POST['resKey']);
    }
    
    if(!empty($_GET))
    {
        $month = $_GET['m'];
        $year = $_GET['y'];
        if(!empty($_GET['d'])) {
            $day = $_GET['d'];
        }
        else {
            $day = 1;
        }
    }
    else if(!empty($resToMod))
    {
        $timeFormat = '%Y-%m-%dT%H:%M:%S';
        $dateTimeArr = strptime($resToMod->reservationData->from, $timeFormat);
        $month = $dateTimeArr['tm_mon'] + 1;
        $year = $dateTimeArr['tm_year'] + 1900;
        $day = $dateTimeArr['tm_mday'];
    }
    else
    {
        $month = gmdate("m", time());
        $year = gmdate("Y", time());
        $day = gmdate("d", time());
    }
    $currDay = $year . "-" . $month . "-" . $day;
    $currDay_from = $year . "-" . $month . "-" . $day . " " . "00:00:00";
    $currDay_to = $year . "-" . $month . "-" . $day . " " . "23:59:59";
    
    $userID = $_SERVER['personUniqueID'];
    
    if(!empty($_POST))
    {
        if(!empty($_POST['selectedArray']))
        {
            $selNodesArr = array();
            $tmpArray = array();
            $fromBlock = 0;
            $toBlock = 0;
            $token = explode(',', $_POST['selectedArray']);
    
            $timevals = array();
    
            foreach($token as $tok)
            {
                $tmp = explode('_', $tok);
                array_push($timevals, $tmp[0]);
    
                $selNodeUrn = $nodes_sorted_by_nodetype[$tmp[1]];
                $tmpArray[] = $selNodeUrn;
            }
            
            $fromBlock = min($timevals);
            $toBlock = max($timevals);
            $fromTimestamp = strtotime($currDay) + ($fromBlock * 15 * 60);
            $toTimestamp = strtotime($currDay) + (($toBlock + 1) * 15 * 60) - 1;
            $selNodesArr['from'] = strftime("%Y-%m-%d %H:%M:%S", $fromTimestamp);
            $selNodesArr['to'] = strftime("%Y-%m-%d %H:%M:%S", $toTimestamp);
            $selNodesArr['nodes'] = array_values(array_unique($tmpArray));
    
    
            if(!empty($_POST['modRes']))
            {
                deleteReservation($_POST['resKey'], $userID);
                try
                {
                    $newResKey = makeReservation($selNodesArr, $userID, "reserved");
                }
                catch (SoapFault $fault)
                {
                    $faultstring .= "<b>\'makeReservation\' call failed at ReservationSystem API</b>"; 
                    $faultstring .= "<br/>";
                    $faultstring .= "<b>Fault Message:</b> " . $fault->faultstring  . "<br/> (<b>Error Code:</b> " . $fault->faultcode . ")";
                    $faultstring .= "<br/>";
                    $faultstring .= "<br/>";
                }
            }
            if(!empty($_POST['makeRes']))
            {
                try
                {
                    $newResKey = makeReservation($selNodesArr, $userID, "reserved");
                }
                catch (SoapFault $fault)
                {
                    $faultstring .= "<b>\'makeReservation\' call failed at ReservationSystem API</b>"; 
                    $faultstring .= "<br/>";
                    $faultstring .= "<b>Fault Message:</b> " . $fault->faultstring  . "<br/> (<b>Error Code:</b> " . $fault->faultcode . ")";
                    $faultstring .= "<br/>";
                    $faultstring .= "<br/>";
                }
            }
        }
        else if(!empty($_POST['deleteRes']))
        {
            if(!empty($_POST['deleteResKey']))
            {
                deleteReservation($_POST['deleteResKey'], $userID);
            }
        }
    }
    
    try
    {
        $resArr = getReservations($currDay_from, $currDay_to);
    }
    catch (SoapFault $fault)
    {
        $faultstring .= "<b>getReservations call failed at the Reservation API</b>"; 
        $faultstring .= "<br/>";
        $faultstring .= "<b>Fault Message:</b> " . $fault->faultstring  . "<br/> (<b>Error Code:</b> " . $fault->faultcode . ")";
        $faultstring .= "<br/>";
        $faultstring .= "<br/>";
    }
   
    
    try
    {
        $myResArr = getMyReservations($currDay_from, $currDay_to, $userID);
    }
    catch (SoapFault $fault2)
    {
        $faultstring .= "<b>getMyReservations call failed at the Reservation API</b>"; 
        $faultstring .= "<br/>";
        $faultstring .= "<b>Fault Message:</b> " . $fault2->faultstring  . "<br/> (<b>Error Code:</b> " . $fault2->faultcode . ")";
        $faultstring .= "<br/>";
    }
    
    // if this is a testbed maintainer, add other user's experiments
    $isTestbedMaintainer = 0;
    if(checkAccessRights($_SERVER['personUniqueID'], "maintainReservation") || checkAccessRights($_SERVER['personUniqueID'], "maintainTestbed")) {
       $isTestbedMaintainer = 1;
    }
    
    
    if($isTestbedMaintainer){
        try {
        $otherUserResArr = getMyReservationsAsTestbedMaintainer_onlyOthers($currDay_from, $currDay_to, $userID);
        }
        catch (SoapFault $fault2)
        {
            $faultstring = "<b>Fault Message:</b> " . $fault2->faultstring  . "<br/> (<b>Error Code:</b> " . $fault2->faultcode . ")";
        }
        //echo "<pre>";
        //echo "<p>myRes</p>";
        //print_r($myResArr);
        //echo "</pre>";
        //echo "<p>otherUser</p>";
        //echo "<pre>";
        //print_r($otherUserResArr);
        //echo "</pre>";
        $myResArr = array_merge($myResArr, $otherUserResArr);
    }
    
    
    //echo "<pre>";
    //print_r($otherUserResArr);
    //echo "</pre>";
    
    $nodeStateMatrice = createNodeStateMatrice($nodesArr, $resArr->reservations, $myResArr, $currDay, $defaultNodeType);
    
    //echo "<pre>";
    //print_r($nodeStateMatrice);
    //echo "</pre>";
?>

<!--
*******************************************************************************
  div container for 'infoBox'
*************************************************************************** -->
<div id='resMyResInfoBox' class='infoBox'>
  <!-- Information text about the experiment (name, id, start, end, description) -->
  <div id='resMyResInfoText' class='infoText'>
    <?php
    
    if(checkAccessRights($_SERVER['personUniqueID'], "makeReservation"))
    {
      if(empty($faultstring))
      {
        echo "<p><strong>Reservation Schedule:</strong> Reserve the nodes you need for your experiment for your desired time period. To achieve this you can either</p>"; 
        echo "<p><strong>Click and Drag</strong> to select a rectangle (nodes vs. time) and <strong>Double-Click</strong> on a node to remove this node from the selected nodes of the rectangle <strong>OR</strong></p>";
        echo "<p><strong>Select (Click) </strong> the <strong>First</strong> and <strong>Last</strong> time slots</p>";
        echo "<p><strong>Click</strong> on the <strong>Reserve Button</strong> on the bottom of the page to finish your <strong>Reservation</strong></p>";
      }
      else
      {
        echo "<p><span style='color:#FF000'>" . $faultstring . "</span></p>";
        exit;
      }
    }
    else
    {
      echo "<p><span style='color:#FF000'>" . "<strong>Error:</strong> You are not allowed to make reservations on the testbed!" . "</span></p>";
      exit;
    }
    ?>
  </div>
  
  
  <div id='resCrossLine' class='crossLine'>
    &nbsp;
  </div>

</div> <!-- end div container 'infoBox' -->



<!--
*******************************************************************************
  div container for 'contentBox'
*************************************************************************** -->
<div id='resMyResContentBox' class='contentBox'>
<?php
    $dbreq = 0;
    //-----------------------------------------------------------------------------
    // display calendar
    $cal = getCalendarSheet($month, $year, $day);
    echo $cal;

    
    echo "<table width='100%' style='padding-right:10pt;'>" . "<tr>";
    if(!empty($newResKey->secretReservationKey->secretReservationKey))
    {
        echo "<td style='width:30%'>";
        echo "<p><font color='#339900'><b>Your reservation was successful!</b></font></p>";
        echo "</td>";
        echo "<td style='width:20%'>";
        echo "<form name='delResForm' action='' method='POST' style='margin:0;'>" . "<b></b> " . "<input type='submit' id='deleteRes' name='deleteRes' value='Undo Reservation'>" . "<input name='deleteResKey' type='hidden' value='" . $newResKey->secretReservationKey->secretReservationKey . "'/>" . "</form>";
        echo "</td>";
        echo "<td style=width:40%'>";
        echo "</td>";
        echo "<td style='width:10%'>";
        echo "<form name='configExpForm' action='../ExperimentSetup/expSetupCfg.php' method='POST' style='margin:0;'><input type='submit' id='configExp' name='configExp' value='Configure Experiment for Reservation'>" . "<input name='resKey' type='hidden' value='" . $newResKey->secretReservationKey->secretReservationKey . "'/>" . "</form>";
        echo "</td>";
    }
    else if(!empty($_POST['modifyRes']))
    {
        echo "<td style='width:100px' align='right'>";
        echo "<input type='submit' name='modRes' value='Modify Reservation' onclick='javascript:var param1=\"modRes\";var param2=\"" . $resToMod->reservationData->data->secretReservationKey . "\";setSubmitMod(param1, param2)'/>";
        echo "</td>";
    }
    else
    {
        echo "<td style='width:100px' align='right'>";
        echo "<input type='submit' name='makeRes' value='Submit Reservation' onclick='javascript:var param1=\"makeRes\";setSubmit(param1)'/>";
        echo "</td>";
    }
    echo "</tr></table>";
    
    
    
    //-----------------------------------------------------------------------------
    // display reservation sheet
    if(!empty($day))
    {
    	echo "<table width='100%' style='padding-right:10pt;'>";
    	echo "<tr>";
    	echo "<td>";
    	
    	echo "<table cellspacing='1' width='100%'>";
    	echo  "<tr>";
    	echo "<td></td>";
        echo "<td></td>";
        for($i = 0; $i < 24; $i++)
    	{
    		echo      "<td colspan='4' align='center' style='border-left: 1pt solid; border-color:#A50021;'>" . "<b>" . "<span style='color:#A50021'><font size='1' color='#A50021'>" . $i . ":00" . "</font></span>" . "</b>" . "</td>";
    	}
    	echo  "</tr>";
    	echo  "<tr>";
        echo "<td></td>";
        echo "<td></td>";
        for($i = 0; $i < 24; $i++)
    	{
    		echo    "<td align='center' style='border-left: 1pt solid; border-color:#A50021;'>";
    		echo    "<img src='../pics/clock15s.png' width='9px' height='9px' alt=''/></td>";
    		echo    "<td align='center'><img src='../pics/clock30s.png' width='8px' height='9px' alt=''/></td>";
    		echo    "<td align='center'><img src='../pics/clock45s.png' width='8px' height='9px' alt=''/></td>";
    		echo    "<td align='center'><img src='../pics/clock60s.png' width='8px' height='9px' alt=''/></td>";
    	}
    	echo  "</tr>";

    	$rowCount = 0;
        $currentType = $nodeTypeMap[$nodes_sorted_by_nodetype[0]];
    	
       
        
        $now = gmdate("Y-m-d H:i:s", time());
        $nowTimestamp = strtotime($now);            
                        
        
        foreach($nodes_sorted_by_nodetype as $node_urn)
    	{
            $divide = explode(":", $node_urn);  // splits the urn (UBERN:xx)
            $identifier = $divide[sizeof($divide)-1];
    
    	    if($nodeTypeMap[$node_urn] != $currentType) {
                $currentType = $nodeTypeMap[$node_urn];
                echo  "<tr>";
                for($j = 0; $j < 2; $j++)
                {
                    echo  "<td height='6px' style='background-color:#FFFFFF;'></td>";
                }
                echo  "</tr>";
            }
            
            echo "<tr>";
            
            if($nodeStates[$node_urn]>0) {
                echo "<td><img src='../pics/" . $nodeTypeMap[$node_urn] . ".png' width='12px' height='12px' title='node is alive'/></td><td style='padding-right:3pt;'><span style='color:#A50021'>" . $identifier . "</span></td>";
            }
            else {
                echo "<td><img src='../pics/exclamation.png' width='12px' height='12px' title='node is currently not alive'/></td><td style='padding-right:3pt;'><span style='color:#A50021'>" . $identifier . "</span></td>";
            }
            
            for($j = 0; $j < 96; $j++)
    		{
    			//draw a frame between the hours
    			if($j % 4 == 0)
    			{
    				echo  "<td style='border-left: 1pt solid; border-color:#A50021; ";
    			}
    			else
    			{
    				echo  "<td style='";
    			}
    			$blockState = $nodeStateMatrice[$node_urn][$j]['state'];
    			$user = $nodeStateMatrice[$node_urn][$j]['userID'];
    			//
    			$blockTimestamp = strtotime($currDay) + (($j+1) * 15 * 60) - 1;
    			if($blockState == 'free')
    			{
    				// time is expired
    				if($blockTimestamp < $nowTimestamp + 900)
    				{
    					echo  "background-color:#C0C0C0;'>" . generateUnselectableDiv($j,$rowCount, 'expired') ."</td>\n";
    				}
    				else
    				{
    					$blockStart = $year . "-" . $month . "-" . $day . " " . $j;
    					$formName = $node_urn . "_" . $year . "-" . $month . "-" . $day . "-" . $j;
    					echo  "background-color:#41A317;'>" . generateDIV($j,$rowCount, $node_urn) . "</td>\n";
    				}
    			}
    			else if($blockState == 'reserved')
    			{
    				if($user == $userID)
    				{
    					//if the resKey of this field is == resKey of the reservation that is to be modified, then add these fields to the "selectedArray" in the javascript
    					if($nodeStateMatrice[$node_urn][$j]['resKey'] == $resToMod->reservationData->data->secretReservationKey)
    					{
    						$reservationKey = $nodeStateMatrice[$node_urn][$j]['resKey'];
    						$from = $nodeStateMatrice[$node_urn][$j]['from'];
    						$to   = $nodeStateMatrice[$node_urn][$j]['to'];
    						echo  "background-color:#41A317;'>". generateDIV_toModify($j,$rowCount) . "</td>\n";
    					}
    					else  //else paint blue
    					{
    					    
    					    $reservationKey = $nodeStateMatrice[$node_urn][$j]['resKey'];
    						$from = $nodeStateMatrice[$node_urn][$j]['from'];
    						$to   = $nodeStateMatrice[$node_urn][$j]['to'];
    						// time is expired
    						if($blockTimestamp < $nowTimestamp + 900) {
    						   echo  "background-color:#666699;'>" . generateSpecialTypeDiv($j,$rowCount, 'reserved_expired', $user, $reservationKey, $from, $to, $isTestbedMaintainer) . "</td>\n";
                            }
                            else {
                               echo  "background-color:#333366;'>" . generateSpecialTypeDiv($j,$rowCount, $blockState, $user, $reservationKey, $from, $to, $isTestbedMaintainer) . "</td>\n";
                            }
                        }
    				}
    				else // other user: if we are admin, display other user properties
    				{
    				    $reservationKey = $nodeStateMatrice[$node_urn][$j]['resKey'];
    				    $email = '';   			
    				    if($isTestbedMaintainer) {
    				        if(array_key_exists($reservationKey, $experimentsToEmails)) {
    				            $email = $experimentsToEmails[$reservationKey];
    				            $user  = $experimentsToUsers[$reservationKey];
                                //echo  "key_exists; key=" . $reservationKey . " email=" . $email .";";
    				        }  
    				        else {
    				            Db::getInstance()->selectDB("wsn_info");
    				            $out = Db::getInstance()->getUserProperties($user);
    				            //echo "<pre>";
                                //print_r($out);
    				            //echo "</pre>";
    				            $dbreq++;
    				            $experimentsToEmails[$reservationKey] = $out['user_email'];
    				            $experimentsToUsers[$reservationKey]  = $out['user_unique_id'];
    				            $email = $experimentsToEmails[$reservationKey];
                                $user  = $experimentsToUsers[$reservationKey];
                                //echo  "else; key=" . $reservationKey . " email=" . $email .";";
    				        }
    				        
    				    }
    					$from = $nodeStateMatrice[$node_urn][$j]['from'];
    					$to   = $nodeStateMatrice[$node_urn][$j]['to'];    
    					// time is expired
    					if($blockTimestamp < $nowTimestamp + 900) {		
    					   echo  "background-color:#CC6666;'>" . generateSpecialTypeDiv($j,$rowCount, 'reserved_other_expired', $user, $email ,$from,$to, $isTestbedMaintainer) . "</td>\n";
    					}
    					else {
    					   echo  "background-color:#A50021;'>" . generateSpecialTypeDiv($j,$rowCount, $blockState, $user, $email ,$from,$to, $isTestbedMaintainer) . "</td>\n";    
    					}
    				}
    			}
    			else if($blockState == 'blocked')
    			{
    				echo  "background-color:#566D7E;'>" . generateSpecialTypeDiv($j,$rowCount, $blockState, $user, '','','', $isTestbedMaintainer) . "</td>\n";
    			}
    			else if($blockState == 'maintenance')
    			{
    				$from = $nodeStateMatrice[$node_urn][$j]['from'];
    				$to   = $nodeStateMatrice[$node_urn][$j]['to'];
    				echo  "background-color:#7E2217;'>" . generateSpecialTypeDiv($j,$rowCount, $blockState, $user, '',$from,$to, $isTestbedMaintainer) . "</td>\n";
    			}
    			else
    			{
    			    $blockState = 'localuser';
    			    $from = $nodeStateMatrice[$node_urn][$j]['from'];
                    $to   = $nodeStateMatrice[$node_urn][$j]['to'];
    				echo  "background-color:#AAAAAA;'>" . generateSpecialTypeDiv($j,$rowCount, $blockState, $user, '' ,$from,$to, $isTestbedMaintainer). "</td>\n";
    			}
    		}
    		echo  "</tr>";
    		$rowCount++;
    	}
    	echo "</table>";
    	echo "</td>";
    	echo "</tr>";
    	echo "</table>";
    }
    
    //-----------------------------------------------------------------------------
    // display the "Configure experiment" Button
    
    echo "<table width='100%' style='padding-right:10pt;'>" . "<tr>";
    if(!empty($newResKey->secretReservationKey->secretReservationKey))
    {
    	echo "<td style='width:30%'>";
    	echo "<p><font color='#339900'><b>Your reservation was successful!</b></font></p>";
    	echo "</td>";
    	echo "<td style='width:20%'>";
    	echo "<form name='delResForm' action='' method='POST' style='margin:0;'>" . "<b></b> " . "<input type='submit' id='deleteRes' name='deleteRes' value='Undo Reservation'>" . "<input name='deleteResKey' type='hidden' value='" . $newResKey->secretReservationKey->secretReservationKey . "'/>" . "</form>";
    	echo "</td>";
    	echo "<td style=width:40%'>";
    	echo "</td>";
    	echo "<td style='width:10%'>";
    	echo "<form name='configExpForm' action='../ExperimentSetup/expSetupCfg.php' method='POST' style='margin:0;'><input type='submit' id='configExp' name='configExp' value='Configure Experiment for Reservation'>" . "<input name='resKey' type='hidden' value='" . $newResKey->secretReservationKey->secretReservationKey . "'/>" . "</form>";
    	echo "</td>";
    }
    else if(!empty($_POST['modifyRes']))
    {
    	echo "<td style='width:100px' align='right'>";
    	echo "<input type='submit' name='modRes' value='Modify Reservation' onclick='javascript:var param1=\"modRes\";var param2=\"" . $resToMod->reservationData->data->secretReservationKey . "\";setSubmitMod(param1, param2)'/>";
    	echo "</td>";
    }
    else
    {
    	echo "<td style='width:100px' align='right'>";
    	echo "<input type='submit' name='makeRes' value='Submit Reservation' onclick='javascript:var param1=\"makeRes\";setSubmit(param1)'/>";
    	echo "</td>";
    }
    echo "</tr></table>";
    echo "<div id='selection'></div>";
?>

</div> <!-- end div container 'contentBox' -->
<!-- ********************************************************************** -->


</div> <!-- end div container 'pageContent' -->
<!-- ********************************************************************** -->


<!-- closing body and html -->
  </body>
</html>
<!-- ********************************************************************** -->
