<!--
*******************************************************************************
  including Header and Menues
*************************************************************************** -->
<?php
include '../include/header.php';
?>
<div id='pageHeader' class='pageHeader'>
<?php
include '../include/menue.php';
include 'testbedManMenu.php';
?>
</div> 
<!-- end div container 'pageHeader' -->
<!-- ********************************************************************** -->


<!--
*******************************************************************************
  div container for 'pageContent'
*************************************************************************** -->
<div id='pageContent' class='pageContent'>    
<?php
require_once('../include/configurations.php');
require_once("../include/classes.inc.php");
require_once("../include/functions.php");
require_once('../include/RSService/RSService.php');


$userID = $_SERVER['personUniqueID'];

if(!empty($_POST['deleteRes']))
{
    if(!empty($_POST['deleteResKey']))
    {
        deleteReservation($_POST['deleteResKey'], $userID);
    }
}


$testbed_setup = "";

try
{
    $testbed_setup = getNetwork();
}
catch (SoapFault $fault)
{
    $faultstring .= "<b>getNetwork call failed at the SessionManager API</b>"; 
    $faultstring .= "<br/>";
    $faultstring .= "<b>Fault Message:</b> " . $fault->faultstring  . "<br/> (<b>Error Code:</b> " . $fault->faultcode . ")";
    $faultstring .= "<br/>";
    $faultstring .= "<br/>";    
}

$testbed_setup_xml = simplexml_load_string($testbed_setup);
$testbed_setup_xml->registerXPathNamespace('default', 'http://wisebed.eu/ns/wiseml/1.0');
$nodesArr = $testbed_setup_xml->xpath('//default:setup/default:node');

$default_setup = $testbed_setup_xml->xpath('//default:setup/default:defaults/default:node');
$defaultNodeType = (string)$default_setup[0]->nodeType;


$nodeArrMap = array();
foreach($nodesArr as $node)
{
    $nodeUrn = xml_attribute($node, 'id');
    $nodeArrMap[] = $nodeUrn;
}

Db::getInstance()->selectDB("wsn_info");
$nodeStates = Db::getInstance()->areNodesAlive();

$nodeTypeMap = createNodeTypeMap($nodesArr, $defaultNodeType);
$types = getAllTypes($nodeTypeMap);
$nodes_sorted_by_nodetype = array();
//sorting the nodes according to the type    
foreach($types as $type)
{
    $nodes_per_type = array();
    $ids = array();
    $identifiers_are_hex = true;
    foreach($nodeArrMap as $idx => $node_urn)
    {
        if($nodeTypeMap[$node_urn]==$type)
        {
            array_push($nodes_per_type, $node_urn);
            $divide = explode(":", $node_urn);  // splits the urn (UBERN:xx)
            $identifier = $divide[sizeof($divide)-1];
            if(strstr($identifier, "0x"))
            {
              $identifiers_are_hex = $identifiers_are_hex && true;
            }
            else
            {
              $identifiers_are_hex = $identifiers_are_hex && false;
            }
        }
    }
    if($identifiers_are_hex)
    {
      sort($nodes_per_type);
    }
    else
    {
      usort($nodes_per_type, "strnatcmp");
    }
    $nodes_sorted_by_nodetype = array_merge($nodes_sorted_by_nodetype, $nodes_per_type);        
}

if(empty($_GET))
{
    $month = gmdate("m", time());
    $year = gmdate("Y", time());
    $day = gmdate("d", time());
}
else
{
    $month = $_GET['m'];
    $year = $_GET['y'];
    $day = $_GET['d'];
}
$currDay = $year . "-" . $month . "-" . $day;
$currDay_from = $year . "-" . $month . "-" . $day . " " . "00:00:00";
$currDay_to = $year . "-" . $month . "-" . $day . " " . "23:59:59";


Db::getInstance()->selectDB("wsn_info");

if(!empty($_POST))
{
    if(!empty($_POST['delRes']))
    {
        if(!empty($_POST['resKey']))
        {
            deleteReservation($_POST['resKey'], $userID);
            Db::getInstance()->deleteExperiment($_POST['resKey']);
        }
    }
    else if(!empty($_POST['delExp']))
    {
        if(!empty($_POST['resKey']))
        {
            Db::getInstance()->deleteExperiment($_POST['resKey']);
        }
    }

    if(!empty($_POST['selectedArray']))
    {
        //echo "<pre>";
        //print_r($_POST['selectedArray']);
        //echo "</pre>";
        $selNodesArr = array();
        $tmpArray = array();
        $fromBlock = 0;
        $toBlock = 0;
        $token = explode(',', $_POST['selectedArray']);
        $timevals = array();
    
        foreach($token as $tok)
        {
            $tmp = explode('_', $tok);
            array_push($timevals, $tmp[0]);
    
            $selNodeUrn = $nodes_sorted_by_nodetype[$tmp[1]];
            $tmpArray[] = $selNodeUrn;
        }
            
        $fromBlock = min($timevals);
        $toBlock = max($timevals);
        $fromTimestamp = strtotime($currDay) + ($fromBlock * 15 * 60);
        $toTimestamp = strtotime($currDay) + (($toBlock + 1) * 15 * 60) - 1;
        $selNodesArr['from'] = strftime("%Y-%m-%d %H:%M:%S", $fromTimestamp);
        $selNodesArr['to'] = strftime("%Y-%m-%d %H:%M:%S", $toTimestamp);
        $selNodesArr['nodes'] = array_values(array_unique($tmpArray));

        try
        {
            $newResKey = makeReservation($selNodesArr, $userID, "maintenance");
        }
        catch (SoapFault $fault)
        {
            $faultstring .= "<b>makeReservation call failed at the ReservationSystem API</b>"; 
            $faultstring .= "<br/>";
            $faultstring .= "<b>Fault Message:</b> " . $fault->faultstring  . "<br/> (<b>Error Code:</b> " . $fault->faultcode . ")";
            $faultstring .= "<br/>";
            $faultstring .= "<br/>"; 
        }
    }
}

try
{
    $resArr = getReservations($currDay_from, $currDay_to, $userID);
}
catch (SoapFault $fault)
{
    $faultstring .= "<b>getReservations call failed at the ReservationSystem API</b>"; 
    $faultstring .= "<br/>";
    $faultstring .= "<b>Fault Message:</b> " . $fault->faultstring  . "<br/> (<b>Error Code:</b> " . $fault->faultcode . ")";
    $faultstring .= "<br/>";
    $faultstring .= "<br/>"; 
}

try
{
    $allResArr = getAllReservations($currDay_from, $currDay_to, $userID);
}
catch (SoapFault $fault)
{
    $faultstring .= "<b>getAllReservations call failed at the ReservationSystem API</b>"; 
    $faultstring .= "<br/>";
    $faultstring .= "<b>Fault Message:</b> " . $fault->faultstring  . "<br/> (<b>Error Code:</b> " . $fault->faultcode . ")";
    $faultstring .= "<br/>";
    $faultstring .= "<br/>"; 
}


// if this is a testbed maintainer, filter out other users' experiments here
$isTestbedMaintainer = 0;
if(checkAccessRights($_SERVER['personUniqueID'], "maintainReservation") || checkAccessRights($_SERVER['personUniqueID'], "maintainTestbed")) {
    $isTestbedMaintainer = 1;
}


if($isTestbedMaintainer) {
    try {
        $myResArr = getMyReservationsAsTestbedMaintainer_onlyMine($currDay_from, $currDay_to, $userID);
    }
    catch (SoapFault $fault2)
    {
        $faultstring = "<b>Fault Message:</b> " . $fault2->faultstring  . "<br/> (<b>Error Code:</b> " . $fault2->faultcode . ")";
    }

    try {
        $otherUserResArr = getMyReservationsAsTestbedMaintainer_onlyOthers($currDay_from, $currDay_to, $userID);
    }
    catch (SoapFault $fault2)
    {
        $faultstring = "<b>Fault Message:</b> " . $fault2->faultstring  . "<br/> (<b>Error Code:</b> " . $fault2->faultcode . ")";
    }
    
    $myResArr = array_merge($myResArr, $otherUserResArr);
}

$nodeStateMatrice = createNodeStateMatrice($nodesArr, $resArr->reservations, $myResArr, $currDay, $defaultNodeType);
$experimentsToEmails = array();
$experimentsToUsers  = array();

//echo "otherUserResArr<pre>";
//print_r($otherUserResArr);
//echo "</pre>";
    
?>

<!--
*******************************************************************************
  div container for 'infoBox'
*************************************************************************** -->


<div id='testbedManResInfoBox' class='infoBox'>
<!-- Information text about the experiment (name, id, start, end, description) -->

<div id='testbedManResInfoText' class='infoText'>
<?php
if(checkAccessRights($_SERVER['personUniqueID'], "maintainReservation"))
{
    if(empty($faultstring))
    {
        echo "<p><strong>All Reservation Schedule:</strong> You can find all reservations of all users and you can delete or configure them.</p>";
    }
    else
    {
        echo "<p><font color='#FF000'>" . $faultstring . "</font></p>";
    }
}
else
{
    echo "<p><font color='#FF000'><strong>Error:</strong> You are not allowed to administrate reservations and experiments</font></p>";
    exit;
}
?>

</div>
<div id='testbedManResCrossLine' class='crossLine'>
&nbsp;
</div>

</div> <!-- end div container 'infoBox' -->

<!--
*******************************************************************************
  div container for 'contentBox'
*************************************************************************** -->

<div id='testbedManResContentBox' class='contentBox'>
<?php
// display calendar
$cal = getCalendarSheet($month, $year, $day);
echo $cal;

echo "<br/>";
echo "<br/>";
//-----------------------------------------------------------------------------
// display reservation sheet
if(!empty($day))
{
    echo "<table width='100%' style='padding-right:10pt;'>";
    echo "<tr>";
    echo "<td>";
    echo "<table cellspacing='1' width='100%'>";
    echo  "<tr>";
    echo "<td></td>";
    echo "<td></td>";
    for($i = 0; $i < 24; $i++)
    {
        echo      "<td colspan='4' align='center' style='border-left: 1pt solid; border-color:#A50021;'>" . "<b>" . "<font size='1' color='#A50021'>" . $i . ":00" . "</font>" . "</b>" . "</td>";
    }
    echo  "</tr>";
    echo  "<tr>";
    echo "<td></td>";
    echo "<td></td>";
    for($i = 0; $i < 24; $i++)
    {
        echo    "<td align='center' style='border-left: 1pt solid; border-color:#A50021;'>";
        echo    "<img src='../pics/clock15s.png' width='9px' height='9px'</td>";
        echo    "<td align='center'><img src='../pics/clock30s.png' width='9px' height='9px'</td>";
        echo    "<td align='center'><img src='../pics/clock45s.png' width='9px' height='9px'</td>";
        echo    "<td align='center'><img src='../pics/clock60s.png' width='9px' height='9px'</td>";

    }
    echo  "</tr>";

    $rowCount = 0;

    $isTestbedMaintainer = 0;
    if(checkAccessRights($_SERVER['personUniqueID'], "maintainReservation") || checkAccessRights($_SERVER['personUniqueID'], "maintainTestbed")) {
        $isTestbedMaintainer = 1;
    }
    
    $now = gmdate("Y-m-d H:i:s", time());
    $nowTimestamp = strtotime($now);            
              
    $currentType = $nodeTypeMap[$nodes_sorted_by_nodetype[0]];
        

    foreach($nodes_sorted_by_nodetype as $node_urn)
    {
        $divide = explode(":", $node_urn);  // splits the urn (UBERN:xx)
        $identifier = $divide[sizeof($divide)-1];
    
        if($nodeTypeMap[$node_urn] != $currentType) {
                $currentType = $nodeTypeMap[$node_urn];
                echo  "<tr>";
                for($j = 0; $j < 2; $j++)
                {
                    echo  "<td height='6px' style='background-color:#FFFFFF;'></td>";
                }
                echo  "</tr>";
        }
        
        echo  "<tr>";
        
        
        if($nodeStates[$node_urn]>0) {
                echo "<td><img src='../pics/" . $nodeTypeMap[$node_urn] . ".png' width='12px' height='12px' title='node is alive'/></td><td style='padding-right:3pt;'><span style='color:#A50021'>" . $identifier . "</span></td>";
        }
        else {
                echo "<td><img src='../pics/exclamation.png' width='12px' height='12px' title='node is currently not alive'/></td><td style='padding-right:3pt;'><span style='color:#A50021'>" . $identifier . "</span></td>";
        }
        
        for($j = 0; $j < 96; $j++)
        {
            //draw a frame between the hours
            if($j % 4 == 0)
            {
                echo  "<td style='border-left: 1pt solid; border-color:#A50021; ";
            }
            else
            {
                echo  "<td style='";
            }
            $blockState = $nodeStateMatrice[$node_urn][$j]['state'];
            $user = $nodeStateMatrice[$node_urn][$j]['userID'];
            //
            $blockTimestamp = strtotime($currDay) + (($j+1) * 15 * 60) - 1;
            if($blockState == 'free')
            {
                // time is expired
                if($blockTimestamp < $nowTimestamp + 900)
                {
                    echo  "background-color:#C0C0C0;'>" . generateUnselectableDiv($j,$rowCount, 'expired') ."</td>\n";
                }
                else
                {
                    $blockStart = $year . "-" . $month . "-" . $day . " " . $j;
                    $formName = $node_urn . "_" . $year . "-" . $month . "-" . $day . "-" . $j;
                    echo  "background-color:#41A317;'>" . generateDIV($j,$rowCount, $node_urn) . "</td>\n";
                }
            }
            else if($blockState == 'reserved')
            {
                if($user == $userID)
                {
                    //if the resKey of this field is == resKey of the reservation that is to be modified, then add these fields to the "selectedArray" in the javascript
                    if($nodeStateMatrice[$node_urn][$j]['resKey'] == $resToMod->reservationData->data->secretReservationKey)
                    {
                        $reservationKey = $nodeStateMatrice[$node_urn][$j]['resKey'];
                        $from = $nodeStateMatrice[$node_urn][$j]['from'];
                        $to   = $nodeStateMatrice[$node_urn][$j]['to'];
                        echo  "background-color:#41A317;'>". generateDIV_toModify($j,$rowCount) . "</td>\n";
                    }
                    else  //else paint blue
                    {

                        $reservationKey = $nodeStateMatrice[$node_urn][$j]['resKey'];
                        $from = $nodeStateMatrice[$node_urn][$j]['from'];
                        $to   = $nodeStateMatrice[$node_urn][$j]['to'];
                        // time is expired
                        if($blockTimestamp < $nowTimestamp + 900) {
                            echo  "background-color:#666699;'>" . generateSpecialTypeDiv($j,$rowCount, 'reserved_expired', $user, $reservationKey, $from, $to, $isTestbedMaintainer) . "</td>\n";
                        }
                        else {
                            echo  "background-color:#333366;'>" . generateSpecialTypeDiv($j,$rowCount, $blockState, $user, $reservationKey, $from, $to, $isTestbedMaintainer) . "</td>\n";
                        }
                    }
                }
                else
                {
                    $reservationKey = $nodeStateMatrice[$node_urn][$j]['resKey'];
                    $email = '';
                    if($isTestbedMaintainer) {
                         if(array_key_exists($reservationKey, $experimentsToEmails)) {
                                $email = $experimentsToEmails[$reservationKey];
                                $user  = $experimentsToUsers[$reservationKey];
                                //echo  "key_exists; key=" . $reservationKey . " email=" . $email .";";
                         }  
                         else {
                                Db::getInstance()->selectDB("wsn_info");
                                $out = Db::getInstance()->getUserProperties($user);
                                //echo "<pre>";
                                //print_r($out);
                                //echo "</pre>";
                                $dbreq++;
                                $experimentsToEmails[$reservationKey] = $out['user_email'];
                                $experimentsToUsers[$reservationKey]  = $out['user_unique_id'];
                                $email = $experimentsToEmails[$reservationKey];
                                $user  = $experimentsToUsers[$reservationKey];
                                //echo  "else; key=" . $reservationKey . " email=" . $email .";";
                         }

                    }
                    $from = $nodeStateMatrice[$node_urn][$j]['from'];
                    $to   = $nodeStateMatrice[$node_urn][$j]['to'];
                    // time is expired
                    if($blockTimestamp < $nowTimestamp + 900) {
                        echo  "background-color:#CC6666;'>" . generateSpecialTypeDiv($j,$rowCount, 'reserved_other_expired', $user, $email ,$from,$to, $isTestbedMaintainer) . "</td>\n";
                    }
                    else {
                        echo  "background-color:#A50021;'>" . generateSpecialTypeDiv($j,$rowCount, $blockState, $user, $email ,$from,$to, $isTestbedMaintainer) . "</td>\n";
                    }
                }
            }
            else if($blockState == 'blocked')
            {
                echo  "background-color:#566D7E;'>" . generateSpecialTypeDiv($j,$rowCount, $blockState, $user, '','','', $isTestbedMaintainer) . "</td>\n";
            }
            else if($blockState == 'maintenance')
            {
                $from = $nodeStateMatrice[$node_urn][$j]['from'];
                $to   = $nodeStateMatrice[$node_urn][$j]['to'];
                echo  "background-color:#7E2217;'>" . generateSpecialTypeDiv($j,$rowCount, $blockState, $user, '',$from,$to, $isTestbedMaintainer) . "</td>\n";
            }
            else
            {
                $blockState = 'localuser';
                $from = $nodeStateMatrice[$node_urn][$j]['from'];
                $to   = $nodeStateMatrice[$node_urn][$j]['to'];
                echo  "background-color:#AAAAAA;'>" . generateSpecialTypeDiv($j,$rowCount, $blockState, $user, '' ,$from,$to, $isTestbedMaintainer). "</td>\n";
            }
        }
        echo  "</tr>";
        $rowCount++;
    }
    echo "</table>";
    echo "</td>";
    echo "</tr>";
    echo "</table>";
}

//-----------------------------------------------------------------------------
//display submit buttons
echo "<table width='100%' style='padding-right:10pt;'>" . "<tr>";
if(!empty($newResKey->secretReservationKey->secretReservationKey))
{
    echo "<td style='width:30%'>";
    echo "<p><font color='#339900'><b>Your reservation was successful!</b></font></p>";
    echo "</td>";
    echo "<td width='30%'>";
    echo "<form name='delResForm' action='' method='POST' style='margin:0;'>" . "<b></b> " . "<input type='submit' id='deleteRes' name='deleteRes' value='Undo Blocking'>" . "<input name='deleteResKey' type='hidden' value='" . $newResKey->secretReservationKey->secretReservationKey . "'>" . "</form>";
    echo "</td>";
    echo "<td width='40%'>";
    echo "</td>";
    echo "<td width='10%'>";
    //echo "<form name='configExpForm' action='../ExperimentSetup/expSetupCfg.php' method='POST' style='margin:0;'><input type='submit' id='configExp' name='configExp' value='Configure Experiment for Reservation'>" . "<input name='resKey' type='hidden' value='" . $newResKey->secretReservationKey->secretReservationKey . "'>" . "</form>";
    echo "</td>";
}
else
{
    echo "<td width='100px'>";
    echo "<input type='submit' name='makeRes' value='block for maintenance' onclick='javascript:setSubmit()'>";
    echo "</td>";
}
echo "</tr></table>";
echo "<div id='selection'></div>";
echo "<br/>\n\n";
?>

<?php  

#################################################################################
#  MANAGE MAINTENANCE RELATED RESERVATIONS                                      #
#################################################################################

echo "<br/><strong><font size='4'>Maintenance-related Reservations: </font></strong><br/><br/>";

//echo "allResArr: <pre>";
//print_r($allResArr);
//echo "</pre>";

$maintenanceReservations=0;
if(!empty($allResArr))
{
    if(count($allResArr->reservationData) == 1)
    {
        $allResArr = array($allResArr->reservationData);
    }
    else
    {
        $allResArr = $allResArr->reservationData;
    }
    uasort($allResArr, "sortResCallback");
    
    foreach($allResArr as $allRes)
    {
        
        $resKey = $allRes->data->secretReservationKey;
        $thisExp = Db::getInstance()->getExperimentConfiguration($resKey);
        $fromTimestamp = strtotime($allRes->from);
        $toTimestamp = strtotime($allRes->to);
        $now = gmdate("Y-m-d H:i:s", time());
        $nowTimestamp = strtotime($now);

        if($fromTimestamp > $nowTimestamp && $toTimestamp > $nowTimestamp && empty($thisExp) && $allRes->userData == "maintenance")
        {
            $maintenanceReservations++;
            echo "<table style='border: 1px solid black'>";
            echo "<colgroup>";
            echo "<col width='200'>";
            echo "<col width='500'>";
            echo "</colgroup>";
            echo "<tr>";
            echo "<td><strong>User:</strong></td><td bgcolor='#F2F2F2'>" . $allRes->data->username . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td><strong>Experiment ID:</strong></td>" . "<td bgcolor='#F2F2F2'>" . $resKey . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td><strong>Name:       </strong></td>";
            echo "<td bgcolor='#F2F2F2'>" . "" . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td style='vertical-align:top'><strong>Description: </strong></td>";
            echo "<td bgcolor='#F2F2F2'><i>no description supplied</i></td>";
            echo "<br>";
            echo "</tr>";
            echo "<tr>";
            echo "<td><strong>Start: </strong></td><td bgcolor='#F2F2F2'>" . $allRes->from . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td><strong>End: </strong></td><td bgcolor='#F2F2F2'>" . $allRes->to . "</td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td>" . "" . "</td>";
            echo "<td>";
            echo "<table border='0' width='100%' cellspacing='0' cellpadding='0'><tr>";
            echo "<td width='50%'></td>";
            echo "<td width='50%' align='right'><form  STYLE='margin: 0px; padding: 0px;' enctype='multipart/form-data' align='right' name='delResForm' action='' method='POST'>\n";
            echo "<input type='submit' id='deleteRes' name='deleteRes' value='Delete Maintance Block'>\n";
            echo "<input name='deleteResKey' type='hidden' value='" . $resKey . "'/></form></td>\n";
            echo "</tr></table>";
            echo "</td>";
            echo "</tr>";
            echo "</form>";
            echo "</table>";
        }
    } // for each
}


if($maintenanceReservations==0) {
    echo "<br/><i>no <strong>maintenance </strong> reservations found</i><br/>";
}



#################################################################################
#  ONLY FOR THE TESTBED MAINTAINER VIEW: GIVE THE OPTION TO DELETE EXPERIMENTS  #
#################################################################################


if($isTestbedMaintainer) {

    // THE YET UNCONFIGURED EXPERIMENTS:
    echo "<br/>";
    echo "<br/>";

    //echo "otherUserResArr: <pre>";
    //print_r($otherUserResArr);
    //echo "</pre>";

    $otherExpArr = Db::getInstance()->getAllUpcomingOrDoneExperimentIDs();

    //echo "otherExpArr: <pre>";
    //print_r($otherExpArr);
    //echo "</pre>";

    echo "<br/><strong><font size='4'>Other Users Unconfigured Experiments:</font></strong><br/><br/>";
    //echo "otherUserResArr: <pre>";
    //print_r($otherUserResArr);
    //echo "</pre>";

    $numUnconfExps = 0;
    foreach($otherUserResArr as $myRes) {
        $resKey = $myRes->data->secretReservationKey;
        //echo "resKey: <pre>";
        //print_r($resKey);
        //echo "</pre>";
        // here, check if the resKey is also in the other user's experiment array! If yes, there's an
        // experiment in the experiment_info db!

        $fromTimestamp = strtotime($myRes->from);
        $toTimestamp = strtotime($myRes->to);
        $now = gmdate("Y-m-d H:i:s", time());
        $nowTimestamp = strtotime($now);

        if(!in_array($resKey, $otherExpArr) && $toTimestamp > $nowTimestamp)
        {
            $numUnconfExps++;
            echo "<table style='border: 1px solid black'>\n";
            echo "<colgroup>\n";
            echo "<col width='200'>\n";
            echo "<col width='500'>\n";
            echo "</colgroup>\n";
            echo "<tr>";
            echo "<td><strong>User:</strong></td><td bgcolor='#F2F2F2'>" . $myRes->data->username . "</td>\n";
            echo "</tr>";
            echo "<tr>";
            echo "<td><strong>Experiment ID:</strong></td>" . "<td bgcolor='#F2F2F2'>" . $resKey . "</td>\n";
            echo "</tr>";
            echo "<tr>";
            echo "<td><strong>Name:       </strong></td>" . "<td bgcolor='#F2F2F2'>" . "" . "</td>\n";
            echo "</tr>";
            echo "<tr>";
            echo "<td style='vertical-align:top'><strong>Description: </strong></td>";
            echo "<td bgcolor='#F2F2F2'><i>no description supplied</i></td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td><strong>Start: </strong></td><td bgcolor='#F2F2F2'>" . $myRes->from . "</td>\n";
            echo "</tr>";
            echo "<tr>";
            echo "<td><strong>End: </strong></td><td bgcolor='#F2F2F2'>" . $myRes->to . "</td>\n";
            echo "</tr>";
            echo "<tr>";
            $fromTimestamp = strtotime($myRes->from);
            $toTimestamp = strtotime($myRes->to);
            $now = gmdate("Y-m-d H:i:s", time());
            $nowTimestamp = strtotime($now);
            //$nowTimestamp = strtotime("now");
            if($toTimestamp > $nowTimestamp )
            {
                echo "<td>" . "" . "</td>";
                echo "<td>";
                echo "<table border='0' width='100%' cellspacing='0' cellpadding='0'><tr>";
                echo "<td width='50%'></td>";
                echo "<td width='50%' align='right'><form  STYLE='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='delExpForm' action='' method='POST'><input type='submit' id='delRes' name='delRes' value='Delete Experiment & Reservation'><input name='resKey' type='hidden' value='" . $resKey . "'/></form></td>";
                echo "</tr></table>";
                echo "</td>";
            }
            echo "</tr>";
            echo "</form>";
            echo "</table>";
            echo "<br/>";
        }
    } // foreach

    if($numUnconfExps == 0 || empty($otherUserResArr) )
    {
        echo "<br/><i>no <strong>unconfigured</strong> experiments saved</i><br/>";
        echo "<br/>";
    }
    else {
        echo "<br/>";
    }

    echo "<br/>";
    echo "<br/><strong><font size='4'>Other Users Configured Experiments:</font></strong><br/><br/>";

    //echo "otherUserResArr: <pre>";
    //print_r($otherUserResArr);
    //echo "</pre>";
    
    $numConfExps = 0;

    foreach($otherUserResArr as $myRes) {
        $resKey = $myRes->data->secretReservationKey;
        //echo "resKey: <pre>";
        //print_r($resKey);
        //echo "</pre>";
        // here, check if the resKey is also in the other user's experiment array! If yes, there's an
        // experiment in the experiment_info db!
        
        $fromTimestamp = strtotime($myRes->from);
        $toTimestamp = strtotime($myRes->to);
        $now = gmdate("Y-m-d H:i:s", time());
        $nowTimestamp = strtotime($now);
            

        if(in_array($resKey, $otherExpArr) && $toTimestamp > $nowTimestamp)
        {
            $numConfExps++;
            echo "<table style='border: 1px solid black'>\n";
            echo "<colgroup>\n";
            echo "<col width='200'>\n";
            echo "<col width='500'>\n";
            echo "</colgroup>\n";
            echo "<tr>";
            echo "<td><strong>User:</strong></td><td bgcolor='#F2F2F2'>" . $myRes->data->username . "</td>\n";
            echo "</tr>";
            echo "<tr>";
            echo "<td><strong>Experiment ID:</strong></td>" . "<td bgcolor='#F2F2F2'>" . $resKey . "</td>\n";
            echo "</tr>";
            echo "<tr>";
            echo "<td><strong>Name:       </strong></td>" . "<td bgcolor='#F2F2F2'>" . "" . "</td>\n";
            echo "</tr>";
            echo "<tr>";
            echo "<td style='vertical-align:top'><strong>Description: </strong></td>";
            echo "<td bgcolor='#F2F2F2'><i>no description supplied</i></td>";
            echo "</tr>";
            echo "<tr>";
            echo "<td><strong>Start: </strong></td><td bgcolor='#F2F2F2'>" . $myRes->from . "</td>\n";
            echo "</tr>";
            echo "<tr>";
            echo "<td><strong>End: </strong></td><td bgcolor='#F2F2F2'>" . $myRes->to . "</td>\n";
            echo "</tr>";
            echo "<tr>";
            if($toTimestamp > $nowTimestamp )
            {
                echo "<td>" . "" . "</td>";
                echo "<td>";
                echo "<table border='0' width='100%' cellspacing='0' cellpadding='0'><tr>";
                echo "<td width='50%'></td>";
                echo "<td width='50%' align='right'><form  STYLE='margin: 0px; padding: 0px;' enctype='multipart/form-data' name='delExpForm' action='' method='POST'>";
                echo "<input type='submit' id='delRes' name='delRes' value='Delete Experiment & Reservation'>";
                echo "<input name='resKey' type='hidden' value='" . $resKey . "'/></form></td>";
                echo "</tr></table>";
                echo "</td>";
            }
            echo "</tr>";
            echo "</form>";
            echo "</table>";
            echo "<br/>";
        }
    } // foreach

    if($numConfExps == 0 || empty($otherUserResArr) )
    {
        echo "<br/><i>no <strong>configured</strong> experiments saved</i><br/>";
        echo "<br/>";
    }
    else {
        echo "<br/>";
    }

} // if $isTestbedMaintainer


?>

</div> <!-- end div container 'contentBox' -->
<!-- ********************************************************************** -->


</div> <!-- end div container 'pageContent' -->
<!-- ********************************************************************** -->


<!-- closing body and html -->
  </body>
</html>
<!-- ********************************************************************** -->
