<!--
*******************************************************************************
  including Header and Menues
*************************************************************************** -->
<?php
include '../include/header.php';
?>
<div id='pageHeader' class='pageHeader'>
<?php
include '../include/menue.php';
?>
</div>
<!-- ********************************************************************** -->

<!--
*******************************************************************************
  div container for content
*************************************************************************** -->
<div id='pageContent' class='pageContent'>

<?php
  require_once('../include/configurations.php');
  require_once('../include/functions.php');
  require_once('../include/Db.class.php');
  
  global $config;
  
  Db::getInstance()->selectDB("wsn_info");
  Db::getInstance()->addUser($_SERVER);
  
  $viewNet = checkAccessRights($_SERVER['personUniqueID'], "viewNetwork");
  $makeRes = checkAccessRights($_SERVER['personUniqueID'], "makeReservation");
  $getRes = checkAccessRights($_SERVER['personUniqueID'], "getReservations");
  $delRes = checkAccessRights($_SERVER['personUniqueID'], "deleteReservation");
  $makeOwnRes = checkAccessRights($_SERVER['personUniqueID'], "makingOwnReservation");
  $createExp = checkAccessRights($_SERVER['personUniqueID'], "createExperiment");
  $adminRes = checkAccessRights($_SERVER['personUniqueID'], "maintainReservation");
  $adminTARWIS = checkAccessRights($_SERVER['personUniqueID'], "maintainTARWIS");
  
  $tarwisViewer = 0;
  $tarwisUser = 0;
  $tarwisAdmin = 0;
  
  if($viewNet == 1)
  {
    $tarwisViewer = 1;
  }
  if($makeRes == 1 && $getRes == 1 && $makeOwnRes == 1 && $createExp == 1 && $viewNet == 1 && $delRes == 1)
  {
    $tarwisUser = 1;
  }
  if($makeRes == 1 && $getRes == 1 && $makeOwnRes == 1 && $createExp == 1 && $viewNet == 1 && $delRes == 1  && $adminRes == 1  && $adminTARWIS == 1)
  {
    $tarwisAdmin = 1;
  }
  
  echo "<p>Welcome to <strong>TARWIS</strong>, the <strong>Testbed Management Architecture for Wireless Sensor Networks</strong> of the <strong>WISEBED</strong> project.</p>";
  echo "<p>This <strong>TARWIS</strong> Deployment administers the Testbed of <strong>" . $config['ORGANIZATION_NAME'] . "</strong></p>";
  echo "<br/>";
  
  echo "<p><strong>TARWIS</strong> offers four Testbed Service Categories of sensor node resources: </p>";
  echo "<strong>Reservation</strong>, <strong>Experiment Configuration</strong>, <strong>Experiment Monitoring</strong>, and <strong>Testbed Management</strong>";
  echo "<br/><br/>";
  
  echo "<p> You have the following roles in the TARWIS deployment at " . $config['ORGANIZATION_NAME'] . ":</p>";
  if($tarwisViewer)
    echo "<strong>TARWISViewer</strong> ";
  if($tarwisUser)
    echo "<strong>TARWISUser</strong> ";
  if($tarwisAdmin)
    echo "<strong>TARWISAdmin</strong> ";
  echo "<br/>";
  
  echo "<br/>";
  echo "<br/>";
  
  echo "You can register for further roles at the <a style='color:#A50021;text-decoration:none;font-weight:bold;' href='" . $config['SNA_GUI_URL'] . "'>SNA Portal</a>.</p>";
?>
</div>

<!-- closing body and html -->
  </body>
</html>
<!-- ********************************************************************** -->

