<?php

class Db
{
  private static $instance = NULL;
  private $dbHost;
  private $dbUser;
  private $dbPassword;
  private $dbDatabase;

//*****************************************************************************
  	
//Constructor:
//  - connects to the MySQL server
private function __construct()
{
  global $config;
  $this->dbHost = $config['MYSQL_DATABASE_HOST'];
  $this->dbUser = $config['MYSQL_DATABASE_USER'];
  $this->dbPassword = $config['MYSQL_DATABASE_PASSWORD'];
  $this->dbDatabase = $config['MYSQL_DATABASE_NAME'];

  //connect to DB
  mysql_connect($this->dbHost, $this->dbUser, $this->dbPassword)
    or die("No connection to MySQL server: " . mysql_error());
}
		
//*****************************************************************************

//getInstance:
//  - returns the instance of the Db object
//  - Db is singleton, there is only one instance
public static function getInstance()
{
  if (self::$instance === NULL)
  {
    self::$instance = new Db();
  }
  return self::$instance;
}
		
//*****************************************************************************

//selectDB:
//  - selects the given DB
public function selectDB()
{
  mysql_select_db($this->dbDatabase);
}


//*****************************************************************************

//updateSnConfiguration:
//  - updates the name, type, and 3d pos of a the given sensor node
public function updateSnConfiguration($postArray)
{
  if(!empty($postArray))
  {   
    $currTimeStr = date('Y-m-d H:i:s');
    $updatePosQuery = "UPDATE sensornodes_positions SET x='" . $postArray['x3D'] . "', y='" . $postArray['y3D'] . "', z='" . $postArray['z3D'] . "' WHERE node_urn='" . $postArray['id'] . "';";
    $updatePosResult = mysql_query($updatePosQuery)
      or die("DB.updateSNConfiguration: Request for pos update failed: " . mysql_error());

    foreach($postArray['prop'] as $propID => $propVal)
    {
      if(!empty($propVal))
      {
        $selPropStr = "SELECT value FROM sensornodes WHERE node_urn='" . $postArray['id'] . "' AND prop_id='" . $propID . "';";
        $selPropResult = mysql_query($selPropStr)
          or die("DB.updateSNConfiguration: Request for existing properties failed: " . mysql_error());
        $line = mysql_fetch_assoc($selPropResult);

        //if this property exists in DB, then update it
        if(!empty($line))
        {
          //if the value has bnot been changed
          if(strcmp($line['value'], $propVal) != 0)
          {
            $updatePropQuery = "UPDATE sensornodes SET value='" . $propVal . "', time='" . $currTimeStr . "' WHERE node_urn='" . $postArray['id'] . "' AND prop_id='" . $propID . "';";
            $updatePropResult = mysql_query($updatePropQuery)
              or die("DB.updateSNConfiguration: Request for pos update failed: " . mysql_error());        
          }
        }
        else //if this property NOT exist, create new entry in DB
        {
          $insertPropQuery = "INSERT INTO sensornodes VALUES('" . $postArray['id'] . "', " . $propID . ", '" . $propVal . "', '" . $currTimeStr . "', 0);";
          $insertPropResult = mysql_query($insertPropQuery)
            or die("DB.addNewSensorNode: Request for pos insert failed: " . mysql_error());          
        }
      }
    } 
  }
  return $postArray['id'];
}

//*****************************************************************************

//addNewSensorNode
//  - inserts a new sensor node into the database (including id, name, type, 3d pos)
public function addNewSensorNode($postArray)
{
  if(!empty($postArray))
  {
    $currTimeStr = date('Y-m-d H:i:s');
    $insertPosQuery = "INSERT INTO sensornodes_positions (node_urn, x, y, z) VALUES('" . $postArray['id'] . "', " . $postArray['x3D'] . ", " . $postArray['y3D'] . ", " . $postArray['z3D'] . ");";
    $insertPosResult = mysql_query($insertPosQuery)
      or die("DB.addNewSensorNode: Request for pos insert failed: " . mysql_error());
      
    foreach($postArray['prop'] as $propID => $propVal)
    {
      if(!empty($propVal))
      {
        $insertPropQuery = "INSERT INTO sensornodes VALUES('" . $postArray['id'] . "', " . $propID . ", '" . $propVal . "', '" . $currTimeStr . "', 0);";
        $insertPropResult = mysql_query($insertPropQuery)
          or die("DB.addNewSensorNode: Request for prop insert failed: " . mysql_error());
      }
    }
  }
  return $postArray['id'];
}


//*****************************************************************************

//deleteSensorNode
//  - inserts a new sensor node into the database (including id, name, type, 3d pos)
public function deleteSensorNode($postArray)
{
  if(!empty($postArray))
  {
    $deleteSNQuery = "DELETE FROM sensornodes_positions WHERE node_urn='" . $postArray['id'] . "';";
    $deleteSNResult = mysql_query($deleteSNQuery)
      or die("DB.deleteSensorNode: Request for deleting sensornode positions failed: " . mysql_error());
      
    $deletePropQuery = "DELETE FROM sensornodes WHERE node_urn='" . $postArray['id'] . "';";
    $deletePropResult = mysql_query($deletePropQuery)
      or die("DB.deleteSensorNode: Request for deleting properties failed: " . mysql_error());
      
    $deleteLinksQuery = "DELETE FROM sensornode_network WHERE node_urn='" . $postArray['id'] . "' OR node_urn_neighbor='". $postArray['id'] . "';";
    $deleteLinksResult = mysql_query($deleteLinkQuery);
      //or die("DB.deleteSensorNode: Request for deleting links failed: " . mysql_error());
  }
}

//*****************************************************************************

public function addUser($serverArray)
{

  $insertStr = "REPLACE INTO users (user_unique_id, user_firstname, user_name, user_email) VALUES ('" . $serverArray['personUniqueID'] . "','" . $serverArray['Shib-WISEBEDPerson-givenName'] . "','" . $serverArray['Shib-WISEBEDPerson-surname'] . "','" . $serverArray['Shib-WISEBEDPerson-mail'] . "')";
  $result = mysql_query($insertStr);
}



//*****************************************************************************

//addNewImage
//  - inserts a new image into the database
public function addNewImage($postArray)
{
  //sql query string for INSERT
  $insertImageString = "INSERT INTO images (image_name, image_version, image_platform, image_description, image_file_name, image_file_size, image_file, image_time, image_usecs, image_visible, exp_user_unique_id) VALUES ('" . $postArray['img_name'] . "','" . $postArray['img_version'] . "','" . $postArray['img_platform'] . "','" . $postArray['img_description'] . "','" . $postArray['img_file_name'] . "','" . $postArray['img_file_size'] . "','" . $postArray['img_file'] . "','" . $postArray['img_file_datetime'] . "','" . $postArray['img_file_usecs'] . "','1', '" . $postArray['exp_user_unique_id'] . "');";
  
  //Writes the information to the database
  $result = mysql_query($insertImageString) or die("DB.addNewImage: Request for inserting image failed (image name probably already taken) : " . mysql_error());
  $imgID = mysql_insert_id();
  return $imgID;
}

//*****************************************************************************

//updateImage
//  - updates an existing image in the database
public function updateImage($postArray)
{
  
  //sql query string for UPDATE (without file uploading)
  if(empty($postArray['img_file_name']))
  {
    $updateImageString = "UPDATE images SET image_name='" . $postArray['img_name'] . "', image_version='" . $postArray['img_version'] . "', image_platform='" . $postArray['img_platform'] . "', image_description='" . $postArray['img_description'] . "', image_time='" . $postArray['img_file_datetime'] . "' WHERE image_id=" . $postArray['img_id'] . ";";
  }
  else //sql query string for UPDATE (complete)
  {
    $updateImageString = "UPDATE images SET image_name='" . $postArray['img_name'] . "', image_version='" . $postArray['img_version'] . "', image_platform='" . $postArray['img_platform'] . "', image_description='" . $postArray['img_description'] . "', image_file_name='" . $postArray['img_file_name'] . "', image_file_size=" . $postArray['img_file_size'] . ", image_file='" . $postArray['img_file'] . "', image_time='" . $postArray['img_file_datetime'] . "', image_usecs=" . $postArray['img_file_usecs'] . " WHERE image_id=" . $postArray['img_id'] . ";";
  }
  
  //Writes the information to the database
  $result = mysql_query($updateImageString)
    or die("updateImage: " . mysql_error());
  return $postArray['img_id'];
}

//*****************************************************************************

//deleteImage
//  - deletes an existing image from the database
public function deleteImage($postArray)
{
  $deleteImageString = "UPDATE images SET image_visible='0' WHERE image_id=" . $postArray['img_id'] . ";";
  $result = mysql_query($deleteImageString) or die("deleteImage: " . mysql_error());
  return $result;
}


//*****************************************************************************

//getImageFile
//  - returns the file name and the data of a given imageID
public function getImageFile($imgID)
{
  $getImageString = "SELECT image_file_name, image_file FROM images WHERE image_id=" . $imgID . ";";
  $result = mysql_query($getImageString)
    or die("getImageFile: " . mysql_error());
  while ($line = mysql_fetch_assoc($result))
  {
    $resArray['image_file_name'] = $line['image_file_name'];
    $resArray['image_file'] = $line['image_file'];
  }
  return $resArray;
}

//*****************************************************************************

//addNewExperimentConfiguration
//  - inserts a new experiment into the database
//  - affected tables: experiment_info and experiment_network
public function addNewExperimentConfiguration($postArray, $serverArray)
{
  $visibility = 0;
  if($postArray['exp_visibility'] == "public")
  {
    $visibility = 1;
  }
  //inserts the experiment configuration (id, name, desc, start, end, userGroup) in the experiment_info table
  $insertExpStr = "INSERT INTO experiment_info (exp_id, exp_name, exp_description, exp_start_time, exp_end_time, exp_user_unique_id, exp_user_email, exp_visibility, exp_done, exp_runs) VALUES ('" . $postArray['exp_id'] . "','" . $postArray['exp_name'] . "','" . $postArray['exp_desc'] . "','" . $postArray['exp_start_time'] . "','" . $postArray['exp_end_time'] . "','" . $serverArray['personUniqueID'] . "','" . $serverArray['Shib-WISEBEDPerson-mail'] . "'," . $visibility . ",'0'," . $postArray['iterations'] . ");";
  $result = mysql_query($insertExpStr);
  
  //inserts the selected nodes with the selected images into the experiment_network table
  foreach($postArray['snNodes'] as $key => $val)
  {
    //extract the image ID (string = "imageID,imageName")
    $tmp = split(",", $val);
    $imageID = $tmp[0];
    //$insertExpNetStr = "INSERT INTO experiment_network VALUES ('" . $postArray['exp_id'] . "','" . $key . "'," . $imageID . ");";
    $insertExpNetStr = "INSERT INTO experiment_network SET node_urn='" . $key. "', exp_id='" . $postArray['exp_id'] . "', image_id='" . $imageID . "';";
    $result2 = mysql_query($insertExpNetStr);
  }
}


//*****************************************************************************
public function insertAutomatedCommand($postArray, $serverArray)
{
  $insertExpStr = "INSERT IGNORE INTO automatedCommands (exp_id, node_urn, command, seconds_after_flash) VALUES ('" . $postArray['exp_id'] . "','" . $postArray['automated_command_input_node'] . "','" . $postArray['command'] . "','" . $postArray['seconds'] . "');";
  $result = mysql_query($insertExpStr) or die("insertAutomatedCommand : Request for update failed: " . mysql_error());
}


//*****************************************************************************
public function insertAutomatedCommandArgs($exp_id, $node_urn, $command, $seconds_after_flash)
{
  $insertExpStr = "INSERT IGNORE INTO automatedCommands (exp_id, node_urn, command, seconds_after_flash) VALUES ('" . $exp_id . "','" . $node_urn . "','" . $command . "','" . $seconds_after_flash . "');";
  $result = mysql_query($insertExpStr) or die("insertAutomatedCommand : Request for update failed: " . mysql_error());
}

//*****************************************************************************
public function insertAutomatedTemplatedCommand($template_id, $node_urn, $command, $seconds_after_flash)
{
  $insertExpStr = "INSERT IGNORE INTO templated_commands (template_id, node_urn, command, seconds_after_flash) VALUES ('" . $template_id . "','" . $node_urn . "','" . $command . "','" . $seconds_after_flash . "');";
  $result = mysql_query($insertExpStr) or die("insertAutomatedCommand : Request for update failed: " . mysql_error());
}

//*****************************************************************************
public function deleteTemplatedNodeImage($template_id, $node_urn)
{
  $insertExpStr = "DELETE FROM templated_nodes_images WHERE template_id='" . $template_id . "' AND node_urn='" . $node_urn . "';";
  $result = mysql_query($insertExpStr) or die("deleteTemplatedNodeImage : Request for update failed: " . mysql_error());
}


//*****************************************************************************
public function insertTemplatedNodeImage($template_id, $node_urn, $image_id)
{
  $insertExpStr = "INSERT IGNORE INTO templated_nodes_images (template_id, node_urn, image_id) VALUES ('" . $template_id . "','" . $node_urn . "','" . $image_id . "');";
  $result = mysql_query($insertExpStr) or die("insertTemplatedNodeImage : Request for update failed: " . mysql_error());
}


//*****************************************************************************
public function deleteAutomatedTemplatedNodeImages($template_id)
{
  $deleteString = "DELETE FROM templated_nodes_images WHERE template_id = '" . $template_id . "';";
  $result = mysql_query($deleteString) or die("deleteAutomatedTemplatedNodeImages : Request for update failed: " . mysql_error());
}

//*****************************************************************************
public function deleteAutomatedTemplatedCommands($template_id)
{
  $deleteString = "DELETE FROM templated_commands WHERE template_id = '" . $template_id . "';";
  $result = mysql_query($deleteString) or die("deleteAutomatedTemplatedCommands : Request for update failed: " . mysql_error());
}

//*****************************************************************************
public function deleteTemplate($template_id)
{
  $deleteString = "DELETE FROM experiment_templates WHERE template_uniqueID = '" . $template_id . "';";
  $result = mysql_query($deleteString) or die("deleteTemplate : Request for update failed: " . mysql_error());
}



//*****************************************************************************
public function deleteAutomatedCommand($commandID)
{
  //inserts the experiment configuration (id, name, desc, start, end, userGroup) in the experiment_info table
  $insertExpStr = "DELETE FROM automatedCommands WHERE command_id='" . $commandID . "';";
  $result = mysql_query($insertExpStr) or die("deleteAutomatedCommand : Request for update failed: " . mysql_error() . " query: " . $insertExpStr );
}

//*****************************************************************************
public function getAutomatedCommands($exp_id)
{
  $automatedCommandsArray = array();
  
  $insertExpStr = "SELECT node_urn, command, command_id, seconds_after_flash FROM automatedCommands  WHERE exp_id = '" . $exp_id . "' ORDER BY seconds_after_flash;";
  $selectRes = mysql_query($insertExpStr) or die("getAutomatedCommands: Request for automatedCommands failed: " . mysql_error());
  while ($line = mysql_fetch_assoc($selectRes))
  {
    $commandEntry['node_urn']            = $line['node_urn'];
    if(strpos($line['node_urn'], "broadcast")!==false) {
    	$commandEntry['node_urn'] = 'all nodes';
    }
    $commandEntry['seconds_after_flash'] = $line['seconds_after_flash'];
    $commandEntry['command']             = $line['command'];
    $commandEntry['command_id']          = $line['command_id'];
    array_push($automatedCommandsArray, $commandEntry);       
  }
  return $automatedCommandsArray;
}



//*****************************************************************************
public function getTemplatedAutomatedCommands($template_id)
{
  $automatedTemplatedCommandsArray = array();
  
  $insertExpStr = "SELECT node_urn, command, seconds_after_flash FROM templated_commands WHERE template_id = '" . $template_id . "' ORDER BY seconds_after_flash;";
  $selectRes = mysql_query($insertExpStr) or die("getTemplatedAutomatedCommands: Request for templated commands failed: " . mysql_error());
  while ($line = mysql_fetch_assoc($selectRes))
  {
    $commandEntry['node_urn']            = $line['node_urn'];
    $commandEntry['seconds_after_flash'] = $line['seconds_after_flash'];
    $commandEntry['command']             = $line['command'];
    array_push($automatedTemplatedCommandsArray, $commandEntry);       
  }
  return $automatedTemplatedCommandsArray;
}

// updates 3D pos
public function areNodesAlive()
{
   $nodestates = array(); 
   $query = "SELECT * FROM aliveState";
   $result = mysql_query($query) or die("Request failed: " . mysql_error());
   while ($line = mysql_fetch_assoc($result))
   {
        $nodestates[$line['node_urn']]  = $line['node_state'];
   }
   return $nodestates;
}



//*****************************************************************************
public function getTemplatedNodesImages($template_id)
{
  $templatedNodesImages = array();
  
  $insertExpStr = "SELECT node_urn, image_id, image_name FROM templated_nodes_images NATURAL JOIN images WHERE template_id = '" . $template_id . "'";
  $selectRes = mysql_query($insertExpStr) or die("getTemplatedNodesImages: Request for templated nodes images pairs failed: " . mysql_error());
  while ($line = mysql_fetch_assoc($selectRes))
  {
    $nodes_image_entry['node_urn']            = $line['node_urn'];
    $nodes_image_entry['image_id']            = $line['image_id'];
    $nodes_image_entry['image_name']          = $line['image_name'];
    array_push($templatedNodesImages, $nodes_image_entry);       
  }
  return $templatedNodesImages;
}


//*****************************************************************************
public function saveTemplate($exp_id, $templatename)
{
  $stuff = array();
  $getStuffString = "SELECT exp_name, exp_description, exp_done, exp_runs, exp_user_unique_id, exp_visibility FROM experiment_info  WHERE exp_id = '" . $exp_id . "';";
  $result = mysql_query($getStuffString) or die("saveTemplate: " . mysql_error());
  while ($line = mysql_fetch_assoc($result))
  {
    $stuff['exp_name']           = $line['exp_name'];
    $stuff['exp_description']    = $line['exp_description'];
    $stuff['exp_runs']           = $line['exp_runs'];
    $stuff['exp_user_unique_id'] = $line['exp_user_unique_id'];
    $stuff['exp_visibility']     = $line['exp_visibility'];
  }
	
  $insertString = "REPLACE INTO experiment_templates VALUES('" . $templatename . "','"  . $stuff['exp_name'] . "','" . $stuff['exp_description'] . "','" . $stuff['exp_user_unique_id'] . "','" . $stuff['exp_visibility'] . "','" . $stuff['exp_runs'] . "');";
  $result = mysql_query($insertString) or die("query: " . $insertString . " saveTemplate : Request for insertion failed: " . mysql_error());

  $automatedCommandsArray = Db::getInstance()->getAutomatedCommands($exp_id);
  foreach($automatedCommandsArray as $automatedCommand)
  {
  	     Db::getInstance()->insertAutomatedTemplatedCommand($templatename, $automatedCommand['node_urn'], $automatedCommand['command'], $automatedCommand['seconds_after_flash']);
  }
  
  $nodesImagesArray = Db::getInstance()->getNodesImages($exp_id);
  foreach($nodesImagesArray as $nodesImageTuple)
  {
         Db::getInstance()->deleteTemplatedNodeImage($templatename, $nodesImageTuple['node_urn'],$nodesImageTuple['image_id']);
         Db::getInstance()->insertTemplatedNodeImage($templatename, $nodesImageTuple['node_urn'],$nodesImageTuple['image_id']);
  }
}



//*****************************************************************************
public function getTemplates($user)
{
  $templateEntries = array();
  $getStuffString = "SELECT template_uniqueID, template_description, template_visibility, template_runs FROM experiment_templates WHERE template_user_unique_id = '" . $user . "';";
  $result = mysql_query($getStuffString) or die("getTemplates: " . mysql_error());
  while ($line = mysql_fetch_assoc($result))
  {
    $templateEntry['template_uniqueID']     = $line['template_uniqueID'];
    $templateEntry['template_description']  = $line['template_description'];
    $templateEntry['template_visibility']   = $line['template_visibility'];
    $templateEntry['template_runs']         = $line['template_runs'];
    array_push($templateEntries, $templateEntry);   
  }
  return $templateEntries;
}


//*****************************************************************************
public function getTemplateWithID($id)
{
  $getStuffString = "SELECT template_name, template_description, template_visibility, template_runs FROM experiment_templates WHERE template_uniqueID = '" . $id . "';";
  $result = mysql_query($getStuffString) or die("getTemplateWithID: " . mysql_error());
  while ($line = mysql_fetch_assoc($result))
  {
    $templateEntry['template_name']         = $line['template_name'];
    $templateEntry['template_description']  = $line['template_description'];
    $templateEntry['template_visibility']   = $line['template_visibility'];
    $templateEntry['template_runs']         = $line['template_runs'];
  }
  return $templateEntry;
}

//*****************************************************************************

public function getUserProperties($userID)
{
    $selectQuery = "SELECT user_unique_id, user_firstname, user_name, user_email from users WHERE user_unique_id = '" . $userID . "';";
    $result = mysql_query($selectQuery) or die("Request for getNodesOfExperiment failed: " . mysql_error());
    $line = mysql_fetch_assoc($result);
    if(!empty($line))
    {
        return $line;
    }
    
    return "none";
}

//*****************************************************************************

public function getNodesOfExperiment($expID)
{
    $nodes = array();
    $selectQuery = "SELECT node_urn FROM experiment_network WHERE exp_id = '" . $expID . "';";
    $result = mysql_query($selectQuery) or die("Request for getNodesOfExperiment failed: " . mysql_error());
    while ($line = mysql_fetch_assoc($result)) {
        array_push($nodes, $line['node_urn']);   
    }
    return $nodes;
}


//*****************************************************************************

public function getNodesImages($expID)
{
    $nodesImages = array();
    $selectQuery = "SELECT node_urn, image_id FROM experiment_network WHERE exp_id = '" . $expID . "';";
    $result = mysql_query($selectQuery) or die("Request for getNodesImages failed: " . mysql_error());
    while ($line = mysql_fetch_assoc($result)) {
        $nodesImageEntry['node_urn']   = $line['node_urn'];
        $nodesImageEntry['image_id']   = $line['image_id'];
        array_push($nodesImages, $nodesImageEntry);   
    }
    return $nodesImages;
}

//*****************************************************************************

//updateExperimentConfiguration
//  - update an exiting experiment
//  - affected tables: experiment_info and experiment_network
public function updateExperimentConfiguration($expConf)
{
  $updateQuery = "UPDATE experiment_info SET exp_name='" . $expConf['exp_name'] . "', exp_description='" . $expConf['exp_description'] . "', exp_user_unique_id='" . $expConf['exp_user_unique_id'] . "', exp_user_email='" . $expConf['exp_user_email'] . "', exp_visibility='" . $expConf['exp_visibility'] . "', exp_runs='" . $expConf['exp_runs'] . "' WHERE exp_id='" . $expConf['exp_id'] . "';";
  $updateResult = mysql_query($updateQuery)
    or die("DB.updateExperimentConfiguration (experiment_info: Request for update failed: " . mysql_error());
    
  foreach($expConf['exp_nodes'] as $expNodes)
  {
    $updateQuery2 = "UPDATE experiment_network SET image_id='" . $expNodes['image_id'] . "' WHERE exp_id='" . $expConf['exp_id'] . "' AND node_urn='" . $expNodes['node_urn']. "';";
    $updateResult2 = mysql_query($updateQuery2)
      or die("DB.updateExperimentConfiguration (experiment_network: Request for update failed: " . mysql_error());
  }
}


//*****************************************************************************

//getAllUpcomingOrDoneExperimentIDs
//  - get all experiment configurations which are not running or finished
//  - affected tables: experiment_info
public function getAllUpcomingOrDoneExperimentIDs()
{
  $expArray = array();
  
  $selectStr = "SELECT exp_id FROM experiment_info WHERE (exp_start_time > UTC_TIMESTAMP() OR exp_done='1' ) ORDER BY exp_end_time;";
  $selectRes = mysql_query($selectStr)
  or die("Request for all own experiments failed: " . mysql_error());
  while ($line = mysql_fetch_assoc($selectRes))
  {
    $expID = $line['exp_id'];
    array_push($expArray, $expID);
  }
  return $expArray;
}

//*****************************************************************************

//getAllPublicExperimentConfigurations
//  - get all public experiment configurations which are already finished
//  - affected tables: experiment_info
public function getAllPublicExperimentConfigurations()
{
  $resArray = array();
  
  $selectStr = "SELECT exp_id, exp_name, exp_description, exp_start_time, exp_end_time, exp_user_unique_id, exp_user_email, exp_visibility FROM experiment_info WHERE exp_visibility = '1' AND exp_done = '1' AND exp_result IS NOT NULL ORDER BY exp_end_time;";
  $selectRes = mysql_query($selectStr)
    or die("Request for all public experiments failed: " . mysql_error());
  while ($line = mysql_fetch_assoc($selectRes))
  {
    $expID = $line['exp_id'];
    $pubExperiment['exp_id'] = $line['exp_id'];
    $pubExperiment['exp_name'] = $line['exp_name'];
    $pubExperiment['exp_description'] = $line['exp_description'];
    $pubExperiment['exp_start_time'] = $line['exp_start_time'];
    $pubExperiment['exp_end_time'] = $line['exp_end_time'];
    $pubExperiment['exp_user_unique_id'] = $line['exp_user_unique_id'];
    $pubExperiment['exp_user_email'] = $line['exp_user_email'];
    $pubExperiment['exp_visibility'] = $line['exp_visibility'];
    $resArray[$expID] = $pubExperiment;       
  }
  return $resArray;
}


//getAllOwnExperimentConfigurations
//  - get all own experiment configurations which are already finished
//  - affected tables: experiment_info
public function getAllOwnExperimentConfigurations($userID)
{
  $resArray = array();
  
  //$selectStr = "SELECT exp_id, exp_name, exp_description, exp_start_time, exp_end_time, exp_user_unique_id, exp_user_email, exp_result, exp_visibility FROM experiment_info WHERE exp_user_unique_id = '" . $userID . "' AND exp_end_time < UTC_TIMESTAMP() AND exp_result IS NOT NULL;";
  $selectStr = "SELECT exp_id, exp_name, exp_description, exp_start_time, exp_end_time, exp_user_unique_id, exp_user_email, exp_visibility, exp_done FROM experiment_info WHERE exp_user_unique_id = '" . $userID . "' AND ( exp_end_time > UTC_TIMESTAMP() OR exp_done='1' ) ORDER BY exp_end_time;";
  $selectRes = mysql_query($selectStr)
  or die("Request for all own experiments failed: " . mysql_error());
  while ($line = mysql_fetch_assoc($selectRes))
  {
    $expID = $line['exp_id'];
    $ownExperiment['exp_id'] = $line['exp_id'];
    $ownExperiment['exp_name'] = $line['exp_name'];
    $ownExperiment['exp_description'] = $line['exp_description'];
    $ownExperiment['exp_start_time'] = $line['exp_start_time'];
    $ownExperiment['exp_end_time'] = $line['exp_end_time'];
    $ownExperiment['exp_user_unique_id'] = $line['exp_user_unique_id'];
    $ownExperiment['exp_user_email'] = $line['exp_user_email'];
    $ownExperiment['exp_visibility'] = $line['exp_visibility'];
    $ownExperiment['exp_done'] = $line['exp_done'];
    $resArray[$expID] = $ownExperiment;       
  }
  return $resArray;
}

//getAllOwnExperimentConfigurations
//  - get all own experiment configurations which are already finished
//  - affected tables: experiment_info
public function getAllOwnOldExperimentConfigurations($userID)
{
  $resArray = array();
  
  $selectStr = "SELECT exp_id, exp_name, exp_description, exp_start_time, exp_end_time, exp_user_unique_id, exp_user_email, exp_result, exp_visibility FROM experiment_info WHERE exp_user_unique_id = '" . $userID . "' AND exp_done = '1' AND exp_result IS NOT NULL ORDER BY exp_end_time;";
  $selectRes = mysql_query($selectStr)
    or die("Request for all own experiments failed: " . mysql_error());
  while ($line = mysql_fetch_assoc($selectRes))
  {
    $expID = $line['exp_id'];
    $ownExperiment['exp_id'] = $line['exp_id'];
    $ownExperiment['exp_name'] = $line['exp_name'];
    $ownExperiment['exp_description'] = $line['exp_description'];
    $ownExperiment['exp_start_time'] = $line['exp_start_time'];
    $ownExperiment['exp_end_time'] = $line['exp_end_time'];
    $ownExperiment['exp_user_unique_id'] = $line['exp_user_unique_id'];
    $ownExperiment['exp_user_email'] = $line['exp_user_email'];
    $ownExperiment['exp_result'] = $line['exp_result'];
    $ownExperiment['exp_visibility'] = $line['exp_visibility'];
    $resArray[$expID] = $ownExperiment;       
  }
  return $resArray;
}

//getAllOtherUsersExperimentConfigurations
//  - get all own experiment configurations which are already finished
//  - affected tables: experiment_info
public function getAllOtherUsersExperimentConfigurations($userID)
{
  $resArray = array();
  
  $selectStr = "SELECT exp_id, exp_name, exp_description, exp_start_time, exp_end_time, exp_user_unique_id, exp_user_email, exp_result, exp_visibility FROM experiment_info WHERE exp_user_unique_id != '" . $userID . "' AND exp_done = '1' AND exp_result IS NOT NULL ORDER BY exp_end_time;";
  $selectRes = mysql_query($selectStr)
    or die("Request for all own experiments failed: " . mysql_error());
  while ($line = mysql_fetch_assoc($selectRes))
  {
    $expID = $line['exp_id'];
    $ownExperiment['exp_id'] = $line['exp_id'];
    $ownExperiment['exp_name'] = $line['exp_name'];
    $ownExperiment['exp_description'] = $line['exp_description'];
    $ownExperiment['exp_start_time'] = $line['exp_start_time'];
    $ownExperiment['exp_end_time'] = $line['exp_end_time'];
    $ownExperiment['exp_user_unique_id'] = $line['exp_user_unique_id'];
    $ownExperiment['exp_user_email'] = $line['exp_user_email'];
    $ownExperiment['exp_result'] = $line['exp_result'];
    $ownExperiment['exp_visibility'] = $line['exp_visibility'];
    $resArray[$expID] = $ownExperiment;       
  }
  return $resArray;
}

//getExperimentConfigurations
//  - get experiment configuration for the fiven expID it it is are already finished
//  - affected tables: experiment_info
public function getExperimentConfiguration($expID)
{
  $selectStr = "SELECT exp_id, exp_name, exp_description, exp_start_time, exp_end_time, exp_user_unique_id, exp_user_email, exp_result, exp_visibility, exp_runs FROM experiment_info WHERE exp_id = '" . $expID . "' AND exp_end_time > UTC_TIMESTAMP();";
  $selectRes = mysql_query($selectStr)
    or die("Request for all own experiments failed: " . mysql_error());
  $line = mysql_fetch_assoc($selectRes);
  if(!empty($line))
  {
    $expID = $line['exp_id'];
    $exp['exp_id'] = $line['exp_id'];
    $exp['exp_name'] = $line['exp_name'];
    $exp['exp_description'] = $line['exp_description'];
    $exp['exp_start_time'] = $line['exp_start_time'];
    $exp['exp_end_time'] = $line['exp_end_time'];
    $exp['exp_user_unique_id'] = $line['exp_user_unique_id'];
    $exp['exp_user_email'] = $line['exp_user_email'];
    $exp['exp_result'] = $line['exp_result'];
    $exp['exp_visibility'] = $line['exp_visibility'];
    $exp['exp_runs'] = $line['exp_runs'];
  
    $nodeArr = array();
    $selectStr2 = "SELECT node_urn, image_id FROM experiment_network WHERE exp_id = '" . $expID . "';";
    $selectRes2 = mysql_query($selectStr2)
      or die("Request for all own experiments failed: " . mysql_error());
    while ($line2 = mysql_fetch_assoc($selectRes2))
    {
      $divide = explode(":", $line2['node_urn']);    
      $node['node_urn'] = $line2['node_urn'];
      $imgId = $line2['image_id'];
      $selectStr3 = "SELECT image_name, image_version, image_platform, image_description FROM images WHERE image_id = '" . $imgId . "';";
      $selectRes3 = mysql_query($selectStr3)
        or die("Request for all own experiments failed: " . mysql_error());
      while ($line3 = mysql_fetch_assoc($selectRes3))
      {
        $node['image_id'] = $imgId;
        $node['image_name'] = $line3['image_name'];
        $node['image_version'] = $line3['image_version'];
        $node['image_platform'] = $line3['image_platform'];
        $node['image_description'] = $line3['image_description'];
      }
      $nodeArray[$divide[sizeof($divide)-1]] = $node;
    }
    ksort($nodeArray);
    $exp['exp_nodes'] = $nodeArray;
  }
  return $exp;
}

//getOldExperimentConfigurations
//  - get experiment configuration for the fiven expID it it is are already finished
//  - affected tables: experiment_info
public function getOldExperimentConfigurations($expID)
{
  $resArray = array();
  
  $selectStr = "SELECT exp_id, exp_name, exp_description, exp_start_time, exp_end_time, exp_user_unique_id, exp_user_email, exp_result, exp_visibility FROM experiment_info WHERE exp_id = '" . $expID . "' AND exp_done = '1' AND exp_result IS NOT NULL;";
  $selectRes = mysql_query($selectStr)
    or die("Request for all own experiments failed: " . mysql_error());
  while ($line = mysql_fetch_assoc($selectRes))
  {
    $expID = $line['exp_id'];
    $exp['exp_id'] = $line['exp_id'];
    $exp['exp_name'] = $line['exp_name'];
    $exp['exp_description'] = $line['exp_description'];
    $exp['exp_start_time'] = $line['exp_start_time'];
    $exp['exp_end_time'] = $line['exp_end_time'];
    $exp['exp_user_unique_id'] = $line['exp_user_unique_id'];
    $exp['exp_user_email'] = $line['exp_user_email'];
    $exp['exp_result'] = $line['exp_result'];
    $exp['exp_visibility'] = $line['exp_visibility'];
    $resArray[$expID] = $exp;       
  }
  return $resArray;
}

// added Hurni, Oct. 2010

public function getNextExperiments()
{
    $idArray = array(); 
    $query = "SELECT exp_id FROM experiment_info WHERE exp_start_time in (SELECT MIN(exp_start_time) FROM experiment_info WHERE exp_start_time > UTC_TIMESTAMP())";
    $select = mysql_query($query) or die("Request for all currently running experiment ids failed: " . mysql_error());
    while ($line = mysql_fetch_assoc($select))
    {
       $expID = $line['exp_id'];
       array_push($idArray, $expID);    
    }
    return $idArray;
}

// added Hurni, Oct. 2010

public function getCurrentRunningExperimentIDs()
{
    $idArray = array(); 
    $query = "SELECT exp_id FROM experiment_info WHERE exp_start_time < UTC_TIMESTAMP() and exp_end_time > UTC_TIMESTAMP() AND exp_done='0'";
    $select = mysql_query($query) or die("Request for all currently running experiment ids failed: " . mysql_error());
    while ($line = mysql_fetch_assoc($select))
    {
       $expID = $line['exp_id'];
       array_push($idArray, $expID);    
    }
    return $idArray;
}

// added Hurni, Oct. 2010

public function getCurrentRunningExperimentIDsOfUser($userid, $isTestbedMaintainer)
{
    $idArray = array(); 
    $query = '';
    if($isTestbedMaintainer) {
        $query = "SELECT exp_id FROM experiment_info WHERE exp_start_time < UTC_TIMESTAMP() AND exp_end_time > UTC_TIMESTAMP() AND exp_done='0';";
    }
    else {
        $query = "SELECT exp_id FROM experiment_info WHERE exp_start_time < UTC_TIMESTAMP() AND exp_end_time > UTC_TIMESTAMP() AND exp_user_unique_id='" . $userid . "' AND exp_done='0';";    
    }
    $select = mysql_query($query) or die("Request for all currently running experiment ids failed: " . mysql_error());
    while ($line = mysql_fetch_assoc($select))
    {
       $expID = $line['exp_id'];
       array_push($idArray, $expID);    
    }
    return $idArray;
}

// added Hurni, Oct. 2010

public function getCurrentRunningExperimentIDsPubliclyVisible()
{
    $idArray = array(); 
    $query = "SELECT exp_id FROM experiment_info WHERE exp_start_time < UTC_TIMESTAMP() AND exp_end_time > UTC_TIMESTAMP() AND exp_visibility='1' AND exp_done='0';";
    $select = mysql_query($query) or die("Request for all currently running experiment ids failed: " . mysql_error());
    while ($line = mysql_fetch_assoc($select))
    {
       $expID = $line['exp_id'];
       array_push($idArray, $expID);    
    }
    return $idArray;
}



//deleteExperiment
//  - deletes an existing experiment from the database
public function deleteExperiment($expID)
{
  $deleteExpString = "DELETE FROM experiment_info WHERE exp_id='" . $expID . "';";
  $result = mysql_query($deleteExpString) or die("deleteExperiment (experiment_info): " . mysql_error());
    
  $deleteExpString2 = "DELETE FROM experiment_network WHERE exp_id='" . $expID . "';";
  $result2 = mysql_query($deleteExpString2) or die("deleteExperiment (experiment_network): " . mysql_error());    
  
  $deleteExpString3 = "DELETE FROM automatedCommands WHERE exp_id='" . $expID . "';";
  $result2 = mysql_query($deleteExpString3) or die("deleteExperiment (automated_commands): " . mysql_error());    
  
}


public function setExperimentDone($expID) {
	  $setDoneString = "UPDATE experiment_info SET exp_done='1' where exp_id='" . $expID . "';";
      $result = mysql_query($setDoneString) or die("setExperimentDone (" . $setDoneString . "): " . mysql_error());
}


//*****************************************************************************

public function getAllProperties()
{
  $resultArray = array();
  
  $selectPropString = "SELECT * FROM properties;";
  $result = mysql_query($selectPropString);
  while ($line = mysql_fetch_assoc($result))
  {
    $propID = $line['prop_id'];
    $resultArray[$propID] = $line;
  }
  
  return $resultArray;
}

//*****************************************************************************
	  
//clone:
private function __clone()
{
}
  	
//*****************************************************************************

}
?>
