
// Copyright by smartass Huernel


anchor_x = 0;
anchor_y = 0;
anchor_set = 0;
anchor_id = 0;
second_anchor_x = 0;
second_anchor_y = 0;

x_min = -1;
x_max = -1;
y_min = -1;
y_max = -1;


clicked_object = 0;
double_clicked_object = 0;

var mouseDown = 0;

function bodyMouseDown() { 
	mouseDown = 1;
}

function bodyMouseUp() { 
	mouseDown = 0;
	if(anchor_set && lastMovedObj != null) {
		un_anchor(lastMovedObj);
	}
}



function addDebugStatement(string) {
	if(document.getElementById("debug")!=null) {
		document.getElementById("debug").value= document.getElementById("debug").value + string;
	}
}

function debug(lastAction) {
	if(document.getElementById("debug")!=null) {
		document.getElementById("debug").value="lastaction=" + lastAction + "\n" 
	  + "anchor_set=" + anchor_set + "\n" 
	  + "anchor_id=" + anchor_id + "\n" 
	  + "second_anchor_x=" + second_anchor_x + "\n" 
	  + "second_anchor_y=" + second_anchor_y + "\n" 
	  + "x_min=" + x_min + "\n"
	  + "x_max=" + x_max + "\n"
	  + "y_min=" + y_min + "\n"
	  + "y_max=" + y_max + "\n";
	}
}



function setAnchor(obj){
	var position = obj.id.split("_");
	anchor_x = parseInt(position[0]);
	anchor_y = parseInt(position[1]);
	anchor_set = 1;
	anchor_id = obj.id;
}

function StartDragSelect(obj) {
	clicked_object = obj;
	
	x_min = getMin_X();
	x_max = getMax_X();
	y_min = getMin_Y();
	y_max = getMax_Y();
	
	
	if( obj.className == "selected" ) {
		obj.className = "";
		anchor_set = 0;	
	} 
	else if( obj.className == ""){
		obj.className = "selected";
		setAnchor(obj);
	}
	//debug("StartDragSelect");
}

function deleteRowAtPoint(position_x,position_y){
	x_var = position_x;
	while( x_var < x_max && document.getElementById(x_var + "_" + position_y ).className == "selected") { 		
		document.getElementById(x_var + "_" + position_y ).className = "";
		x_var = x_var + 1;
	}
	x_var = position_x - 1;
	while( x_var >= x_min && document.getElementById(x_var + "_" + position_y ).className == "selected") { 
		document.getElementById(x_var + "_" + position_y ).className = "";
		x_var = x_var - 1;
	}
}

function doubleClicked(obj) {
	//debug("doubleClicked");
	var position = obj.id.split("_");
	var position_x = parseInt(position[0]);
	var position_y = parseInt(position[1]);
	
	// delete row
	if(	obj.className == "selected" ) {
		double_clicked_object = obj;
		//addDebugStatement("selected\n");
		deleteRowAtPoint(position_x, position_y);
	}
}


function setFieldsIfAnchorSet(obj) {
	if(anchor_set && anchor_id!= obj.id && mouseDown && (obj.className == "selected" || obj.className == "") ) {
		obj.className = "selected";
		var position = obj.id.split("_");
		
		var position_x = parseInt(position[0]);
		var position_y = parseInt(position[1]);
		
		var inc_x = 1;
		var inc_y = 1;
		
		
		if(anchor_x <= position_x) {
			inc_x = 1;	
		}
		else {
			inc_x = -1;
		}
		if(anchor_y <= position_y) {
			inc_y = 1;	
		}
		else {
			inc_y = -1;
		}
				
		for (x = x_min; x != x_max; x = x + 1) {
			for (y = y_min; y != y_max; y = y + 1) {
				if(document.getElementById(x + "_" + y ).className == "selected" || document.getElementById(x + "_" + y ).className == "") {
					document.getElementById(x + "_" + y ).className = "";
				}
			}
		}
		
		for (x = anchor_x; x != position_x + inc_x; x = x + inc_x) {
			for (y = anchor_y; y != position_y + inc_y; y = y + inc_y) { 
				document.getElementById(x + "_" + y ).className = "selected";
			}
		}
		
			
	}
}



lastMovedObj = 0;

function mouseOver(obj) {
	setFieldsIfAnchorSet(obj);
	if(!mouseDown && anchor_set && anchor_id!= obj.id) {
		un_anchor(obj);
	}
	lastMovedObj = obj;
	addDebugStatement("position: " + obj.id + "\n");
	debug("mouseOver");
}

function un_anchor(obj) {
	//addDebugStatement("resetting anchor\n");
	var position = obj.id.split("_");
	second_anchor_x = parseInt(position[0]);
	second_anchor_y = parseInt(position[1]);
	
	setFieldsIfAnchorSet(obj);	
	
	//remove invalid fields
	for(var j=anchor_y; j<second_anchor_y; j++ ){
		for(var i=anchor_x; i<second_anchor_x; i++ ){
			if(document.getElementById(i + "_" + j)!= null && document.getElementById(i + "_" + j).value=='nonselectable'){
				//addDebugStatement("i=" + i + " j=" + j + " nonselectable\n");
				deleteRowAtPoint(i,j);
				i=second_anchor_x;
			}
		}
	}
	anchor_set = 0;
	//addDebugStatement("reset anchor\n");
}


function onMouseUp(obj) {
	//debug("onMouseUp");
	if(anchor_set && anchor_id!= obj.id) { 
		un_anchor(obj);
	}
	else if(clicked_object == obj){
		anchor_set = 0;
		//addDebugStatement("clicked_object==obj\n");
		//debug("onMouseUp");
	}
	else {
		//addDebugStatement("onMouseUp done nothing with anchor\n");
		if( obj.className == "" ) {
			obj.className = "selected";
		}
		else if( obj.className == "selected" ){
			obj.className = "";	
		}
	}
	//addDebugStatement("onMouseUp end\n");
}

function setSubmit(p1){
    selectedArray = getSelectedArray();
	$value = selectedArray.toString();
	$info  ='<form name="selection" method="post" action="">';
	$info +='<input type="hidden" name="'+p1+'" value="'+1+'" >';
	$info +='<input type="hidden" name="selectedArray" value="'+$value+'" >';
	$info +='</form>';
	document.getElementById("selection").innerHTML=$info;
	document.selection.submit();
}

function setSubmitMod(p1, p2){
    selectedArray = getSelectedArray();
	$value = selectedArray.toString();
	$info  ='<form name="selection" method="post" action="">';
	$info +='<input type="hidden" name="'+p1+'" value="'+1+'" >';
	$info +='<input type="hidden" name="resKey" value="'+p2+'" >';
	$info +='<input type="hidden" name="selectedArray" value="'+$value+'" >';
	$info +='</form>';
	document.getElementById("selection").innerHTML=$info;
	document.selection.submit();
}

function getSelectedArray() {
	selectedArray = new Array();
	//addDebugStatement("max_x=" + max_x + "\n");
	//addDebugStatement("max_y=" + max_y + "\n");
	for (x = 0; x < x_max; x = x + 1) {
		for (y = 0; y < y_max; y = y + 1) {
			if(document.getElementById(x + "_" + y ) != null && document.getElementById(x + "_" + y ).className == "selected") {
				selectedArray.push(x + "_" + y);			
			}
		}
	}	
	return selectedArray;
}

function getMax_X() {
	var x0 = 0;
	while(document.getElementById( x0+"_0" ) == null) {
		x0++;
	}
	
	while(document.getElementById( x0+"_0" ) != null) {
		x0++;	
	}
	return x0;
}

function getMax_Y() {
	var y0 = 0;
	var x_max = getMax_X()-1;
	while(document.getElementById( x_max + "_" + y0  ) == null) {
		y0++;
	}
	while(document.getElementById( x_max + "_" + y0 ) != null) {
		y0++;	
	}
	return y0;
}

function getMin_X() {
	var x00 = 200;
	while(document.getElementById( x00 + "_0" ) == null) {
		x00--;
	}
	while(document.getElementById( x00 + "_0" ) != null && x00 > 0) {
		x00--;	
	}
	return x00;
}

function getMin_Y() {
	var y00 = 200;
	
	while(document.getElementById( "0_"+ y00  ) == null) {
		y00--;
	}
	while(document.getElementById( "0_"+ y00 ) != null && y00 > 0) {
		y00--;	
	}
	return y00;
}

function clearAll() {
	for (var x = 0; x < x_max; x = x + 1) {
		for (var y = 0; y < y_max; y = y + 1) {
			if(document.getElementById(x + "_" + y ) != null) {
				document.getElementById(x + "_" + y ).className = "";		
			}
		}
	}	
}

function checkPreselectedFields() {
	
	if(document.getElementById("0_0")!=null) {
		x_min = getMin_X();
		x_max = getMax_X();
		y_min = getMin_Y();
		y_max = getMax_Y();
		
		for (x = 0; x < x_max; x = x + 1) {
			for (y = 0; y < y_max; y = y + 1) {
				if(document.getElementById(x + "_" + y ) != null ) {
					if(document.getElementById(x + "_" + y).getAttribute("tomodify")!=null) {
						document.getElementById(x + "_" + y ).className = "selected";
					}
				}
			}
		}
	}
}

