<?php
/*
 * AAI Attributes Textual Descriptions
 *
 * http://www.switch.ch/aai/studybranch.html
 *
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 *
 * Copyright (c) 2004 SWITCH (htttp://www.switch.ch)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: AAIAttributes.inc,v 1.5 2005/02/01 17:15:02 vlry Exp $
 *
 * @author Valery Tschopp - SWITCH
 * @version $Revision: 1.5 $
 */

/**
 * Textual descriptions for Study Branch 1.
 */
$DESCRIPTIONS_STUDYBRANCH1= array(

   /* University Study Branch 1 */
   '1' => array(    'de' => 'Geistes- + Sozialwiss.', 
	                'fr' => 'Sciences humaines + sociales' ),
   '2' => array(    'de' => 'Wirtschaftswissenschaften', 
		            'fr' => 'Sciences conomiques' ),
   '3' => array(    'de' => 'Recht', 
		            'fr' => 'Droit' ),
   '4' => array(    'de' => 'Exakte + Naturwiss.', 
		            'fr' => 'Sciences exactes + naturelles' ),
   '5' => array(    'de' => 'Medizin + Pharmazie', 
		            'fr' => 'Mdecine + pharmacie' ),
   '6' => array(    'de' => 'Technische Wissenschaften', 
		            'fr' => 'Sciences techniques' ),
   '7' => array(    'de' => 'Interdisziplinre + andere', 
		            'fr' => 'Interdisciplinaire + autres' ),
   '8' => array(    'de' => 'Zentralbereich', 
		            'fr' => 'Domaine central' ),

   /* University of Applied Science */
   '10000' => array(    'de' => 'Bauwesen', 
		                'fr' => 'Sciences de la construction' ),
   '20000' => array(    'de' => 'Technik', 
		                'fr' => 'Technique' ),
   '30000' => array(    'de' => 'Chemie', 
		                'fr' => 'Chimie' ),
   '40000' => array(    'de' => 'Landwirtschaft', 
		                'fr' => 'Agriculture' ),
   '50000' => array(    'de' => 'Wirtschaft', 
		                'fr' => 'Economie' ),
   '60000' => array(    'de' => 'Gestaltung', 
		                'fr' => 'Arts appliqus' ),
   '70000' => array(    'de' => 'Sport', 
		                'fr' => 'Sport' ),
   '80000' => array(    'de' => 'Bildende Kunst', 
		                'fr' => 'Art visuel' ),
   '90000' => array(    'de' => 'Musik', 
		                'fr' => 'Musique' ),
   '100000' => array(   'de' => 'Theater', 
		                'fr' => 'Thtre' ),
   '110000' => array(   'de' => 'Angewandte Linguistik', 
		                'fr' => 'Linguistique applique' ),
   '120000' => array(   'de' => 'Soziale Arbeit', 
		                'fr' => 'Travail social' ),
   '130000' => array(   'de' => 'Angewandte Psychologie', 
	 	                'fr' => 'Psychologie applique' ),
   '140000' => array(   'de' => 'Gesundheit', 
		                'fr' => 'Sant' ),
   '150000' => array(   'de' => 'Lehrkrfteausbildung', 
		                'fr' => 'Formation des enseignants' ),
   '990000' => array(   'de' => 'Nachdiplomstudium nicht zuteilbar', 
		                'fr' => 'Etudes postgrades non rpartissables' ),
   '999000' => array(   'de' => 'Nicht zuteilbar / Leistung fr mehrere Studiengnge gleichzeitig', 
		                'fr' => "Non rpartissable / Prestation attribue simultanment  plusieurs filires d'tudes" ),
);

/**
 * Textual descriptions for Study Branch 2.
 */
$DESCRIPTIONS_STUDYBRANCH2= array(
    /* University Study Branch 2 */
    '11' => array(  'de' => "Theologie",
                    'fr' => "Thologie" ),
    '12' => array(  'de' => "Sprach- + Literaturw. (SLW)",
                    'fr' => "Langues + Littrature (LL)" ),
    '13' => array(  'de' => "Historische + Kulturw.",
                    'fr' => "Sciences historiques + culture" ),
    '14' => array(  'de' => "Sozialwissenschaften",
                    'fr' => "Sciences sociales" ),
    '15' => array(  'de' => "Geist./Soz.w. fcherbergr./brige",
                    'fr' => "Sci. humaines + soc. pluridisc./autres" ),
    '41' => array(  'de' => "Exakte Wissenschaften",
                    'fr' => "Sciences exactes" ),
    '42' => array(  'de' => "Naturwissenschaften",
                    'fr' => "Sciences naturelle" ),
    '43' => array(  'de' => "Exakte + Naturw.,brige",
                    'fr' => "Sci. exactes + naturelles pluridisc./autres" ),
    '51' => array(  'de' => "Humanmedizin",
                    'fr' => "Mdecine humaine" ),
    '52' => array(  'de' => "Zahnmedizin",
                    'fr' => "Mdecine dentaire" ),
    '53' => array(  'de' => "Veterinrmedizin",
                    'fr' => "Mdecine vtrinaire" ),
    '54' => array(  'de' => "Pharmazie",
                    'fr' => "Pharmacie" ),
    '55' => array(  'de' => "Medizin + Pharm. fcherb./brige",
                    'fr' => "Mdecine + pharm. pluridisc./autres" ),
    '61' => array(  'de' => "Bauwesen + Geodsie",
                    'fr' => "Sc. de la construction + mensuration" ),
    '62' => array(  'de' => "Maschinen- + Elektroingenieurw.",
                    'fr' => "Gnies mchanique + lectronique" ),
    '63' => array(  'de' => "Agrar- + Forstwissenschaften",
                    'fr' => "Agriculture + sylviculture" ),
    '64' => array(  'de' => "Techn. Wiss. Fcherbergr./brige",
                    'fr' => "Sci. techniques pluridisc./autres" ),
    '81' => array(  'de' => "Zentrale Verwaltung",
                    'fr' => "Admnistration centrale" ),
    '82' => array(  'de' => "Zentrale Bibliotheken",
                    'fr' => "Bibliothques centrales" ),
    '83' => array(  'de' => "Technische Dienste und Logistik",
                    'fr' => "Services techniques et logistique" ),
    '84' => array(  'de' => "Dienstleistungen fr Mitarbeitende und Studierende",
                    'fr' => "Services pour les collaborateurs et les tudiants" ),

    /* University of Applied Science Study Branch 2 */
    '10100' => array(       'de' => "Architektur",
                            'fr' => "Architecture" ),
    '10200' => array(       'de' => "Bauingenieurwesen",
                            'fr' => "Gnie civil" ),
    '10300' => array(       'de' => "Planung und Geomatik",
                            'fr' => "Mensuration et gomatique" ),
    '10400' => array(       'de' => "Holztechnik",
                            'fr' => "Technique du bois" ),
    '10900' => array(       'de' => "Bauwesen",
                            'fr' => "Sciences de la construction" ),
    '20200' => array(       'de' => "Elektroingenieurwesen",
                            'fr' => "Gnie lectrique" ),
    '20300' => array(       'de' => "Informatik",
                            'fr' => "Informatique" ),
    '20400' => array(       'de' => "Maschineningenieurwesen",
                            'fr' => "Gnie mcanique" ),
    '20500' => array(       'de' => "Telekommunikation",
                            'fr' => "Tlcommunication" ),
    '20600' => array(       'de' => "Systemtechnik",
                            'fr' => "Technique des systmes" ),
    '20700' => array(       'de' => "Drucktechnik",
                            'fr' => "Industrie graphique" ),
    '20900' => array(       'de' => "Technik",
                            'fr' => "Technique" ),
    '30100' => array(       'de' => "Chemie",
                            'fr' => "Chimie" ),
    '30200' => array(       'de' => "Bio- und Lebensmitteltechnologie",
                            'fr' => "Biotechnologie et sciences alimentaires" ),
    '30900' => array(       'de' => "Chemie allgemein",
                            'fr' => "Chimie en gnral" ),
    '40100' => array(       'de' => "Agrarwirtschaft",
                            'fr' => "Agriculture" ),
    '40200' => array(       'de' => "Pflanzenproduktion",
                            'fr' => "Production vgtale" ),
    '40300' => array(       'de' => "Tierproduktion",
                            'fr' => "Production animale" ),
    '40400' => array(       'de' => "Milchwirtschaft",
                            'fr' => "Economie laitire" ),
    '40900' => array(       'de' => "Landwirtschaft",
                            'fr' => "Agriculture en gnral" ),
    '50100' => array(       'de' => "Betriebskonomie",
                            'fr' => "Economie d'entreprise" ),
    '50200' => array(       'de' => "Betriebsfhrung, Hotellerie und Tourismus",
                            'fr' => "Gestion d'entreprise, htellerie et tourisme" ),
    '50300' => array(       'de' => "Wirtschaftsinformatik",
                            'fr' => "Informatique de gestion" ),
    '50400' => array(       'de' => "Information und Dokumentation",
                            'fr' => "Information et documentation" ),
    '50500' => array(       'de' => "Kommunikation",
                            'fr' => "Communication" ),
    '50900' => array(       'de' => "Wirtschaft",
                            'fr' => "Economie" ),
    '60100' => array(       'de' => "Visuelle Kommunikation",
                            'fr' => "Communication visuelle" ),
    '60200' => array(       'de' => "Innenarchitektur",
                            'fr' => "Architecture d'intrieur" ),
    '60300' => array(       'de' => "Produkte- und Industriedesign",
                            'fr' => "Design industriel et des produits" ),
    '60400' => array(       'de' => "Konservierung - Restaurierung",
                            'fr' => "Conservation - restauration" ),
    '60900' => array(       'de' => "Gestaltung",
                            'fr' => "Arts appliqus" ),
    '70100' => array(       'de' => "Sport",
                            'fr' => "Sport" ),
    '80100' => array(       'de' => "Bildende Kunst",
                            'fr' => "Art visuel" ),
    '80200' => array(       'de' => "Lehrerbildung fr Kunstfcher",
                            'fr' => "Formation d'enseignants pour domaines artistiques" ),
    '90100' => array(       'de' => "Musikpdagogik (instrumental und vokal)",
                            'fr' => "Pdagogie musicale (instrumentale et vocale)" ),
    '90200' => array(       'de' => "Interpretation/Performance",
                            'fr' => "Interprtation/Performance" ),
    '90300' => array(       'de' => "Schul- und Kirchenmusik",
                            'fr' => "Musique spirituelle et enseign. de la musique  l'cole" ),
    '90400' => array(       'de' => "Dirigieren",
                            'fr' => "Direction" ),
    '90500' => array(       'de' => "Spezialausbildungen",
                            'fr' => "Formations musicales spcialises" ),
    '90900' => array(       'de' => "Musik allgemein",
                            'fr' => "Musique en gnral" ),
    '100100' => array(      'de' => "Theaterschaffen in den darstellenden Knsten",
                            'fr' => "Cration dans les arts de la scne" ),
    '100200' => array(      'de' => "Bewegungs-, Sprech- und Stimmerziehung",
                            'fr' => "Expression corporelle et vocale" ),
    '100300' => array(      'de' => "Szenelehrkrfte",
                            'fr' => "Formation des enseignants pour la mise en scne" ),
    '100400' => array(      'de' => "Spezialausbildungen",
                            'fr' => "Formations thtrales spcialises" ),
    '100900' => array(      'de' => "Theater allgemein",
                            'fr' => "Thtre en gnral" ),
    '110100' => array(      'de' => "bersetzen",
                            'fr' => "Traduction" ),
    '110200' => array(      'de' => "Dolmetschen",
                            'fr' => "Interprtation" ),
    '110900' => array(      'de' => "Angewandte Linguistik allgemein",
                            'fr' => "Linguistique applique en gnral" ),
    '120100' => array(      'de' => "Sozialarbeit",
                            'fr' => "Service social" ),
    '120200' => array(      'de' => "Sozialpdagogik",
                            'fr' => "Education sociale" ),
    '120300' => array(      'de' => "Soziokulturelle Animation",
                            'fr' => "Animation socioculturelle" ),
    '120900' => array(      'de' => "Allgemeine Soziale Arbeit",
                            'fr' => "Travail social en gnral" ),
    '130100' => array(      'de' => "Angewandte Psychologie",
                            'fr' => "Psychologie applique" ),
    '140100' => array(      'de' => "Pflege und Gesundheitserziehung",
                            'fr' => "Soins et ducation  la sant" ),
    '140200' => array(      'de' => "Therapie und Rehabilitation",
                            'fr' => "Thrapie et rhabilitation" ),
    '140300' => array(      'de' => "Diagnostische/Therapeutische Technik",
                            'fr' => "Technique diagnostique" ),
    '140900' => array(      'de' => "Gesundheit allgemein",
                            'fr' => "Sant en gnral" ),
    '150100' => array(      'de' => "Vorschul- und Primarstufe",
                            'fr' => "Formation des enseignants pr-primaire et primaire" ),
    '150200' => array(      'de' => "Sekundarstufe I",
                            'fr' => "Formation des enseignants secondaire I" ),
    '150300' => array(      'de' => "Sekundarstufe II (Maturittsschulen)",
                            'fr' => "Formation des enseignants secondaire II (coles de maturit)" ),
    '150400' => array(      'de' => "Heilpdagogik",
                            'fr' => "Pdagogie curative" ),
    '150900' => array(      'de' => "Lehrkrfteausbildung allgemein",
                            'fr' => "Formation des enseignants en gnral" ),
    '999000' => array(      'de' => "Nicht zuteilbar / Leistung fr mehrere Studiengnge gleichzeitig",
                            'fr' => "Non rpartissable / prestation attribue simultanment  plusieurs filires d'tudes" ),
    '999900' => array(      'de' => "Nachdiplomstudium nicht zuteilbar",
                            'fr' => "Etudes postgrades non rpartissables" ),

); // end DESCRIPTION_STUDYBRANCH2

/**
 * Textual descriptions for Study Branch 3.
 */
$DESCRIPTIONS_STUDYBRANCH3= array(
    /* University Study Branch 3 */
    '1201' => array(        'de' => "Theologie fcherbergr./brige",
                            'fr' => "Thologie pluridisc./autres" ),
    '1205' => array(        'de' => "Protestantische Theologie",
                            'fr' => "Thologie protestante" ),
    '1210' => array(        'de' => "Rmisch-katholische Theologie",
                            'fr' => "Thologie catholique-romaine" ),
    '1215' => array(        'de' => "Christkatholische Theologie",
                            'fr' => "Thologie catholique-chrtienne" ),
    '1401' => array(        'de' => "SLW fcherbergr./brige",
                            'fr' => "Langues + littrature pluridisc./autres" ),
    '1405' => array(        'de' => "Linguistik",
                            'fr' => "Linguistique" ),
    '1410' => array(        'de' => "Deutsche SLW",
                            'fr' => "LL allemandes" ),
    '1415' => array(        'de' => "Franzsische SLW",
                            'fr' => "LL fran&ccedil;aises" ),
    '1420' => array(        'de' => "Italienische SLW",
                            'fr' => "LL italiennes" ),
    '1425' => array(        'de' => "Rtoromanische SLW",
                            'fr' => "LL rhetoromaines" ),
    '1429' => array(        'de' => "Andere mod. Sprachen Europas",
                            'fr' => "Autres langues europ. modernes" ),
    '1430' => array(        'de' => "Iberische SLW",
                            'fr' => "LL ibriques" ),
    '1431' => array(        'de' => "Neugriechische SLW",
                            'fr' => "LL grecques modernes" ),
    '1435' => array(        'de' => "Englische SLW",
                            'fr' => "LL anglaises" ),
    '1440' => array(        'de' => "Slawische SLW",
                            'fr' => "LL slaves" ),
    '1445' => array(        'de' => "Nordische SLW",
                            'fr' => "LL nordiques" ),
    '1449' => array(        'de' => "Klass. Sprachen Europas",
                            'fr' => "Langues europennes classiques" ),
    '1450' => array(        'de' => "Klass. SLW",
                            'fr' => "LL anciennes classiques" ),
    '1454' => array(        'de' => "Andere nichteurop. Sprachen",
                            'fr' => "Autres langues non-europennes" ),
    '1455' => array(        'de' => "Asiatische SKW",
                            'fr' => "LC asiatiques" ),
    '1460' => array(        'de' => "Vorderorientalische SKW",
                            'fr' => "LC proche-orientales" ),
    '1465' => array(        'de' => "Afrikanische SKW",
                            'fr' => "LC africaines" ),
    '1470' => array(        'de' => "Dolmetschen + Uebersetzung",
                            'fr' => "Interprtation + traduction" ),
    '1300' => array(        'de' => "Philosophie",
                            'fr' => "Philosophie" ),
    '1500' => array(        'de' => "Archologie, Ur- + Frhgesch.",
                            'fr' => "Archologie + prhistoire" ),
    '1600' => array(        'de' => "Geschichte",
                            'fr' => "Histoire" ),
    '1700' => array(        'de' => "Kunstgeschichte",
                            'fr' => "Histoire de l'art" ),
    '1800' => array(        'de' => "Musikwissenschaft",
                            'fr' => "Musicologie" ),
    '1850' => array(        'de' => "Theater- + Filmwissenschaft",
                            'fr' => "Filmologie + thatrologie" ),
    '1900' => array(        'de' => "Ethnologie + Volkskunde",
                            'fr' => "Ethnologie + sc. des traditions populaires" ),
    '1990' => array(        'de' => "Hist. + Kulturwiss. fcherb./brige",
                            'fr' => "Sci. historiques + culture pluridisc./autres" ),
    '2000' => array(        'de' => "Psychologie",
                            'fr' => "Psychologie" ),
    '2100' => array(        'de' => "Erziehungswissenschaften",
                            'fr' => "Sciences de l'ducation" ),
    '2120' => array(        'de' => "Sonderpdagogik",
                            'fr' => "Pdagogie curative" ),
    '2200' => array(        'de' => "Soziologie",
                            'fr' => "Sociologie" ),
    '2205' => array(        'de' => "Sozialarbeit",
                            'fr' => "Travail social" ),
    '2300' => array(        'de' => "Politikwissenschaft",
                            'fr' => "Sciences politiques" ),
    '2400' => array(        'de' => "Kommunikations- + Medienw.",
                            'fr' => "Communications + mass-media" ),
    '2450' => array(        'de' => "Sozialwiss. fcherbergr./brige",
                            'fr' => "Sci. sociales pluridisc./autres" ),
    '4905' => array(        'de' => "Humangeographie",
                            'fr' => "Gographie humaine" ),
    '1100' => array(        'de' => "Geist./Sozialwiss., brige",
                            'fr' => "Sci. humaines + soc., autres" ),
    '1190' => array(        'de' => "Lehrkrfteausb. Sekundarstufe I (Phil. I)",
                            'fr' => "Form. des enseignants du secondaire I (Phil. I)" ),
    '3701' => array(        'de' => "Lehrkrfteausb. Vorschul- und Primarstufe",
                            'fr' => "Form. des enseignants niveau pr-primaire et primaire" ),
    '2505' => array(        'de' => "Volkswirtschaftslehre",
                            'fr' => "Economie politique" ),
    '2520' => array(        'de' => "Betriebswirtschaftslehre",
                            'fr' => "Economie d'entreprise" ),
    '2530' => array(        'de' => "Betriebsinformatik",
                            'fr' => "Informatique de gestion" ),
    '2540' => array(        'de' => "Wirtschaftsw.  fcherb./brige",
                            'fr' => "Sci. conomiques pluridisc./autres" ),
    '2600' => array(        'de' => "Recht",
                            'fr' => "Droit" ),
    '4200' => array(        'de' => "Mathematik",
                            'fr' => "Mathmatiques" ),
    '4300' => array(        'de' => "Informatik",
                            'fr' => "Informatique" ),
    '4400' => array(        'de' => "Astronomie",
                            'fr' => "Astronomie" ),
    '4500' => array(        'de' => "Physik",
                            'fr' => "Physique" ),
    '4590' => array(        'de' => "Exakte Wiss. fcherbergr./brige",
                            'fr' => "Sci. exactes pluridisc./autres" ),
    '4600' => array(        'de' => "Chemie",
                            'fr' => "Chimie" ),
    '4700' => array(        'de' => "Biologie",
                            'fr' => "Biologie" ),
    '4800' => array(        'de' => "Erdwissenschaften",
                            'fr' => "Sciences de la terre" ),
    '4900' => array(        'de' => "Geographie",
                            'fr' => "Gographie" ),
    '4990' => array(        'de' => "Naturwiss. fcherbergr./brige",
                            'fr' => "Sci. naturelles pluridisc./autres" ),
    '4100' => array(        'de' => "Ex. + Naturw. fcherbergr./brige",
                            'fr' => "Sci. exactes+naturelles pluridisc./autres" ),
    '4103' => array(        'de' => "Lehrkrfteausb. Sekundarstufe I (Phil. II)",
                            'fr' => "Form. des enseignants du secondaire I (Phil. II)" ),
    '6200' => array(        'de' => "Humanmedizin",
                            'fr' => "Mdecine humaine" ),
    '6300' => array(        'de' => "Zahnmedizin",
                            'fr' => "Mdecine dentaire" ),
    '6400' => array(        'de' => "Veterinrmedizin",
                            'fr' => "Mdecine vtrinaire" ),
    '6500' => array(        'de' => "Pharmazie",
                            'fr' => "Pharmacie" ),
    '6100' => array(        'de' => "Medizin + Pharm. fcherb./brige",
                            'fr' => "Mdecine+pharm. pluridisc./autres" ),
    '6150' => array(        'de' => "Pflegewissenschaften",
                            'fr' => "Sciences des soins infirmiers" ),
    '7200' => array(        'de' => "Bauingenieurwesen",
                            'fr' => "Gnie civil" ),
    '7300' => array(        'de' => "Architektur + Planung",
                            'fr' => "Architecture + amnage. du territoire" ),
    '7800' => array(        'de' => "Kulturtechnik + Vermessung",
                            'fr' => "Gnie rural + mensuration" ),
    '7450' => array(        'de' => "Mikrotechnik",
                            'fr' => "Microtechnique" ),
    '7500' => array(        'de' => "Elektroingenieurwesen",
                            'fr' => "Gnie lectrique" ),
    '7550' => array(        'de' => "Kommunikationssysteme",
                            'fr' => "Systmes de communication" ),
    '7600' => array(        'de' => "Maschineningenieurwesen",
                            'fr' => "Gnie mcanique" ),
    '7650' => array(        'de' => "Betriebs- + Produktionsw.",
                            'fr' => "Production + entreprise" ),
    '7700' => array(        'de' => "Materialwissenschaften",
                            'fr' => "Science des matriaux" ),
    '7905' => array(        'de' => "Forstwirtschaft",
                            'fr' => "Sciences forestires" ),
    '7910' => array(        'de' => "Agrarwirtschaft",
                            'fr' => "Agronomie" ),
    '7915' => array(        'de' => "Lebensmittelwissenschaft",
                            'fr' => "Science alimentaire" ),
    '7100' => array(        'de' => "Techn. Wiss., brige",
                            'fr' => "Sci. techniques, autres" ),
    '7400' => array(        'de' => "Chemieingenieurwesen",
                            'fr' => "Gnie chimique" ),
    '1000' => array(        'de' => "Oekologie",
                            'fr' => "Ecologie" ),
    '2130' => array(        'de' => "Sport",
                            'fr' => "Sport" ),
    '8000' => array(        'de' => "Militrwissenschaften",
                            'fr' => "Sciences militaires" ),
    '9000' => array(        'de' => "Interdisziplinre / interfakultre",
                            'fr' => "Interdisciplinaire ou interfacultaire" ),
    '9001' => array(        'de' => "Frauen- / Geschlechterforschung",
                            'fr' => "Etudes femmes / genres" ),
    '9002' => array(        'de' => "Interfakultre Weiterbildung",
                            'fr' => "Formation continue interfacultaire" ),
    '850' => array(         'de' => "Zentrale Verwaltung",
                            'fr' => "Admnistration centrale" ),
    '650' => array(         'de' => "Zentrale Bibliotheken",
                            'fr' => "Bibliothques centrales" ),
    '660' => array(         'de' => "Technische Dienste und Logistik",
                            'fr' => "Services techniques et logistique" ),
    '750' => array(         'de' => "Dienstleistungen fr Mitarbeitende und Studierende",
                            'fr' => "Services pour les collaborateurs et les tudiants" ),

    /* University of Applied Science */
    '10199' => array(       'de' => "Architektur allgemein",
                            'fr' => "Architecture en gnral" ),
    '10201' => array(       'de' => "Bauprozessmanagement",
                            'fr' => "Bauprozessmanagement" ),
    '10299' => array(       'de' => "Bauingenieurwesen allgemein",
                            'fr' => "Gnie civil en gnral" ),
    '10301' => array(       'de' => "Landschaftsarchitektur",
                            'fr' => "Paysagisme" ),
    '10302' => array(       'de' => "Raumplanung",
                            'fr' => "Urbanisme" ),
    '10303' => array(       'de' => "Geomatik",
                            'fr' => "Gomatique" ),
    '10304' => array(       'de' => "Umweltmanagement",
                            'fr' => "Gestion de la nature" ),
    '10499' => array(       'de' => "Holztechnik allgemein",
                            'fr' => "Technique du bois en gnral" ),
    '10999' => array(       'de' => "Fcherbergreifende NDS im Bereich Bauwesen",
                            'fr' => "Etudes postgrades pluridisciplinaires dans le domaine de la construction" ),
    '20201' => array(       'de' => "Elektrotechnik und Automation",
                            'fr' => "Electrotechnique et automatique" ),
    '20203' => array(       'de' => "Energie und Leistung",
                            'fr' => "Energie et puissance" ),
    '20204' => array(       'de' => "Mikroelektronik",
                            'fr' => "Microlectronique" ),
    '20205' => array(       'de' => "Prozess-/Anlagetechnik",
                            'fr' => "Prozess-/Anlagetechnik" ),
    '20299' => array(       'de' => "Elektroingenieurwesen allgemein",
                            'fr' => "Gnie lectrique en gnral" ),
    '20302' => array(       'de' => "Datenanalyse und Prozesse",
                            'fr' => "Analyse de donnes et processus" ),
    '20307' => array(       'de' => "HyperWerk",
                            'fr' => "HyperWerk" ),
    '20309' => array(       'de' => "Informatik und Telekommunikation",
                            'fr' => "Informatique et tlcommunication" ),
    '20310' => array(       'de' => "Kommunikations-Informatik",
                            'fr' => "Kommunikations-Informatik" ),
    '20311' => array(       'de' => "Informationstechnologie",
                            'fr' => "Informationstechnologie" ),
    '20399' => array(       'de' => "Informatik allgemein",
                            'fr' => "Informatique en gnral" ),
    '20402' => array(       'de' => "Heizung, Lftung, Klima",
                            'fr' => "Chauffage, aration, climatisation" ),
    '20406' => array(       'de' => "Mechatronik",
                            'fr' => "Mcatronique" ),
    '20407' => array(       'de' => "Automobiltechnik allgemein",
                            'fr' => "Technique automobile en gnral" ),
    '20408' => array(       'de' => "Wirtschaftsingenieurwesen",
                            'fr' => "Wirtschaftsingenieurwesen" ),
    '20499' => array(       'de' => "Maschinen- und Betriebstechnik allgemein",
                            'fr' => "Gnie mcanique en gnral" ),
    '20599' => array(       'de' => "Telekommunikation allgemein",
                            'fr' => "Tlcommunication en gnral" ),
    '20602' => array(       'de' => "Mikrotechnik/Feinwerktechnik",
                            'fr' => "Microtechnique" ),
    '20603' => array(       'de' => "Physikalische Technik",
                            'fr' => "Physique applique" ),
    '20699' => array(       'de' => "Systemtechnik allgemein",
                            'fr' => "Technique des systmes en gnral" ),
    '20799' => array(       'de' => "Drucktechnik allgemein",
                            'fr' => "COMEM, industrie graphique en gnral" ),
    '20999' => array(       'de' => "Fcherbergreifende NDS im Bereich Technik",
                            'fr' => "Etudes postgrades pluridisciplinaires dans le domaine technique" ),
    '30102' => array(       'de' => "Verfahrenstechnik",
                            'fr' => "Chimie technique" ),
    '30199' => array(       'de' => "Chemie allgemein",
                            'fr' => "Chimie en gnral" ),
    '30298' => array(       'de' => "Lebensmitteltechnologie",
                            'fr' => "Sciences alimentaires" ),
    '30299' => array(       'de' => "Biotechnologie allgemein",
                            'fr' => "Biotechnologie en gnral" ),
    '30999' => array(       'de' => "Fcherbergreifende NDS im Bereich Chemie",
                            'fr' => "Etudes postgrades pluridisciplinaires dans le domaine de la chimie" ),
    '40101' => array(       'de' => "Internationale Landwirtschaft",
                            'fr' => "Agriculture internationale" ),
    '40102' => array(       'de' => "Forstwirtschaft",
                            'fr' => "Economie forestire" ),
    '40199' => array(       'de' => "Agrarwirtschaft allgemein",
                            'fr' => "Agriculture en gnral" ),
    '40201' => array(       'de' => "Pflanzenproduktion",
                            'fr' => "Production vgtale" ),
    '40202' => array(       'de' => "Obst-,Wein-,Gartenbau",
                            'fr' => "Arboriculture fruitire/Horticulture" ),
    '40205' => array(       'de' => "Oenologie",
                            'fr' => "Oenologie" ),
    '40301' => array(       'de' => "Tierproduktion",
                            'fr' => "Production animale" ),
    '40402' => array(       'de' => "Milchwirtschaft",
                            'fr' => "Economie laitire" ),
    '40999' => array(       'de' => "Fcherbergreifende NDS im Bereich Landwirtschaft",
                            'fr' => "Etudes postgrades pluridisciplinaires dans le domaine de l'agriculture" ),
    '50106' => array(       'de' => "Internationale Beziehungen",
                            'fr' => "Relations internationales" ),
    '50107' => array(       'de' => "Technische Betriebswirtschaft",
                            'fr' => "Technische Betriebswirtschaft" ),
    '50199' => array(       'de' => "Betriebskonomie allgemein",
                            'fr' => "Economie d'entreprise en gnral" ),
    '50201' => array(       'de' => "Hotellerie und Gastronomie",
                            'fr' => "Htellerie et gastronomie" ),
    '50202' => array(       'de' => "Facility Management",
                            'fr' => "Facility Management" ),
    '50203' => array(       'de' => "Tourismus und Mobilitt",
                            'fr' => "Tourismus und Mobilitt" ),
    '50204' => array(       'de' => "Tourism and Hospitality",
                            'fr' => "Tourism and Hospitality" ),
    '50399' => array(       'de' => "Wirtschaftsinformatik allgemein",
                            'fr' => "Informatique de gestion en gnral" ),
    '50499' => array(       'de' => "Information und Dokumentation allgemein",
                            'fr' => "Information et documentation en gnral" ),
    '50501' => array(       'de' => "Wirtschaftskommunikation",
                            'fr' => "Wirtschaftskommunikation" ),
    '50502' => array(       'de' => "Fachjournalismus und Unternehmenskommunikation",
                            'fr' => "Fachjournalismus und Unternehmenskommunikation" ),
    '50999' => array(       'de' => "Fcherbergreifende NDS im Bereich Wirtschaft",
                            'fr' => "Etudes postgrades pluridisciplinaires dans le domaine de l'conomie" ),
    '60199' => array(       'de' => "Visuelle Kommunikation allgemein",
                            'fr' => "Communication visuelle en gnral" ),
    '60299' => array(       'de' => "Innenarchitektur allgemein",
                            'fr' => "Architecture d'intrieur en gnral" ),
    '60399' => array(       'de' => "Produkte- und Industriedesign allgemein",
                            'fr' => "Design industriel et des produits en gnral" ),
    '60499' => array(       'de' => "Konservierung - Restaurierung allgemein",
                            'fr' => "Conservation - restauration en gnral" ),
    '60999' => array(       'de' => "Fcherbergreifende NDSim Bereich Gestaltung",
                            'fr' => "Etudes postgrades pluridisciplinaires dans le domaine des arts appliqus" ),
    '70101' => array(       'de' => "Sportunterricht",
                            'fr' => "Enseignement du sport" ),
    '80199' => array(       'de' => "Bildende Kunst allgemein",
                            'fr' => "Art visuel en gnral" ),
    '80201' => array(       'de' => "Bildnerisches Gestalten",
                            'fr' => "Cration visuelle" ),
    '80202' => array(       'de' => "Werklehrer/Werklehrerin",
                            'fr' => "Enseignement des travaux manuels" ),
    '80203' => array(       'de' => "Aesthetische Erziehung",
                            'fr' => "Education esthtique" ),
    '80299' => array(       'de' => "Lehrerbildung fr Kunstfcher allgemein",
                            'fr' => "Formation d'enseignants pour domaines art. en gnral" ),
    '90101' => array(       'de' => "Musikpdagogik (instrumental und vokal)",
                            'fr' => "Pdagogie musicale (instrumentale et vocale)" ),
    '90201' => array(       'de' => "Interpretation/Performance",
                            'fr' => "Interprtation/Performance" ),
    '90301' => array(       'de' => "Schul- und Kirchenmusik",
                            'fr' => "Musique spirituelle et enseign. de la musique  l'cole" ),
    '90401' => array(       'de' => "Dirigieren",
                            'fr' => "Direction" ),
    '90501' => array(       'de' => "Spezialausbildungen in Musik",
                            'fr' => "Formations musicales spcialises" ),
    '90999' => array(       'de' => "Musik allgemein",
                            'fr' => "Musique en gnral" ),
    '100101' => array(      'de' => "Theaterschaffen in den darstellenden Knsten",
                            'fr' => "Cration dans les arts de la scne" ),
    '100201' => array(      'de' => "Bewegungs-, Sprech- und Stimmerziehung",
                            'fr' => "Expression corporelle et vocale" ),
    '100301' => array(      'de' => "Szenelehrkrfte",
                            'fr' => "Formation des enseignants pour la mise en scne" ),
    '100401' => array(      'de' => "Spezialausbildungen in Theater",
                            'fr' => "Formations thtrales spcialises" ),
    '100999' => array(      'de' => "Theater allgemein",
                            'fr' => "Thtre en gnral" ),
    '110199' => array(      'de' => "bersetzen allgemein",
                            'fr' => "Traduction en gnral" ),
    '110299' => array(      'de' => "Dolmetschen allgemein",
                            'fr' => "Interprtation en gnral" ),
    '110999' => array(      'de' => "Angewandte Linguistik allgemein",
                            'fr' => "Linguistique applique en gnral" ),
    '120199' => array(      'de' => "Sozialarbeit allgemein",
                            'fr' => "Service social en gnral" ),
    '120299' => array(      'de' => "Sozialpdagogik allgemein",
                            'fr' => "Education sociale en gnral" ),
    '120399' => array(      'de' => "Soziokulturelle Animation allgemein",
                            'fr' => "Animation socioculturelle en gnral" ),
    '120999' => array(      'de' => "Allgemeine Soziale Arbeit allgemein",
                            'fr' => "Travail social en gnral" ),
    '130101' => array(      'de' => "Psychologische Diagnostik und Beratung",
                            'fr' => "Diagnostique psychologique et conseil" ),
    '130102' => array(      'de' => "Berufsberatung",
                            'fr' => "Conseil professionnel" ),
    '130103' => array(      'de' => "Arbeits- und Organisationspsychologie",
                            'fr' => "Psychologie des organisations et du travail" ),
    '130999' => array(      'de' => "Angewandte Psychologie allgemein",
                            'fr' => "Psychologie applique en gnral" ),
    '140101' => array(      'de' => "Pflege",
                            'fr' => "Soins infirmiers" ),
    '140102' => array(      'de' => "Hebamme",
                            'fr' => "Sages-femmes et hommes sages-femmes" ),
    '140199' => array(      'de' => "Pflege und Gesundheitserziehung allgemein",
                            'fr' => "Soins et ducation  la sant en gnral" ),
    '140201' => array(      'de' => "Physiotherapie",
                            'fr' => "Physiothrapie" ),
    '140202' => array(      'de' => "Ergotherapie",
                            'fr' => "Ergothrapie" ),
    '140203' => array(      'de' => "Medizinische Psychomotorik",
                            'fr' => "Psychomotricit mdicale" ),
    '140204' => array(      'de' => "Ernhrungsberatung",
                            'fr' => "Dittique" ),
    '140299' => array(      'de' => "Therapie und Rehabilitation allgemein",
                            'fr' => "Thrapie et rhabilitation en gnral" ),
    '140301' => array(      'de' => "Medizinische Radiologie",
                            'fr' => "Radiologie mdicale" ),
    '140399' => array(      'de' => "Diagnostische/Therapeutische Technik allgemein",
                            'fr' => "Technique diagnostique et thrapeutique en gnral" ),
    '140999' => array(      'de' => "Gesundheit allgemein",
                            'fr' => "Sant en gnral" ),
    '150101' => array(      'de' => "Vorschul- und Primarstufe allgemein",
                            'fr' => "Niveau pr-primaire et primaire en gnral" ),
    '150201' => array(      'de' => "Sekundarstufe I allgemein",
                            'fr' => "Niveau secondaire I en gnral" ),
    '150301' => array(      'de' => "Sekundarstufe II (Maturittsschulen)",
                            'fr' => "Niveau secondaire II en gnral (coles de maturit)" ),
    '150401' => array(      'de' => "Logopdie",
                            'fr' => "Logopdie" ),
    '150402' => array(      'de' => "Psychomotorik",
                            'fr' => "Thrapie psychomoteur" ),
    '150499' => array(      'de' => "Heilpdagogik allgemein",
                            'fr' => "Pdagogie curative en gnral" ),
    '150999' => array(      'de' => "Lehrkrfteausbildung allgemein",
                            'fr' => "Formation des enseignants en gnral" ),
    '999000' => array(      'de' => "Nicht zuteilbar / Leistung fr mehrere Studiengnge gleichzeitig",
                            'fr' => "Non rpartissable / prestation attribue simultanment  plusieurs filires d'tudes" ),
    '999999' => array(      'de' => "Nachdiplomstudium nicht zuteilbar",
                            'fr' => "Etudes postgrades non rpartissables" ),

); // end DESCRIPTION_STUDYBRANCH3

/**
 * Study Level descriptions.
 *
 * WARNING: only temporary solution for ETHZ (Thomas Piendl - NET ETHZ)
 */
$DESCRIPTIONS_STUDYLEVEL= array(
    '00' => array(  'de' => "Vorbereitungskurs, Gaststudent",
                    'fr' => "" ),
    '10' => array(  'de' => "Student ohne 2. Vordiplom, zum Lizentiat oder Lehrpatent",
                    'fr' => "" ),
    '15' => array(  'de' => "Bachelor-Student",
                    'fr' => "" ),
    '20' => array(  'de' => "Student mit 2. Vordiplom",
                    'fr' => "" ),
    '25' => array(  'de' => "Master-Student mit Bachelor",
                    'fr' => "" ),
    '26' => array(  'de' => "Master-Student ohne Bachelor (direkter Master)",
                    'fr' => "" ),
    '31' => array(  'de' => "Doktoratstudent",
                    'fr' => "" ),
    '32' => array(  'de' => "Nachdiplomstudent",
                    'fr' => "" ),
    '39' => array(  'de' => "Individualstudent im Nachdiplomstudium",
                    'fr' => "" ),

 ); // end DESCRIPTION_STUDYLEVEL

/**
 * Static helper class to get textual description of AAI attributes Study
 * Branch 1, 2, 3 and Study Level.
 *
 * See: http://www.switch.ch/aai/studybranch.html
 *
 * @author Valery Tschopp - SWITCH
 * @version $Revision: 1.5 $
 */
class AAIAttributes {

    /**
    * Returns the description of the Study Branch 1 given its number and lang.
    *
    * @param string $studybranch1 The study branch 1 number.
    * @param string $lang         The language 'de' or 'fr'. Default: 'de'
    * @return The textual description of the StudyBranch1 or the given parameter 
    *         if no description is available.
    * @static
    */
    function getStudyBranch1Description( $studybranch1, $lang= 'de' ) {
        global $DESCRIPTIONS_STUDYBRANCH1;
        $branches= explode( ';', $studybranch1 );
        $descriptions= array();
        foreach( $branches as $branch ) {
            $branch= trim( $branch );
            if (array_key_exists( $branch, $DESCRIPTIONS_STUDYBRANCH1 ) ) {
                $desc= $DESCRIPTIONS_STUDYBRANCH1[$branch][$lang];
                $desc.= " ($branch)";
                $descriptions[]= $desc;
            }
            else {
                $descriptions[]= "$branch";
            }
        }
        $description= implode('; ', $descriptions);
        return $description;
    }

    /**
    * Returns the description of the Study Branch 2 given its number and lang.
    *
    * @param string $studybranch1 The study branch 2 number.
    * @param string $lang         The language 'de' or 'fr'. Default: 'de'
    * @return The textual description of the StudyBranch2 or the given parameter 
    *         if no description is available.
    * @static
    */
     function getStudyBranch2Description( $studybranch2, $lang= 'de' ) {
        global $DESCRIPTIONS_STUDYBRANCH2;
        $branches= explode( ';', $studybranch2 );
        $descriptions= array();
        foreach( $branches as $branch ) {
            $branch= trim( $branch );
            if (array_key_exists( $branch, $DESCRIPTIONS_STUDYBRANCH2 ) ) {
                $desc= $DESCRIPTIONS_STUDYBRANCH2[$branch][$lang];
                $desc.= " ($branch)";
                $descriptions[]= $desc;
            }
            else {
                $descriptions[]= "$branch";
            }
        }
        $description= implode('; ', $descriptions);
        return $description;
    }

    /**
    * Returns the description of the Study Branch 3 (multi-valued allowed)
    * given its number (multi-valued separated by ';') and lang.
    *
    * @param string $studybranch3 The study branch 3 numbers.
    * @param string $lang         The language 'de' or 'fr'. Default: 'de'
    * @return The textual description of the StudyBranch3
    *         or branch 3 number if no description is available.
    * @static
    */
    function getStudyBranch3Description( $studybranch3, $lang= 'de' ) {
        global $DESCRIPTIONS_STUDYBRANCH3;
        $branches= explode( ';', $studybranch3 );
        $descriptions= array();
        foreach( $branches as $branch ) {
            $branch= trim( $branch );
            if (array_key_exists( $branch, $DESCRIPTIONS_STUDYBRANCH3 ) ) {
                $desc= $DESCRIPTIONS_STUDYBRANCH3[$branch][$lang];
                $desc.= " ($branch)";
                $descriptions[]= $desc;
            }
            else {
                $descriptions[]= "$branch";
            }
        }
        $description= implode('; ', $descriptions);
        return $description;
    }

    /**
    * Returns the description of the Study Level given its composed 
    * number (branch3-level) and lang (multi-valued separated by ';').
    *
    * @param string $studylevel   The study level composed number (branch3-level).
    * @param string $lang         The language 'de' or 'fr'. Default: 'de'
    * @return The textual description of the StudyLevel or the given parameter 
    *         if no description is available.
    * @static
    */
    function getStudyBranchLevelDescription( $branch3_level, $lang= 'de' ) {
        global $DESCRIPTIONS_STUDYLEVEL;
        $branch3levels= explode(';', $branch3_level);
        $descriptions= array();
        foreach($branch3levels as $branch3level) {
            $branch3level= trim($branch3level);
            // branch3-level => branch3, level
            if ( ereg("([0-9]{3,6})-([0-9]{2})", $branch3level, $elts) ) {
                $level= trim($elts[2]);
                if (array_key_exists( $level, $DESCRIPTIONS_STUDYLEVEL ) ) {
	               $desc= $DESCRIPTIONS_STUDYLEVEL[$level][$lang];
	               $desc.= " ($branch3level)";
	               $descriptions[]= $desc;
                }
                else {
                    $descriptions[]= "$branch3level";
                }
            }
            else {
                $descriptions[]= "$branch3level";
            }
        }
        $description= implode('; ', $descriptions);
        return $description;
    }

}

?>
