<?php
/* ****************************************************************** */
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 *
 * Copyright (C) 2004 SWITCH (http://www.switch.ch)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: WebCTIMS_XMLParser.class.inc,v 1.2 2004/10/12 11:08:58 vlry Exp $
 */

/**
* WebCTIMS_XMLParser is a utility class for writing a well-formed and
* properly indenten IMS objects as XML stream. Output is written to an 
* internal string buffer and can be retrieved using the method
* {@link getBuffer() }.
*
* @version $Revision: 1.2 $
* @author Valery Tschopp - SWITCH
* @package WebCTAPI 
*/
class WebCTIMS_XMLParser {

  /* ***************************************************************** */
  /*                    static methods                                 */
  /* ***************************************************************** */

  /* ***************************************************************** */
   /*                    private fields                                 */
   /* ***************************************************************** */
   
   /**
   * the string buffer
   *
   * @var string
   * @access private
   */ 
   var $xml_= "";
   var $xml_tree_= array();
    var $xml_parser_error_= null;
   
   /* ***************************************************************** */
   /*                    constructor                                    */
   /* ***************************************************************** */   
   function WebCTIMS_XMLParser() {    
   }
   
  /* ***************************************************************** */
  /*                    methods                                        */
   /* ***************************************************************** */   

    function parse($xml_data) {
        $this->xml_= $xml_data;

        $xmlp= xml_parser_create();
        xml_parser_set_option($xmlp, XML_OPTION_CASE_FOLDING, 0);
        xml_parser_set_option($xmlp, XML_OPTION_SKIP_WHITE, 1);
        xml_parse_into_struct( $xmlp, $this->xml_, $elements);
        $xml_error= xml_get_error_code($xmlp);
        xml_parser_free($xmlp);

        if ($xml_error) {
            //XXX echo "XXX:WebCTIMS_XMLParser:parse:ERROR:\n{$this->xml_}\n---\n";
            $this->xml_parser_error_= xml_error_string($xml_error);
            return false;
        }   

        //XXX echo "XXX:elements: "; var_dump($elements);


        // build XML tree
        $level = array();
        foreach ($elements as $xml_elem) {
            if ($xml_elem['type'] == 'open') {
                $level[$xml_elem['level']] = $xml_elem['tag'];
                //if (array_key_exists('attributes',$xml_elem)) {
                //    list($level[$xml_elem['level']]) = array_values($xml_elem['attributes']);
                //} 
                //else {
                //    $level[$xml_elem['level']] = $xml_elem['tag'];
                //}
            }
            if ($xml_elem['type'] == 'complete') {
                $start_level = 1;
                $php_stmt = '$this->xml_tree_';
                while($start_level < $xml_elem['level']) {
                    $php_stmt .= '[$level['.$start_level.']]';
                    $start_level++;
                }
                $php_stmt .= '[$xml_elem[\'tag\']] = $xml_elem[\'value\'];';
                //XXX echo "XXX:eval: $php_stmt\n";
                eval($php_stmt);
            }
        }

//XXX
/*
echo "XXX:-->\n";
var_dump($this->xml_tree_);
echo "XXX:<--\n";
*/
        return true;

    }

    function getTree() {
        return $this->xml_tree_;
    }

    function getError() {
        return $this->xml_parser_error_;
    }

    /**
    * Resets the internal string buffer to the empty string
    */
    function reset() {
        $this->xml_= "";  
        $this->xml_tree_= array();
        $this->xml_parser_error_= null;
    }

}


?>
