<?php
/*
* SNA-Portal mediates between one or more Authentication and Authorisation
* Infrastructures and non-AAI-enabled roles.
* Copyright (C) 2003 Swiss Virtual Campus (http://www.swissvirtualcampus.ch)
* Copyright (C) 2004 SWITCH (http://www.switch.ch)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
* $Id: WebCTVistaIMS_Constants.inc,v 1.5 2006/01/25 08:38:29 vlry Exp $
*/
/**
* This file includes common constant definitions for the WebCT Vista
* IMS API.
*
* @author Valery Tschopp - SWITCH
* @version $Revision: 1.5 $
*
* @package WebCTAPI
*/



//
// params used in POST request
//
define('WEBCTVISTA_IMS_PARAM_ADAPTOR',    "adapter");
define('WEBCTVISTA_IMS_PARAM_ACTION',     "action");
define('WEBCTVISTA_IMS_PARAM_OPTION',     "option");
define('WEBCTVISTA_IMS_PARAM_TIMESTAMP',  "timestamp");
define('WEBCTVISTA_IMS_PARAM_GLCID',      "glcid");
define('WEBCTVISTA_IMS_PARAM_CHECKSUM',   "checksum");
define('WEBCTVISTA_IMS_PARAM_MAC',        "auth");
define('WEBCTVISTA_IMS_PARAM_WEBCTID',    "webctid");
define('WEBCTVISTA_IMS_PARAM_IMS_ID',     "ims_id");
define('WEBCTVISTA_IMS_PARAM_IMS_SOURCE', "ims_source");

define('WEBCTVISTA_IMS_ACTION_IMPORT', "import");
define('WEBCTVISTA_IMS_ACTION_EXPORT', "export");
define('WEBCTVISTA_IMS_ACTION_GET',    "get");

//
// options for action=import
//
define('WEBCTVISTA_IMS_OPTION_RESTRICT', "restrict");
define('WEBCTVISTA_IMS_OPTION_UNRESTRICT', "unrestrict");

// option for action=get
define('WEBCTVISTA_IMS_OPTION_CONSORTIAID', "consortia_id");

// option for action=export
define('WEBCTVISTA_IMS_OPTION_PERSONRECORD', "person_record");

//
// adapter
//
define('WEBCTVISTA_IMS_ADAPTOR_IMS', "ims");
define('WEBCTVISTA_IMS_ADAPTOR_SCT', "sct");
define('WEBCTVISTA_IMS_ADAPTOR_STANDARD', "standard");

//
// recstatus:
// 1 Create, 2 Update, 3 Delete
//
// <person recstatus="$recstatus">
// ...
// </person>
//
// <membership>
//   ...
//   <member>
//      ...
//      <role recstatus="$recstatus" roletype="$roletype">
//      ...
//      </role>
//   </member>
// </membership>
//
define('WEBCTVISTA_IMS_OBJECT_RECSTATUS_CREATE', 1);
define('WEBCTVISTA_IMS_OBJECT_RECSTATUS_UDPDATE', 2);
define('WEBCTVISTA_IMS_OBJECT_RECSTATUS_DELETE', 3);




?>
