<?php
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 *
 * Copyright (C) 2003  Swiss Virtual Campus (http://www.swissvirtualcampus.ch) 
 * Copyright (C) 2004-2005  SWITCH (http://www.switch.ch) 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *
 * $Id: change-language.php,v 1.4 2005/03/04 12:57:18 vlry Exp $
 */


/**
* This page displays an input form for selecting the current language
* in the SNA-Portal.
*
* <b>Request Parameters</b>
* <ul>
*   <li>_locale=<value>: the new locale to be set
* </ul>
*
*
* @version $Revision: 1.4 $
* @package adminPortal
*/

/**
 */
 

// Headerfile for documentation database
require_once("include/application.inc");

// start session and ensure access restrictions
//
Session::ensureAdminSessionValid();

//
// make sure the current user exists
//
$uid= Session::getUID();
$admin=& Administrator::reconstituteByUid($uid);
if (is_null($admin)) {
    ErrorHandling::fatalErrorAndExit("Could not reconstitute user: $uid");
}
Session::init($admin);

// handling request paramters
//
if (isset($_REQUEST["do_apply"])) {
  if (isset($_REQUEST["_locale"]) && I18N::isSupportedLocale( $_REQUEST["_locale"] )) {
     $locale= $_REQUEST["_locale"];
     $locale= strtolower($locale);
     $admin->storeAttribute(ATID_PREFERREDLANGUAGE, $locale); 
     Session::setLocale( $admin );
  }
}


I18N::initLocale();

// include the common header
//
include("include/adminHeader.inc");

?>
  <h1>My Language (<?= I18N::getLocale() ?>)</h1>
 
  <p>You can set your default language. All notification emails you send will use this locale.</p>
  <p>This setting is stored in your profile.</p>
 
  <form action="<?= $_SERVER['PHP_SELF'] ?>" method="post">
  <table width="50%" border="0" cellspacing="0" class="form-table">
    <tr>
    <td valign="top" align="center" class="form-head" colspan=2>
      Choose your language
    </td>    
     </tr>  
    <tr>
	    <td width="30%" valign="top" class="form-label">
              Language
            </td>
	    <td width="70%" valign="top" class="form-entry">
                <select name="_locale" >
                <?php
                   $languages = I18N::getSupportedLocales();
                   foreach($languages as $langid => $langdisplayname): 
                     $selected = (I18N::getLocale() == $langid) ? "SELECTED" : "";
                ?>
                    <option value="<?= $langid ?>" <?= $selected ?> ><?= $langdisplayname ?></option> 
                <?php endforeach; ?>
               </select>
	     </td>
    </tr>
  <tr>
    <td valign="top" align="center" class="form-control" colspan=2>
      <input name="do_apply" type="submit" value="Apply" class="button">
    </td>    
  </tr>    
  </table>
  </form>

<?php
// include the common footer
//
include("include/adminFooter.inc");
?>
