<?php
/* ****************************************************************** */
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 * Copyright (C) 2003  Swiss Virtual Campus (http://www.swissvirtualcampus.ch) 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *
 * $Id: email.php,v 1.13 2006/08/25 10:38:29 vlry Exp $
 */
/* ****************************************************************** */

/**
* This is the start page for the administration part of the SNA-Portal.
*
* 
* @version $Revision: 1.13 $
* @package AdminPortal
*/


// bootstrap application
//
require_once("include/application.inc");
require_once("lookandfeel/current/lf-specific-functions.inc");


//
// resume the current session and make sure we have a valid session
//
Session::ensureAdminSessionValid();

$uid= Session::getUID();
$admin=& Administrator::reconstituteByUid($uid);
if (is_null($admin)) {
  ErrorHandling::fatalErrorAndExit("current user is not priviledged to enter this page"); 
}
Session::init($admin);


/* check if this is intended as an sms send form */
if (isset($_REQUEST['sms']) and $_REQUEST['sms'] == "1") {
	/* sms behaviour */
	$sms = true;
} else {
	/* email behaviour */
	$sms = false;
}	


if (isset($_POST['to']) && isset($_POST['body'])) {
	/* form already filled out */
	$to= trim($_POST['to']);
	$body= $_POST['body'];
	if (get_magic_quotes_gpc()) {
        $body= stripslashes($body);
    }
	$message =& new Messaging();
	$ok = false;
	/* getting adminitrator email address */
	$from = $admin->getAttribute(ATID_MAIL);

	if ($sms) {
		$ok = $message->sendAsSMS($from, $to, $body);
	} else {
		$useBcc = false;
		if (isset($_POST['useBcc'])) {
			$useBcc = true;
		}
		$subject= $_POST['subject'];
		$ok = $message->sendAsMail($from, $to, $subject, $body, $useBcc);
	}
	/* display html sent confirmation */
	$error= null;
    $error= $message->error;
    displaySentConfirmation($ok, $error);

} else {	
	/* display html email form */
	displayMailForm($sms);
}


/* **************************************************************** */
/*                     functions                                    */
/* **************************************************************** */

function displaySentConfirmation($ok, $error= '') {

	if ($ok) {
		$text = "<b>Message sent out successfully</b>";
        if (!empty($error)) {
            $text.= "<p><i>But following error occurs:</i><br>$error.";
        }
	} else {
		$text = "<b>Error:</b> $error.<p>Please contact the Portal Administrator.";
	}	

	/* output html */
	?>
	
	<html>
	<head>
	<link rel="stylesheet" href="<?= lf_get_admin_style_sheet_url() ?>" type="text/css">
	<title></title>
	</head>
	<body>
	<table align="center">
		<tr>
			<td>&nbsp;<td>
		</tr>
		<tr>
			<td>&nbsp;<td>
		</tr>
		<tr>
			<td><?= $text ?></td>
		</tr>
		<tr>
			<td>&nbsp;<td>
		</tr>
		<tr>
			<td align="center"><a href="javascript:window.close();">Close Window</a></td>
		</tr>
	</table>
	</body>
	</html>

	<?php

}


function displayMailForm($sms = false) {

	$message =& new Messaging();
	
	$maxSMSLength = $message->getMaxSMSLength();
	if ($sms) {
		$title = "SNAportal - SMS Sender";
	} else {
		$title = "SNAportal - Email Sender";
	}

	/* output html */
	?>
	
	<html>
	<head>
	<link rel="stylesheet" href="<?= lf_get_admin_style_sheet_url() ?>" type="text/css">
	<title><?= $title ?></title>
	</head>

	<script language="JavaScript">
	
	function textCounter(field, countfield, maxlimit) {
		if ( field.value.length > maxlimit ) {
			field.value = field.value.substring( 0, maxlimit );
			alert( 'SMS message can only be ' + maxlimit + ' characters in length.' );
			return false;
		} else {
			countfield.value = maxlimit - field.value.length;
		}
	}

	</script>
	<body>
	<form action="" method="post">
	<table>
		<tr>
			<td colspan="2" align="center"><h1><?= $title ?></h1></td>
		</tr>
		<tr>
			<td>Recepient(s)</td>
			<td><input type="text" name="to" value="<?= $_GET['recs'] ?>" size="60"></td>
		</tr>
	<?php if (!$sms): ?>	
		<tr>
			<td>Recepients as Bcc</td>
			<td><input type="checkbox" name="useBcc"></td>
		</tr>
		<tr>
			<td>Subject</td>
			<td><input type="text" name="subject" value="<?= $message->getDefaultSubject() ?>" size="60"></td>
		</tr>
		<tr>
			<td>Body</td>
			<td><textarea name="body" cols="60" rows="10"></textarea></td>
		</tr>
	<?php else: ?>	
		<tr>
			<td>Body</td>
			<td><textarea name="body" cols="60" rows="6" onKeyPress="textCounter(this,this.form.counter,<?= $maxSMSLength ?>);"></textarea></td>
		</tr>
		<tr>
			<td colspan="2" align="right"><input type="text" name="counter" value="<?= $maxSMSLength ?>" size="3"> characters left</td>
		</tr>
		<input type="hidden" name="sms" value="1">
	<?php endif; ?>	
		<tr>
			<td colspan="2" align="right"><input type="submit" name="close" value="Cancel &amp; Close" onClick="javascript:window.close()">&nbsp;<input type="submit" name="submit" value="Send"></td>
		</tr>
	</table>
	</form>
	</body>
	</html>
	
	<?php 
	
}
	
?>
