<?php
	
	// bootstrap application
	//
	require_once("include/application.inc");
	
	//
	// resume the current session and make sure we have a valid session
	//
	Session::ensureAdminSessionValid();
	
	$uid= Session::getUID();
	$admin=& Administrator::reconstituteByUid($uid);
	if (is_null($admin)) {
		ErrorHandling::fatalErrorAndExit("current user is not priviledged to enter this page"); 
	}
	Session::init($admin);
	
	// search params
	$search_field= 'action_title'; // default: Title
	$search_func= 2; // default: starts with
	if (Session::exists('action_search_field')) {
		$search_field= Session::get('action_search_field');
	}
	if (isset($_REQUEST['action_search_field'])) {
		$search_field= $_REQUEST['action_search_field'];
		Session::set('action_search_field', $search_field);
	}
	if (Session::exists('action_search_func')) {
		$search_func= Session::get('action_search_func');
	}
	if (isset($_REQUEST['action_search_func'])) {
		$search_func= $_REQUEST['action_search_func'];
		Session::set('action_search_func', $search_func);
	}
	//XXX
	//print "XXX:search_field= $search_field<br>";
	//print "XXX:search_func= $search_func<br>";
	
	$search_value= null;
	$search_sql_value= null;
	$is_search= false;
	if (isset($_REQUEST['action_search_value']) and !empty($_REQUEST['action_search_value'])) {
		//XXX print "XXX:search_value= {$_REQUEST['search_value']}<br>";
		$search_value= trim($_REQUEST['action_search_value']);
		$is_search= true;
		switch ($search_func) {
			case 1: $search_sql_value= $search_value; break; // is
			case 2: $search_sql_value= "$search_value%"; break; // starts with
			case 3: $search_sql_value= "%$search_value"; break; // ends with
			case 4: $search_sql_value= "%$search_value%"; break; // contains
			default: $search_sql_value= "%$search_value%"; break;
		}
	}
	
	// orderby in request?
	$orderby= 'action_title'; // default sorting
	if (Session::exists('action_order_by')) {
		$orderby= Session::get('action_order_by');
	}
	if (isset($_REQUEST['order_by'])) {
		$orderby= $_REQUEST['order_by'];
		Session::set('action_order_by', $orderby);
	}
	//XXX
	//print "orderby: $orderby<br>";
	
	// limit offset, count
	$limit_offset= 0;
	if (isset($_REQUEST['limit_offset'])) {
		$limit_offset= $_REQUEST['limit_offset'];
	}
	$limit_count= 100; // default 100 actions/page
	if (Session::exists('limit_count')) {
		$limit_count= Session::get('limit_count');
	}
	if (isset($_REQUEST['limit_count'])) {
		$limit_count= $_REQUEST['limit_count'];
		Session::set('limit_count', $limit_count);
	}
	
	$n_actions= Action::getActionCount($search_field,$search_sql_value);
	if ($is_search) {
		$total_actions= Action::getActionCount();
	}
	$n_pages= ceil( $n_actions / $limit_count );
	$page_n= ($limit_offset / $limit_count ) + 1;
	
	
	/* ****************************************************************** */
	/*                     page content                                   */
	/* ****************************************************************** */
	include("include/adminHeader.inc");
	?>

<script language="JavaScript">
<!--
function delete_action(rid) {
	if (confirm("Do you really want to delete this action ?")) {
		window.open(
					"<?= PORTAL_BASE_URL ?>/admin/delete-action.php?" 
					+ "aid=" + rid 
					+ "&url=<?= PORTAL_BASE_URL ?>/admin/list-actions.php"
					
					, "_self"
					); 
	}
}

function orderby(attr_name) {
    document.form_controller.order_by.value= attr_name;
    document.form_controller.submit();
}

function change_limit_count() {
    var lcount= parseInt(document.form_controller.limit_count_list.value);
    document.form_controller.limit_count.value= lcount;
    document.form_controller.limit_offset.value= 0;
    document.form_controller.submit();
}


function goto_page( page_n ) {
    var lcount= parseInt(document.form_controller.limit_count.value);
    document.form_controller.limit_offset.value= lcount * ( page_n - 1 );
    document.form_controller.submit();
}

function prev_page() {
    var loffset= parseInt(document.form_controller.limit_offset.value);
    var lcount= parseInt(document.form_controller.limit_count.value);
    document.form_controller.limit_offset.value= loffset - lcount;
    document.form_controller.submit();
}
function next_page() {
    var loffset= parseInt(document.form_controller.limit_offset.value);
    var lcount= parseInt(document.form_controller.limit_count.value);
    document.form_controller.limit_offset.value= loffset + lcount;
    document.form_controller.submit();
}

function do_search() {
    document.form_controller.limit_offset.value= 0;
    document.form_controller.submit();
}

function clear_search() {
    document.form_controller.action_search_value.value= "";
    document.form_controller.limit_offset.value= 0;
    document.form_controller.submit();
}
// -->
</script>

<h1>All Actions
<?php if ($is_search): ?>
(Filtered Result)
<?php endif; ?>
</h1>

<form name="form_controller" action="<?= $_SERVER['PHP_SELF'] ?>" method="POST">
<input type="hidden" name="order_by" value="<?= $orderby ?>" />
<input type="hidden" name="limit_offset" value="<?= $limit_offset ?>" />
<input type="hidden" name="limit_count" value="<?= $limit_count ?>" />
<!-- SEARCH FUNCTION BEGIN -->
Show actions where <select name="action_search_field">
<?php
    $search_fields= array('action_name' => 'Action Name', 'action_title' => 'Action Title');
    foreach($search_fields as $field => $name) {
        $selected= "";
        if ($field == $search_field) { $selected= "selected ";}
        print "<option value=\"$field\" $selected>$name";
    }
	?>
</select>
<select name="action_search_func">
<?php
    $search_funcs= array(1 => 'is', 2 => 'starts with', 3 => 'ends with', 4 => 'contains');
    foreach($search_funcs as $func => $name) {
        $selected= "";
        if ($func == $search_func) { $selected= "selected ";}
        print "<option value=\"$func\" $selected>$name";
    }
	?>
</select>
<input type="text" name="action_search_value" value="<?= $search_value ?>">
<input type="button" value="Search" onClick="do_search()" />
<input type="button" value="All" onClick="clear_search()"/>
<!-- SEARCH FUNCTION END -->
<br/>
<!-- PAGE COUNT BEGIN -->
<?= $n_actions ?> <?php if ($is_search) { print "(of " . $total_actions . ") "; } ?>
actions (<select name="limit_count_list" onChange="change_limit_count()">
		 <?php
		 // drop down list 10, 25, 50, 100, 200
		 $limit_counts= array( 10, 25, 50, 100, 200 );
		 foreach( $limit_counts as $count ) {
		 $selected= "";
		 if ($count == $limit_count) $selected= "selected ";
		 print "<option value=\"$count\" $selected>$count";
		 }
		 ?>
		 </select>
		 actions/page on <?= $n_pages ?> pages)<br>
<!-- PAGE COUNT END -->
</form>






<?php
	if ($n_pages > 1) {
		// show << | 1 | 2 | ... | n | >> control
		if ($page_n > 1) { 
			print "<a href=\"javascript:prev_page()\" title=\"Previous Page\">&lt;&lt;</a> ";
		}
		else {
			print "&lt;&lt; ";
		}
		foreach( range(1,$n_pages) as $page ) {
			if ($page == $page_n) {
				print "| <b>$page</b> ";
			}
			else {
				print "| <a href=\"javascript:goto_page($page)\" title=\"Go to Page $page\">$page</a> ";
			}
		}
		if ($page_n < $n_pages ) {
			print "| <a href=\"javascript:next_page()\" title=\"Next Page\">&gt;&gt;</a>";
		}
		else {
			print "| &gt;&gt;";
		}
	}
	?>
<p/>

<table width="95%" border="0" cellspacing="0" class="data-table">

<tr>
<th class="data" valign="top"><a href="javascript:orderby('action_name')" title="Sort by Action Name">
<?php if ($orderby == 'action_name') print "<i>Action Name</i>";
	else print "Action Name"; ?>
</a> 
</th>
<th class="data"><a href="javascript:orderby('action_title')" title="Sort by Action Title">
<?php if ($orderby == 'action_title') print "<i>Action Title</i>";
	else print "Action Title"; ?>
</a> 
</th>
<th class="data"><a href="javascript:orderby('date_created')" title="Sort by Creation Date">
<?php if ($orderby == 'date_created') print "<i>Creation</i>";
	else print "Creation"; ?></a></th>
<th class="data"><a href="javascript:orderby('date_modified')" title="Sort by <i>Modification Date">
<?php if ($orderby == 'date_modified') print "<i>Modified</i>";
	else print "Modified"; ?></a></th>
<th class="data last">Actions</th>
</tr>  

<?php
	$actions_attrs= Action::getActionsAttributes($search_field, $search_sql_value, $orderby, $limit_offset, $limit_count);
	$i = 0;
	foreach($actions_attrs as $action_attrs):
	$action_id= $action_attrs['action_id'];
	$action_name= $action_attrs['action_name'];
	$action= Action::reconstituteById($action_id);
	$action_title= $action_attrs['action_title'];
	$date_created= $action_attrs['date_created'];
	$date_modified= $action_attrs['date_modified'];
	$style= ($i++ % 2 == 0) ? "data-even" : "data-odd";
	?>

<tr>
<td valign="top" class="<?= $style ?>">
<?= $action_name ?>
</td>
<td valign="top" class="<?= $style ?>">
<?= $action_title ?>
</td>
<td valign="top" class="<?= $style ?>">
<?= Formatting::formatMysqlDate($date_created,false) ?>
</td>
<td valign="top" class="<?= $style ?>">
<?= Formatting::formatMysqlDate($date_modified,false) ?>
</td>
<td valign="top" align="center" class="<?= $style ?> last">
<a href="edit-action.php?aid=<?= $action_id ?>" title="Edit Action">Edit</a>
| <a href="javascript:delete_action(<?= $action_id ?>)" title="Delete Action">Delete</a>
</td>
</tr>   

<?php endforeach; ?>


</table>

<p/>

<?php
	if ($n_pages > 1) {
		// show << | 1 | 2 | ... | n | >> control
		if ($page_n > 1) { 
			print "<a href=\"javascript:prev_page()\" title=\"Previous Page\">&lt;&lt;</a> ";
		}
		else {
			print "&lt;&lt; ";
		}
		foreach( range(1,$n_pages) as $page ) {
			if ($page == $page_n) {
				print "| <b>$page</b> ";
			}
			else {
				print "| <a href=\"javascript:goto_page($page)\" title=\"Go to Page $page\">$page</a> ";
			}
		}
		if ($page_n < $n_pages ) {
			print "| <a href=\"javascript:next_page()\" title=\"Next Page\">&gt;&gt;</a>";
		}
		else {
			print "| &gt;&gt;";
		}
	}
	?>
<p/>



<?php
	// include common page footer
	//
	include("include/adminFooter.inc");
	?>
