<?php
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 *
 * Copyright (C) 2003  Swiss Virtual Campus (http://www.swissvirtualcampus.ch) 
 * Copyright (C) 2004-2005 SWITCH (http://www.switch.ch)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *
 * $Id: list-all-roles.php,v 1.56 2007/10/15 12:48:42 vlry Exp $
 */

/**
* Displays a list of all available roles.
*
* 
* @version $Revision: 1.56 $
* @package AdminPortal
*/

// bootstrap application
//
require_once("include/application.inc");

//
// resume the current session and make sure we have a valid session
//
Session::ensureAdminSessionValid();

$uid= Session::getUID();
$admin=& Administrator::reconstituteByUid($uid);
if (is_null($admin)) {
   ErrorHandling::fatalErrorAndExit("current user is not priviledged to enter this page"); 
}
Session::init($admin);

// search params
$search_field= 'role_title'; // default: Title
$search_func= 2; // default: starts with
if (Session::exists('role_search_field')) {
    $search_field= Session::get('role_search_field');
}
if (isset($_REQUEST['role_search_field'])) {
    $search_field= $_REQUEST['role_search_field'];
    Session::set('role_search_field', $search_field);
}
if (Session::exists('role_search_func')) {
    $search_func= Session::get('role_search_func');
}
if (isset($_REQUEST['role_search_func'])) {
    $search_func= $_REQUEST['role_search_func'];
    Session::set('role_search_func', $search_func);
}
//XXX
//print "XXX:search_field= $search_field<br>";
//print "XXX:search_func= $search_func<br>";

$search_value= null;
$search_sql_value= null;
$is_search= false;
if (isset($_REQUEST['role_search_value']) and !empty($_REQUEST['role_search_value'])) {
    //XXX print "XXX:search_value= {$_REQUEST['search_value']}<br>";
    $search_value= trim($_REQUEST['role_search_value']);
    $is_search= true;
    switch ($search_func) {
        case 1: $search_sql_value= $search_value; break; // is
        case 2: $search_sql_value= "$search_value%"; break; // starts with
        case 3: $search_sql_value= "%$search_value"; break; // ends with
        case 4: $search_sql_value= "%$search_value%"; break; // contains
        default: $search_sql_value= "%$search_value%"; break;
    }
}

// orderby in request?
$orderby= 'role_title'; // default sorting
if (Session::exists('role_order_by')) {
    $orderby= Session::get('role_order_by');
}
if (isset($_REQUEST['order_by'])) {
    $orderby= $_REQUEST['order_by'];
    Session::set('role_order_by', $orderby);
}
//XXX
//print "orderby: $orderby<br>";

// limit offset, count
$limit_offset= 0;
if (isset($_REQUEST['limit_offset'])) {
    $limit_offset= $_REQUEST['limit_offset'];
}
$limit_count= 100; // default 100 roles/page
if (Session::exists('limit_count')) {
    $limit_count= Session::get('limit_count');
}
if (isset($_REQUEST['limit_count'])) {
    $limit_count= $_REQUEST['limit_count'];
    Session::set('limit_count', $limit_count);
}
//XXX
//print "limit_offset: $limit_offset<br>";
//print "limit_count: $limit_count<br>";

$n_roles= Role::getRolesCount($search_field,$search_sql_value);
if ($is_search) {
    $total_roles= Role::getRolesCount();
}
$n_pages= ceil( $n_roles / $limit_count );
$page_n= ($limit_offset / $limit_count ) + 1;


/* ****************************************************************** */
/*                     page content                                   */
/* ****************************************************************** */
include("include/adminHeader.inc");
?>

<script language="JavaScript">
<!--
function delete_role(rid) {
  if (confirm("Do you really want to delete this role ?")) {
     window.open(
       "<?= PORTAL_BASE_URL ?>/admin/delete-role.php?" 
       + "rid=" + rid 
       + "&url=<?= PORTAL_BASE_URL ?>/admin/list-all-roles.php"
       
       , "_self"
     ); 
  }
}

function orderby(attr_name) {
    document.form_controller.order_by.value= attr_name;
    document.form_controller.submit();
}

function change_limit_count() {
    var lcount= parseInt(document.form_controller.limit_count_list.value);
    document.form_controller.limit_count.value= lcount;
    document.form_controller.limit_offset.value= 0;
    document.form_controller.submit();
}


function goto_page( page_n ) {
    var lcount= parseInt(document.form_controller.limit_count.value);
    document.form_controller.limit_offset.value= lcount * ( page_n - 1 );
    document.form_controller.submit();
}

function prev_page() {
    var loffset= parseInt(document.form_controller.limit_offset.value);
    var lcount= parseInt(document.form_controller.limit_count.value);
    document.form_controller.limit_offset.value= loffset - lcount;
    document.form_controller.submit();
}
function next_page() {
    var loffset= parseInt(document.form_controller.limit_offset.value);
    var lcount= parseInt(document.form_controller.limit_count.value);
    document.form_controller.limit_offset.value= loffset + lcount;
    document.form_controller.submit();
}

function do_search() {
    document.form_controller.limit_offset.value= 0;
    document.form_controller.submit();
}

function clear_search() {
    document.form_controller.role_search_value.value= "";
    document.form_controller.limit_offset.value= 0;
    document.form_controller.submit();
}
// -->
</script>

<h1>All Roles
<?php if ($is_search): ?>
 (Filtered Result)
<?php endif; ?>
</h1>
  
<form name="form_controller" action="<?= $_SERVER['PHP_SELF'] ?>" method="POST">
  <input type="hidden" name="order_by" value="<?= $orderby ?>" />
  <input type="hidden" name="limit_offset" value="<?= $limit_offset ?>" />
  <input type="hidden" name="limit_count" value="<?= $limit_count ?>" />
<!-- SEARCH FUNCTION BEGIN -->
Show roles where <select name="role_search_field">
<?php
    $search_fields= array('role_title' => 'Role Title', 'role_key' => 'Role Key');
    foreach($search_fields as $field => $name) {
        $selected= "";
        if ($field == $search_field) { $selected= "selected ";}
        print "<option value=\"$field\" $selected>$name";
    }
?>
  </select>
  <select name="role_search_func">
<?php
    $search_funcs= array(1 => 'is', 2 => 'starts with', 3 => 'ends with', 4 => 'contains');
    foreach($search_funcs as $func => $name) {
        $selected= "";
        if ($func == $search_func) { $selected= "selected ";}
        print "<option value=\"$func\" $selected>$name";
    }
?>
  </select>
  <input type="text" name="role_search_value" value="<?= $search_value ?>">
  <input type="button" value="Search" onClick="do_search()" />
  <input type="button" value="All" onClick="clear_search()"/>
<!-- SEARCH FUNCTION END -->
<br/>
<!-- PAGE COUNT BEGIN -->
<?= $n_roles ?> <?php if ($is_search) { print "(of " . $total_roles . ") "; } ?>
roles (<select name="limit_count_list" onChange="change_limit_count()">
<?php
    // drop down list 10, 25, 50, 100, 200
    $limit_counts= array( 10, 25, 50, 100, 200 );
    foreach( $limit_counts as $count ) {
        $selected= "";
        if ($count == $limit_count) $selected= "selected ";
        print "<option value=\"$count\" $selected>$count";
    }
?>
</select>
roles/page on <?= $n_pages ?> pages)<br>
<!-- PAGE COUNT END -->
</form>

 <?php
 if ($n_pages > 1) {
    // show << | 1 | 2 | ... | n | >> control
    if ($page_n > 1) { 
        print "<a href=\"javascript:prev_page()\" title=\"Previous Page\">&lt;&lt;</a> ";
    }
    else {
        print "&lt;&lt; ";
    }
    foreach( range(1,$n_pages) as $page ) {
        if ($page == $page_n) {
            print "| <b>$page</b> ";
        }
        else {
            print "| <a href=\"javascript:goto_page($page)\" title=\"Go to Page $page\">$page</a> ";
        }
    }
    if ($page_n < $n_pages ) {
        print "| <a href=\"javascript:next_page()\" title=\"Next Page\">&gt;&gt;</a>";
    }
    else {
        print "| &gt;&gt;";
    }
 }
 ?>
 <p/>
  
  <table width="95%" border="0" cellspacing="0" class="data-table">

    <tr>
      <th class="data" valign="top"><a href="javascript:orderby('role_title')" title="Sort by Role Title">
      <?php if ($orderby == 'role_title') print "<i>Role Title</i>";
            else print "Role Title"; ?>
      </a> [<a href="javascript:orderby('role_key')" title="Sort by Role Key">
      <?php if ($orderby == 'role_key') print "<i>Role Key</i>";
            else print "Role Key"; ?>
      </a>]</th>
      <th class="data"><a href="javascript:orderby('commonName')" title="Sort by Provider Name">
      <?php if ($orderby == 'commonName') print "<i>Provider Name</i>";
            else print "Provider Name"; ?>
      </a> (<a href="javascript:orderby('privilegeName')" title="Sort by Provider Privilege">
      <?php if ($orderby == 'privilegeName') print "<i>Prilivege</i>";
            else print "Prilivege"; ?>
      </a>)</th>
      <th class="data"><a href="javascript:orderby('date_created')" title="Sort by Creation Date">
      <?php if ($orderby == 'date_created') print "<i>Creation</i>";
            else print "Creation"; ?></a></th>
      <th class="data last">Actions</th>
    </tr>  

   <?php
     $roles_attrs= Role::getRolesAttributes($search_field, $search_sql_value, $orderby, $limit_offset, $limit_count);
     $i = 0;
     foreach($roles_attrs as $role_attrs):
        $role_id= $role_attrs['role_id'];
        $role_key= $role_attrs['role_key'];
        $role= Role::reconstituteById($role_id);
//XXX: invisible roles not shown !?!
//        if (! $admin->canViewRole($role)) {
//         continue;
//        }
        $role_title= $role_attrs['role_title'];
        $prov_name= $role_attrs['commonName'];
        $prov_priv= $role_attrs['privilegeName'];
        $date_created= $role_attrs['date_created'];
        $style= ($i++ % 2 == 0) ? "data-even" : "data-odd";
       ?>
     
      <tr>
        <td valign="top" class="<?= $style ?>">
           <?= $role_title ?> [<?= $role_key ?>]
        </td>
        <td valign="top" class="<?= $style ?>">
           <?= $prov_name ?> (<?= $prov_priv ?>)
        </td>
        <td valign="top" class="<?= $style ?>">
           <?= Formatting::formatMysqlDate($date_created,false) ?>
        </td>
         <td valign="top" align="center" class="<?= $style ?> last">
        <?php if ($admin->canEditRole($role)): ?>
          <a href="edit-role.php?rid=<?= $role_id ?>" title="Edit Role">Edit</a>
          | <a href="copy-role.php?rid=<?= $role_id ?>" title="Duplicate Role">Copy</a>
          | <a href="javascript:delete_role(<?= $role_id ?>)" title="Delete Role">Delete</a>
          | <a href="edit-role-managers.php?rid=<?= $role_id ?>" title="Manage Role Administrators">Admins</a>
        <?php elseif ($admin->canViewRole($role)): ?>
          <a href="show-role.php?rid=<?= $role_id ?>" title="View Role Details">View Details</a>
        <?php else: ?>
          Invisible
        <?php endif; ?>
        </td>
      </tr>   

   <?php endforeach; ?>


   </table>

 <p/>

 <?php
 if ($n_pages > 1) {
    // show << | 1 | 2 | ... | n | >> control
    if ($page_n > 1) { 
        print "<a href=\"javascript:prev_page()\" title=\"Previous Page\">&lt;&lt;</a> ";
    }
    else {
        print "&lt;&lt; ";
    }
    foreach( range(1,$n_pages) as $page ) {
        if ($page == $page_n) {
            print "| <b>$page</b> ";
        }
        else {
            print "| <a href=\"javascript:goto_page($page)\" title=\"Go to Page $page\">$page</a> ";
        }
    }
    if ($page_n < $n_pages ) {
        print "| <a href=\"javascript:next_page()\" title=\"Next Page\">&gt;&gt;</a>";
    }
    else {
        print "| &gt;&gt;";
    }
 }
 ?>
 <p/>



<?php
// include common page footer
//
include("include/adminFooter.inc");
?>
