<?php
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 *
 * Copyright (C) 2003  Swiss Virtual Campus (http://www.swissvirtualcampus.ch)
 * Copyright (C) 2004-2006 SWITCH (http://www.switch.ch)
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 * $Id: index.php,v 1.32 2007/10/12 12:19:24 vlry Exp $
 */

require_once("include/application.inc");
require_once("lookandfeel/current/lf-specific-functions.inc");
?>
<html>
<head>
<title>SNAportal Login</title>
<link rel="stylesheet" href="<?= lf_get_user_style_sheet_url() ?>" type="text/css">

<style type="text/css">
<!--
    /* WISEBEDaai Login pages style */
    a.wisebedaai-link {
        font-family: Verdana, Arial, Helvetica, sans-serif; 
        color: #000000; 
        font-size: 12;
    }
    .wisebedaai-link { 
        font-family: Verdana, Arial, Helvetica, sans-serif; 
        color: #000000; 
        font-size: 12; 
    }
    img.wisebedaai-login-button {
        padding-bottom: 10; 
        padding-top: 12;
    }
    img.non-aai-login-button {
        padding-bottom: 8; 
        padding-top: 40;
    }
    input.non-aai-login-button {
        padding-bottom: 8; 
        padding-top: 12; 
        float: right;
    }
    .fullheight {
      height: 100%; 
      min-height: 100%;
    }
    
    /* boxing styles */
    td.wisebedaai {
      font-family: Verdana, Arial, Helvetica, sans-serif; 
      background: #FFFFFF; 
      color: #000000; 
      font-size: 12;
    }
    td.top-left-x {
        background-image: url('lookandfeel/current/obenlinksx.gif');
        height: 14px;
        width: 14px;
    }
    td.top-middle-x {
        background-image: url('lookandfeel/current/obenmittex.gif');
        height: 14px;
    }
    td.top-right-x {
        background-image: url('lookandfeel/current/obenrechtsx.gif');
        height: 14px;
        width: 14px;
    }
    td.middle-left-x {
        background-image: url('lookandfeel/current/mittelinksx.gif');
        width: 14px;
    }
    td.middle-right-x {
        background-image: url('lookandfeel/current/mitterechtsx.gif');
        width: 14px;
    }
    td.bottom-left-x {
        background-image: url('lookandfeel/current/untenlinksx.gif');
        height: 14px;
        width: 14px;
    }
    td.bottom-middle-x {
        background-image: url('lookandfeel/current/untenmittex.gif');
        height: 14px;
    }
    td.bottom-right-x {
        background-image: url('lookandfeel/current/untenrechtsx.gif');
        height: 14px;
        width: 14px;
    }
-->
</style>

</head>
<body>

<p class="welcome-title" style="padding-top: 1cm; text-align: center;">
Welcome to the SNAportal (<?= SNA_PORTAL_VERSION ?>)
</p>

<div align="center">
<table width="50%" class="data-table">

<tr>
  <th width="33%" class="data">
  <strong>Login as User</strong>
  </td>
</tr>
<tr>
   <td class="data-even" valign="top" align="center" style="padding-top: 0.5cm; padding-bottom: 0.5cm;">

<!-- WISEBEDaai Login -->
  <table class="wisebedaai" border="0" cellpadding="0" cellspacing="0" width="60%">
    <tr>
      <td width="14"><img name="obenlinks" src="lookandfeel/current/obenlinks.gif" width="14" height="14" border="0" alt=""></td>
      <td><img name="obenmitte" src="lookandfeel/current/obenmitte.gif" width="100%" height="14" border="0" alt=""></td>
      <td width="14"><img name="obenrechts" src="lookandfeel/current/obenrechts.gif" width="14" height="14" border="0" alt=""></td>
    </tr>
    <tr>
      <td rowspan="3" class="fullheight"><img name="mittelinks" src="lookandfeel/current/mittelinks.gif" width="14" height="100%" border="0" alt=""></td>
      <td class="wisebedaai"><img src="lookandfeel/current/wisebed-logo.png" height="96"></img></td>
      <td rowspan="3" style="height: 100%"><img name="mitterechts" src="lookandfeel/current/mitterechts.gif" width="14" height="100%" border="0" alt=""></td>
    </tr>
    <tr><td class="wisebedaai" height="30"></td></tr>
    <tr>
      <td valign="top" class="wisebedaai">
        <p><b>Login for WISEBED AAI users</b></p>
        <p>Available to all members of the institutions participating in the <a href="http://www.wisebed.eu/" target="wisebedaai">WISEBED Federation</a>.
    <a href="user/aai/login.php"><img src="lookandfeel/current/button-login.gif" height="24" border="0" alt="login" class="wisebedaai-login-button" align="right"></a></p>
      </td>
    </tr>
    <tr>
      <td><img name="untenlinks" src="lookandfeel/current/untenlinks.gif" width="14" height="14" border="0" alt=""></td>
      <td><img name="untenmitte" src="lookandfeel/current/untenmitte.gif" width="100%" height="14" border="0" alt=""></td>
      <td><img name="untenrechts" src="lookandfeel/current/untenrechts.gif" width="14" height="14" border="0" alt=""></td>
    </tr>
  </table>

  </td>

</tr>
<tr>
  <th width="33%" class="data">
  <a href="admin.php">SNA Administrator Access</a>
  </td>
</tr>

</table>
</div>

</body>
</html>

