<?php
/* ****************************************************************** */
/*
 * SNA-Portal mediates between one or more Authentication and Authorisation
 * Infrastructures and non-AAI-enabled roles.
 * Copyright (C) 2003  Swiss Virtual Campus (http://www.swissvirtualcampus.ch) 
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 *
 * $Id: change-language.php,v 1.5 2005/03/14 11:57:23 vlry Exp $
 */
/* ****************************************************************** */


/**
* This page displays an input form for selecting the current language
* in the SNA-Portal.
*
* <b>Request Parameters</b>
* <ul>
*   <li>_locale=<value>: the new locale to be set
* </ul>
*
*
* @version $Revision: 1.5 $
* @package UserPortal
*/

/**
 */
 

// Headerfile for documentation database
require_once("include/application.inc");

// start session and ensure access restrictions
//
Session::ensureUserSessionValid();
I18N::initLocale();
I18N::loadMessageBundle("user/change-language");

//
// make sure the current user exists
//
$uid= Session::getUID();
$user=& User::reconstituteByUid($uid);
if (is_null($user)) {
    ErrorHandling::fatalErrorAndExit("Could not reconstitute user: $uid");
}

// handling request paramters
//
if (isset($_REQUEST["do_apply"])) {
  if (isset($_REQUEST["_locale"]) && I18N::isSupportedLocale( $_REQUEST["_locale"] )) {
     $locale= $_REQUEST["_locale"];
     $locale= strtolower($locale);
     $user->storeAttribute(ATID_PREFERREDLANGUAGE, $locale); 
     Session::setLocale( $user );
  }
}



// include the common header
//
include("include/header.inc");

?>
  <h1><?= I18N::getMessage("change-language.pagetitle") ?></h1>
 
  <?= I18N::getMessage("change-language.text1") ?>
  
  <form action="change-language.php" method="post">
  <table width="50%" border="0" cellspacing="0" class="form-table">
    <tr>
    <td valign="top" align="center" class="form-head" colspan=2>
      <?= I18N::getMessage("change-language.form1.title") ?>
    </td>    
     </tr>  
    <tr>
	    <td width="30%" valign="top" class="form-label">
              <?= I18N::getMessage("change-language.form1.label1") ?>
              Language
            </td>
	    <td width="70%" valign="top" class="form-entry">
                <select name="_locale" >
                <?php
                   $languages = I18N::getSupportedLocales();
                   foreach($languages as $langid => $langdisplayname): 
                     $selected = (I18N::getLocale() == $langid) ? "SELECTED" : "";
                ?>
                    <option value="<?= $langid ?>" <?= $selected ?> ><?= $langdisplayname ?></option> 
                <?php endforeach; ?>
               </select>


	     </td>
    </tr>
  <tr>
    <td valign="top" align="center" class="form-control" colspan=2>
      <input name="do_apply" type="submit" value="<?= I18N::getMessage("change-language.act.apply") ?>" class="button">
    </td>    
  </tr>    
  </table>
  </form>

<?php
// include the common footer
//
include("include/footer.inc");

?>
